/**
 * # Widget
 * Copyright(c) 2019 Stefano Balietti <ste@nodegame.org>
 * MIT Licensed
 *
 * Prototype of a widget class
 *
 * Prototype methods will be injected in every new widget, if missing.
 *
 * Additional properties can be automatically, depending on configuration.
 *
 * @see Widgets.get
 * @see Widgets.append
 */
(function(e){"use strict";function r(){}function i(e,t,n,r,i){var s;if(!e.constructor[n].hasOwnProperty(t))throw new Error(r+": name not found: "+t);s="undefined"!=typeof e[n][t]?e[n][t]:e.constructor[n][t];if("function"==typeof s){s=s(e,i);if("string"!=typeof s&&s!==!1)throw new TypeError(r+': cb "'+t+'" did not '+"return neither string or false. Found: "+s)}return s}function s(e,n,r,i,s,o){var u,a,f;s||(s=e.constructor[n]),"undefined"==typeof o&&(o={}),u={};if(t.isArray(s)){a=-1,f=s.length;for(;++a<f;)u[s[a]]=e[r](s[a],o)}else for(a in s)s.hasOwnProperty(a)&&(u[a]=e[r](a,o));return u}function o(e,t,n,r,i){var s;if("object"!=typeof t&&"undefined"!=typeof t)throw new TypeError(i+": "+n+" must be object or undefined. Found: "+t);for(s in t)t.hasOwnProperty(s)&&e[r](s,t[s])}function u(e,t,n,r,i){if("undefined"==typeof e.constructor[r][t])throw new TypeError(i+": name not found: "+t);if("string"!=typeof n&&"function"!=typeof n&&!1!==n)throw new TypeError(i+': value for item "'+t+'" must be string, function or false. '+"Found: "+n);e[r][t]=n}var t=e.JSUS,n=e.NDDB;e.Widget=r,r.prototype.init=function(e){},r.prototype.listeners=function(){},r.prototype.append=function(){},r.prototype.getValues=function(e){},r.prototype.setValues=function(e){},r.prototype.reset=function(e){},r.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError(t.funcName(this.constructor)+".highlight: "+"border must be string or undefined. Found: "+e);if(!this.isAppended()||this.isHighlighted())return;this.highlighted=!0,this.bodyDiv.style.border=e||"3px solid red",this.emit("highlighted",e)},r.prototype.unhighlight=function(){if(!this.isHighlighted())return;this.highlighted=!1,this.bodyDiv.style.border="",this.emit("unhighlighted")},r.prototype.isHighlighted=function(){return!!this.highlighted},r.prototype.isDocked=function(){return!!this.docked},r.prototype.collapse=function(){if(!this.panelDiv)return;this.bodyDiv.style.display="none",this.collapsed=!0,this.collapseButton&&(this.collapseButton.src="/images/maximize_small2.png",this.collapseButton.title="Restore"),this.footer&&(this.footer.style.display="none"),this.collapseTarget&&this.collapseTarget.appendChild(this.panelDiv),this.emit("collapsed")},r.prototype.uncollapse=function(){if(!this.panelDiv)return;this.collapseTarget&&this.originalRoot.appendChild(this.panelDiv),this.bodyDiv.style.display="",this.collapsed=!1,this.collapseButton&&(this.collapseButton.src="/images/maximize_small.png",this.collapseButton.title="Minimize"),this.footer&&(this.footer.style.display=""),this.emit("uncollapsed")},r.prototype.isCollapsed=function(){return!!this.collapsed},r.prototype.enable=function(e){if(!this.disabled)return;this.disabled=!1,this.emit("enabled",e)},r.prototype.disable=function(e){if(this.disabled)return;this.disabled=!0,this.emit("disabled",e)},r.prototype.isDisabled=function(){return!!this.disabled},r.prototype.hide=function(){if(!this.panelDiv)return;if(this.hidden)return;this.panelDiv.style.display="none",this.hidden=!0,this.emit("hidden")},r.prototype.show=function(e){this.panelDiv&&this.panelDiv.style.display==="none"&&(this.panelDiv.style.display=e||"",this.hidden=!1,this.emit("shown"))},r.prototype.toggle=function(e){if(!this.panelDiv)return;this.hidden?this.show():this.hide()},r.prototype.isHidden=function(){return!!this.hidden},r.prototype.destroy=null,r.prototype.setTitle=function(e,n){var r;if(!this.panelDiv)throw new Error("Widget.setTitle: panelDiv is missing.");if(!e)this.headingDiv&&(this.panelDiv.removeChild(this.headingDiv),this.headingDiv=null);else{if(!this.headingDiv){if(!n)n={className:"panel-heading"};else if("object"!=typeof n)throw new TypeError("Widget.setTitle: options must be object or undefined. Found: "+n);this.headingDiv=W.add("div",this.panelDiv,n),r=this.bodyDiv&&this.bodyDiv.childNodes[0]||null,this.panelDiv.insertBefore(this.headingDiv,r)}if(W.isElement(e))this.headingDiv.innerHTML="",this.headingDiv.appendChild(e);else{if("string"!=typeof e)throw new TypeError(t.funcName(this.constructor)+".setTitle: title must be string, "+"HTML element or falsy. Found: "+e);this.headingDiv.innerHTML=e}this.collapsible&&function(e){var t,n;t=document.createElement("span"),t.className="panel-collapse-link",n=document.createElement("img"),n.src="/images/minimize_small.png",t.appendChild(n),t.onclick=function(){e.isCollapsed()?e.uncollapse():e.collapse()},e.headingDiv.appendChild(t)}(this),this.closable&&function(e){var t,n;t=document.createElement("span"),t.className="panel-collapse-link",n=document.createElement("img"),n.src="/images/close_small.png",t.appendChild(n),t.onclick=function(){e.destroy()},e.headingDiv.appendChild(t)}(this)}},r.prototype.setFooter=function(e,n){if(!this.panelDiv)throw new Error("Widget.setFooter: panelDiv is missing.");if(!e)this.footerDiv&&(this.panelDiv.removeChild(this.footerDiv),delete this.footerDiv);else{if(!this.footerDiv){if(!n)n={className:"panel-footer"};else if("object"!=typeof n)throw new TypeError("Widget.setFooter: options must be object or undefined. Found: "+n);this.footerDiv=W.add("div",this.panelDiv,n)}if(W.isElement(e))this.footerDiv.innerHTML="",this.footerDiv.appendChild(e);else{if("string"!=typeof e)throw new TypeError(t.funcName(this.constructor)+".setFooter: footer must be string, "+"HTML element or falsy. Found: "+title);this.footerDiv.innerHTML=e}}},r.prototype.setContext=function(e){if("string"!=typeof e)throw new TypeError(t.funcName(this.constructor)+".setContext: "+"context must be string. Found: "+e);W.removeClass(this.panelDiv,"panel-[a-z]*"),W.addClass(this.panelDiv,"panel-"+e)},r.prototype.addFrame=function(e){if("undefined"==typeof e)e="default";else if("string"!=typeof e||e.trim()==="")throw new TypeError(t.funcName(this.constructor)+".addFrame: context must be a non-empty "+"string or undefined. Found: "+e);this.panelDiv&&this.panelDiv.className.indexOf("panel-")===-1&&W.addClass(this.panelDiv,"panel-"+e),this.bodyDiv&&this.bodyDiv.className.indexOf("panel-body")===-1&&W.addClass(this.bodyDiv,"panel-body")},r.prototype.removeFrame=function(){this.panelDiv&&W.removeClass(this.panelDiv,"panel-[a-z]*"),this.bodyDiv&&W.removeClass(this.bodyDiv,"panel-body")},r.prototype.isAppended=function(){return!!this.panelDiv},r.prototype.isDestroyed=function(){return!!this.destroyed},r.prototype.setSound=function(e,t){u(this,e,t,"sounds","Widget.setSound")},r.prototype.setSounds=function(e){o(this,e,"sounds","setSound",t.funcName(this.constructor)+".setSounds")},r.prototype.getSound=function(e,n){return i(this,e,"sounds",t.funcName(this.constructor)+".getSound",n)},r.prototype.getSounds=function(e,n){return s(this,"sounds","getSound",t.funcName(this.constructor)+".getSounds",e,n)},r.prototype.getAllSounds=function(e){return s(this,"sounds","getSound",t.funcName(this.constructor)+".getAllSounds",undefined,e)},r.prototype.setText=function(e,n){u(this,e,n,"texts",t.funcName(this.constructor)+".setText")},r.prototype.setTexts=function(e){o(this,e,"texts","setText",t.funcName(this.constructor)+".setTexts")},r.prototype.getText=function(e,n){return i(this,e,"texts",t.funcName(this.constructor)+".getText",n)},r.prototype.getTexts=function(e,n){return s(this,"texts","getText",t.funcName(this.constructor)+".getTexts",e,n)},r.prototype.getAllTexts=function(e){return s(this,"texts","getText",t.funcName(this.constructor)+".getAllTexts",undefined,e)},r.prototype.on=function(){n.prototype.on.apply(this,arguments)},r.prototype.off=function(){n.prototype.off.apply(this,arguments)},r.prototype.emit=function(){n.prototype.emit.apply(this,arguments)},r.prototype.throwErr=function(e,n,r){var i;throw i=t.funcName(this.constructor)+"."+n+": ","object"==typeof r?i+=r.stack||r:"string"==typeof r&&(i+=r),e==="TypeError"?new TypeError(i):new Error(i)}})("undefined"!=typeof node?node:module.parent.exports.node),function(e,t){"use strict";function r(){var e;this.widgets={},this.instances=[],this.lastAppended=null,this.docked=[],this.dockedHidden=[],this.boxSelector=null,this.collapseTarget=null,e=this,t.registerSetup("widgets",function(n){var r,i,s;if(!n)return;if(n.widgets)for(r in n.widgets)n.widgets.hasOwnProperty(r)&&e.register(r,n.widgets[r]);n.destroyAll&&e.destroyAll();if(n.append)for(r in n.append)n.append.hasOwnProperty(r)&&(i=n.append[r].root,"function"==typeof i?i=i():"string"==typeof i&&(i=W.getElementById(i)),i||(i=W.getScreen()),i?e.append(r,i,n.append[r]):t.warn("setup widgets: could not find a root for widget "+r+". Requested: "+n.append[r].root));return n.collapseTarget&&("function"==typeof n.collapseTarget?s=n.collapseTarget():"string"==typeof n.collapseTarget?s=W.getElementById(n.collapseTarget):J.isElement(n.collapseTarget)&&(s=n.collapseTarget),s?e.collapseTarget=s:t.warn("setup widgets: could not find collapse target.")),n}),t.on("FRAME_LOADED",function(){t.widgets.garbageCollection()}),t.info("node-widgets: loading")}function i(e,n){var r=e.name||e.id;t.err(n+" not found. "+r+" cannot be loaded")}function s(e,n){var r,i,s,a,f;r=t.widgets.docked,s=r.length;for(i=0;i<s;i++)a?r[i].panelDiv.style.right=u(r[i].panelDiv.style.right)-a+"px":r[i].wid===e&&(a=r[i].dockedOffsetWidth,f=t.widgets.docked.splice(i,1)[0],n&&(t.widgets.dockedHidden.push(f),f.hide(),t.widgets.boxSelector||(t.widgets.boxSelector=t.widgets.append("BoxSelector",document.body,{className:"docked-left",getId:function(e){return e.wid},getDescr:function(e){return e.title},onclick:function(e,n){e.show(),t.widgets.docked.push(e),o(e),this.removeItem(n),this.items.length===0&&(this.destroy(),t.widgets.boxSelector=null)}})),t.widgets.boxSelector.addItem(f)),s--,i--);return!!a}function o(n){var r,i,o,a,f,l;i=200,r=20,f=t.widgets,a=0,f.docked.length>1&&(o=f.docked[f.docked.length-2],a=u(o.panelDiv.style.right),a+=o.panelDiv.offsetWidth),a+=r,n.panelDiv.style.right=a+"px",l=0,a+=n.panelDiv.offsetWidth+i;while(f.docked.length>1&&a>e.innerWidth&&l<f.docked.length-1)s(f.docked[l].wid,!0),l++;n.dockedOffsetWidth=n.panelDiv.offsetWidth+r}function u(e){return parseInt(e.substring(0,e.length-2),10)}var n=e.NDDB;r.prototype.register=function(e,n){if("string"!=typeof e)throw new TypeError("Widgets.register: name must be string. Found: "+e);if("function"!=typeof n)throw new TypeError("Widgets.register: w must be function.Found: "+n);return"undefined"==typeof n.sounds&&(n.sounds={}),"undefined"==typeof n.texts&&(n.texts={}),J.mixout(n.prototype,new t.Widget),this.widgets[e]=n,this.widgets[e]},r.prototype.get=function(e,n){var r,i,o,u;if("string"!=typeof e)throw new TypeError("Widgets.get: widgetName must be string.Found: "+e);if(!n)n={};else if("object"!=typeof n)throw new TypeError("Widgets.get: "+e+" options "+"must be object or undefined. Found: "+n);if(n.storeRef===!1&&n.docked===!0)throw new TypeError("Widgets.get: "+e+"options.storeRef cannot be false "+"if options.docked is true.");r=this,i=J.getNestedValue(e,this.widgets);if(!i)throw new Error("Widgets.get: "+e+" not found");t.info("creating widget "+e+" v."+i.version);if(!this.checkDependencies(i))throw new Error("Widgets.get: "+e+" has unmet "+"dependencies");o=new i(n);if("undefined"!=typeof n.id){"number"==typeof n.id&&(n.id=""+n.id);if("string"!=typeof n.id)throw new TypeError("Widgets.get: options.id must be string, number or undefined. Found: "+n.id);o.id=n.id}o.title="undefined"==typeof n.title?i.title:n.title,o.panel="undefined"==typeof n.panel?i.panel:n.panel,o.footer="undefined"==typeof n.footer?i.footer:n.footer,o.className=i.className;if(J.isArray(n.className))o.className+=" "+n.className.join(" ");else if("string"==typeof n.className)o.className+=" "+n.className;else if("undefined"!=typeof n.className)throw new TypeError("Widgets.get: className must be array, string, or undefined. Found: "+n.className);return o.context="undefined"==typeof n.context?i.context:n.context,o.sounds="undefined"==typeof n.sounds?i.sounds:n.sounds,o.texts="undefined"==typeof n.texts?i.texts:n.texts,o.collapsible=n.collapsible||!1,o.closable=n.closable||!1,o.collapseTarget=n.collapseTarget||this.collapseTarget||null,o.hooks={hidden:[],shown:[],collapsed:[],uncollapsed:[],disabled:[],enabled:[],destroyed:[],highlighted:[],unhighlighted:[]},o.widgetName=e,o.wid=""+J.randomInt(0,1e19),o.disabled=null,o.highlighted=null,o.collapsed=null,o.hidden=null,o.docked=null,n.disabled&&(o._disabled=!0),n.highlighted&&(o._highlighted=!0),n.collapsed&&(o._collapsed=!0),n.hidden&&(o._hidden=!0),n.docked&&(o._docked=!0),o.init(n),n.listeners!==!1&&(t.events.setRecordChanges(!0),o.listeners.call(o),u=t.events.getChanges(!0),t.events.setRecordChanges(!1)),o.destroy=function(){var n,r,i,a;(function(){try{o.panelDiv&&o.panelDiv.parentNode&&o.panelDiv.parentNode.removeChild(o.panelDiv)}catch(n){t.warn(e+".destroy: error caught: "+n)}})();if(u)for(a in u)if(u.hasOwnProperty(a)){i=u[a],n=-1,r=i.added.length;for(;++n<r;)t.events.ee[a].off(i.added[n].type,i.added[n].listener);n=-1,r=u[a].removed.length;for(;++n<r;)t.events.ee[a].on(i.removed[n].type,i.removed[n].listener)}if(o.storeRef!==!1){n=-1,r=t.widgets.instances.length;for(;++n<r;)if(t.widgets.instances[n].wid===o.wid){t.widgets.instances.splice(n,1);break}t.widgets.lastAppended&&t.widgets.lastAppended.wid===this.wid&&(t.warn("node.widgets.lastAppended destroyed."),t.widgets.lastAppended=null)}this.docked?s(o.wid,!1):t.window&&t.window.adjustFrameHeight(undefined,120),this.destroyed=!0,this.emit("destroyed")},n.storeRef!==!1?this.instances.push(o):o.storeRef=!1,o},r.prototype.append=function(e,t,n){var r,i,s,u;if("string"!=typeof e&&"object"!=typeof e)throw new TypeError("Widgets.append: w must be string or object. Found: "+e);if(!t)t=W.getFrameDocument(),t&&(t=t.body),t||(t=document.body);else if("string"==typeof t){r=W.gid(t);if(!r)throw new Error('Widgets.append: element with id "'+t+'" not found');t=r}if(!J.isElement(t))throw new TypeError("Widgets.append: root must be HTMLElement, string or undefined. Found: "+t);if(n&&"object"!=typeof n)throw new TypeError("Widgets.append: options must be object or undefined. Found: "+n);n=n||{},"undefined"==typeof n.panel&&t===W.getHeader()&&(n.panel=!1),"string"==typeof e&&(e=this.get(e,n)),r=n.panel===!1?!0:e.panel===!1,r={className:r?["ng_widget","no-panel",e.className]:["ng_widget","panel","panel-default",e.className]};if(n.docked||e._docked)r.className.push("docked"),this.docked.push(e),e.docked=!0;return e.panelDiv=W.get("div",r),n.title!==!1&&e.title&&(r=n.panel===!1?"no-panel-heading":"panel-heading",e.setTitle(e.title,{className:r})),r=n.panel!==!1?"panel-body":"no-panel-body",e.bodyDiv=W.append("div",e.panelDiv,{className:r}),e.footer&&(r=n.panel===!1?"no-panel-heading":"panel-heading",e.setFooter(e.footer)),e.context&&e.setContext(e.context),(n.hidden||e._hidden)&&e.hide(),(n.collapsed||e._collapsed)&&e.collapse(),(n.disabled||e._disabled)&&e.disable(),(n.highlighted||e._highlighted)&&e.highlight(),t.appendChild(e.panelDiv),e.originalRoot=t,e.append(),e.docked&&o(e),e.storeRef!==!1&&(this.lastAppended=e),e},r.prototype.add=function(e,t,n){return console.log("***Widgets.add is deprecated. Use Widgets.append instead.***"),this.append(e,t,n)},r.prototype.isWidget=function(e,n){return n?e instanceof t.Widget:"object"==typeof e&&"function"==typeof e.append&&"function"==typeof e.getValues},r.prototype.destroyAll=function(){var e,n;e=-1,n=this.instances.length;for(;++e<n;)this.instances[0].destroy();this.lastAppended=null,this.instances.length&&t.warn("node.widgets.destroyAll: some widgets could not be destroyed.")},r.prototype.checkDependencies=function(n,r){var s,o,u,a,f;if(!n.dependencies)return!0;s=[e,t,this.widgets,t.window],o=n.dependencies;for(u in o)if(o.hasOwnProperty(u)){a=!1;for(f=0;f<s.length;f++)if(J.getNestedValue(u,s[f])){a=!0;break}if(!a)return r||i(n,u),!1}return!0},r.prototype.garbageCollection=function(){var e,n,r,i;i=[],r=W.getFrameDocument(),e=t.widgets.instances;for(n=0;n<e.length;n++)e[n].isAppended()&&r&&!r.contains(e[n].panelDiv)&&!document.body.contains(e[n].panelDiv)&&(i.push(e[n]),e[n].destroy(),n--);return i},t.widgets=new r}("undefined"!=typeof window?window:module.parent.exports.window,"undefined"!=typeof window?window.node:module.parent.exports.node),function(e){"use strict";function t(t){var r;r=this;if("object"==typeof t.button)this.button=t.button;else{if("undefined"!=typeof t.button)throw new TypeError("BackButton constructor: options.button must be object or undefined. Found: "+t.button);this.button=document.createElement("input"),this.button.type="button"}this.acrossStages=null,this.acrossRounds=null,this.button.onclick=function(){var t;t=n(r);if(!t)return;t=e.game.gotoStep(t),t&&r.disable()}}function n(t){var n,r;n=e.game.getCurrentGameStage();if(n.stage===0)return;r=e.game.getPreviousStep();if(r.stage===0)return;return n.stage>r.stage&&!t.acrossStages?!1:n.round>r.round&&!t.acrossRounds?!1:r}e.widgets.register("BackButton",t),t.version="0.1.0",t.description="Creates a button that if pressed goes to the previous step.",t.title=!1,t.className="backbutton",t.texts.back="Back",t.dependencies={JSUS:{}},t.prototype.init=function(e){var n;e=e||{};if("undefined"==typeof e.id)n=t.className;else if("string"==typeof e.id)n=e.id;else{if(!1!==e.id)throw new TypeError("BackButton.init: options.id must be string, false, or undefined. Found: "+e.id);n=""}this.button.id=n;if("undefined"==typeof e.className)n="btn btn-lg btn-secondary";else if(e.className===!1)n="";else if("string"==typeof e.className)n=e.className;else{if(!J.isArray(e.className))throw new TypeError("BackButton.init: options.className must be string, array, or undefined. Found: "+e.className);n=e.className.join(" ")}this.button.className=n,this.button.value="string"==typeof e.text?e.text:this.getText("back"),this.acrossStages="undefined"==typeof e.acrossStages?!1:!!e.acrossStages,this.acrossRounds="undefined"==typeof e.acrossRounds?!0:!!e.acrossRounds},t.prototype.append=function(){this.bodyDiv.appendChild(this.button)},t.prototype.listeners=function(){var t=this;e.on("PLAYING",function(){var r,i;i=n(t),i&&t.enable(),r=e.game.getProperty("backbutton"),(!i||r===!1||r&&r.enableOnPlaying===!1)&&t.disable(),"string"==typeof r?t.button.value=r:r&&r.text&&(t.button.value=r.text)})},t.prototype.disable=function(){this.button.disabled="disabled"},t.prototype.enable=function(){this.button.disabled=!1}}(node),function(e){"use strict";function n(){this.button=null,this.buttonText="",this.items=[],this.onclick=null,this.getDescr=null,this.getId=function(e){return e.id},this.ul=null}var t=e.NDDB;e.widgets.register("BoxSelector",n),n.version="1.0.0",n.description="Creates a simple box that opens a menu of items to choose from.",n.panel=!1,n.title=!1,n.className="boxselector",n.dependencies={JSUS:{}},n.prototype.init=function(e){if(e.onclick){if("function"!=typeof e.onclick)throw new Error("BoxSelector.init: options.getId must be function or undefined. Found: "+e.getId);this.onclick=e.onclick}if("function"!=typeof e.getDescr)throw new Error("BoxSelector.init: options.getDescr must be function. Found: "+e.getDescr);this.getDescr=e.getDescr;if(e.getId&&"function"!=typeof e.getId)throw new Error("BoxSelector.init: options.getId must be function or undefined. Found: "+e.getId);this.getId=e.getId},n.prototype.append=function(){var e,t,n,r,i;r=W.add("div",this.bodyDiv),r.role="group",r["aria-label"]="Select Items",r.className="btn-group dropup",n=this.button=W.add("button",r),n.className="btn btn-default btn dropdown-toggle",n["data-toggle"]="dropdown",n["aria-haspopup"]="true",n["aria-expanded"]="false",n.innerHTML=this.buttonText+"&nbsp;",W.add("span",n,{className:"caret"}),t=this.ul=W.add("ul",r),t.className="dropdown-menu",t.style.display="none",i=!1,n.onclick=function(){i?(t.style.display="none",i=!1):(t.style.display="block",i=!0)},this.onclick&&(e=this,t.onclick=function(n){var r,s,o;r=n.target,t.style.display="",i=!1,r=r.parentNode.id,r||(r=n.target.parentNode.parentNode.id);if(!r)return;o=e.items.length;for(s=0;s<o;s++)if(e.getId(e.items[s])===r){e.onclick.call(e,e.items[s],r);break}})},n.prototype.addItem=function(e){var t,n,r,i;t=this.ul,n=document.createElement("li"),i=this.getDescr(e);if(!i||"string"!=typeof i)throw new Error("BoxSelector.addItem: getDescr did not return a string. Found: "+i+". Item: "+e);this.onclick?(r=document.createElement("a"),r.href="#",r.innerHTML=i,n.appendChild(r)):n.innerHTML=i,i=this.getId(e);if(!i||"string"!=typeof i)throw new Error("BoxSelector.addItem: getId did not return a string. Found: "+i+". Item: "+e);n.id=i,n.className="dropdown-header",t.appendChild(n),this.items.push(e)},n.prototype.removeItem=function(e){var t,n,r;n=this.items.length;for(t=0;t<n;t++)if(this.getId(this.items[t])===e)return r=W.gid(e),this.ul.removeChild(r),this.items.splice(t,1);return!1},n.prototype.getValues=function(){return this.items}}(node),function(e){"use strict";function n(){this.chatEvent=null,this.stats={received:0,sent:0,unread:0},this.submitButton=null,this.useSubmitButton=null,this.receiverOnly=!1,this.storeMsgs=!1,this.db=null,this.chatDiv=null,this.textarea=null,this.initialMsg=null,this.recipientsIds=null,this.recipientsIdsQuitted=null,this.senderToNameMap=null,this.recipientToNameMap=null,this.senderToRecipientMap=null,this.recipientToSenderMap=null}function r(t){var n,r,i;if(t.isDisabled())return;n=t.readTextarea();if(n===""){e.warn("Chat: message has no text, not sent.");return}i=t.recipientsIds;if(i.length===0){e.warn("Chat: empty recipient list, message not sent.");return}r=i.length===1?i[0]:i,t.writeMsg("outgoing",{msg:n}),e.say(t.chatEvent,r,n),setTimeout(function(){t.textarea.value=""})}var t=e.NDDB;e.widgets.register("Chat",n),n.texts={outgoing:function(e,t){return t.msg},incoming:function(e,t){var n;return n="<span>",e.recipientsIds.length>1&&(n+='<span class="chat_id_other">'+(e.senderToNameMap[t.id]||t.id)+"</span>: "),n+=t.msg+"</span>",n},quit:function(e,t){return(e.senderToNameMap[t.id]||t.id)+" left the chat"},noMoreParticipants:function(e,t){return"No active participant left. Chat disabled."},collapse:function(e,t){return(e.senderToNameMap[t.id]||t.id)+" "+(t.collapsed?"mini":"maxi")+"mized the chat"},textareaPlaceholder:function(e){return e.useSubmitButton?"Type something":"Type something and press enter to send"},submitButton:"Send"},n.version="1.0.0",n.description="Offers a uni-/bi-directional communication interface between players, or between players and the server.",n.title="Chat",n.className="chat",n.panel=!1,n.dependencies={JSUS:{}},n.prototype.init=function(n){var r,i,s,o,u;u=this,r=n.chatEvent;if(r){if("string"!=typeof r)throw new TypeError("Chat.init: chatEvent must be a non-empty string or undefined. Found: "+r);this.chatEvent=n.chatEvent}else this.chatEvent="CHAT";this.storeMsgs=!!n.storeMsgs,this.storeMsgs&&(this.db||(this.db=new t)),this.useSubmitButton="undefined"==typeof n.useSubmitButton?J.isMobileAgent():!!n.useSubmitButton,r=n.participants;if(!J.isArray(r)||!r.length)throw new TypeError("Chat.init: participants must be a non-empty array. Found: "+r);this.recipientsIds=new Array(r.length),this.recipientsIdsQuitted=[],this.recipientToSenderMap={},this.recipientToNameMap={},this.senderToNameMap={},this.senderToRecipientMap={};for(i=0;i<r.length;i++)if("string"==typeof r[i])this.recipientsIds[i]=r[i],this.recipientToNameMap[r[i]]=r[i],this.recipientToSenderMap[r[i]]=r[i],this.senderToRecipientMap[r[i]]=r[i],this.senderToNameMap[r[i]]=r[i];else{if("object"!=typeof r[i])throw new TypeError("Chat.init: participants array must contain string or object. Found: "+r[i]);s=r[i].recipient,o=r[i].sender,this.recipientsIds[i]=s,this.recipientToSenderMap[s]=o||s,this.recipientToNameMap[s]=r[i].name||s,this.senderToRecipientMap[o]=s,this.senderToNameMap[o]=this.recipientToNameMap[s]}this.uncollapseOnMsg=n.uncollapseOnMsg||!1,this.printStartTime=n.printStartTime||!1,this.printNames=n.printNames||!1;if(n.initialMsg){if("object"!=typeof n.initialMsg)throw new TypeError("Chat.init: initialMsg must be object or undefined. Found: "+n.initialMsg);this.initialMsg=n.initialMsg}this.on("uncollapsed",function(){u.setTitle(u.title),u.recipientsIds.length&&e.say(u.chatEvent+"_COLLAPSE",u.recipientsIds,!1)}),this.on("collapsed",function(){u.recipientsIds.length&&e.say(u.chatEvent+"_COLLAPSE",u.recipientsIds,!0)}),this.on("destroyed",function(){u.recipientsIds.length&&e.say(u.chatEvent+"_QUIT",u.recipientsIds)})},n.prototype.append=function(){var e,t,n;this.chatDiv=W.get("div",{className:"chat_chat"}),this.bodyDiv.appendChild(this.chatDiv),this.receiverOnly||(e=this,t=document.createElement("div"),t.className="chat_inputgroup",this.textarea=W.get("textarea",{className:"chat_textarea form-control",placeholder:this.getText("textareaPlaceholder")}),t.appendChild(this.textarea),this.useSubmitButton?(this.submitButton=W.get("button",{className:"btn-sm btn-info form-control chat_submit",innerHTML:this.getText("submitButton")}),this.submitButton.onclick=function(){r(e)},t.appendChild(this.submitButton)):this.textarea.onkeydown=function(t){t=t||window.event,(t.keyCode||t.which)===13&&r(e)},this.bodyDiv.appendChild(t)),this.printStartTime&&(W.add("div",this.chatDiv,{innerHTML:Date(J.getDate()),className:"chat_event"}),n=!0),this.printNames&&(W.add("div",this.chatDiv,{className:"chat_event",innerHTML:"Participants: "+J.keys(this.senderToNameMap).join(", ")}),n=!0),n&&W.add("div",this.chatDiv,{className:"chat_event",innerHTML:"&nbsp;"}),this.initialMsg&&this.writeMsg(this.initialMsg.id?"incoming":"outgoing",this.initialMsg)},n.prototype.readTextarea=function(){var e;return e=this.textarea.value,this.textarea.value="",e.trim()},n.prototype.writeMsg=function(e,t){var n;n=e==="incoming"||e==="outgoing"?e:"event",W.add("div",this.chatDiv,{innerHTML:this.getText(e,t),className:"chat_msg chat_msg_"+n}),this.chatDiv.scrollTop=this.chatDiv.scrollHeight},n.prototype.listeners=function(){var t=this;e.on.data(this.chatEvent,function(n){if(!t.handleMsg(n))return;t.stats.received++,t.storeMsgs&&t.db.insert({from:n.from,text:n.data,time:e.timer.getTimeSince("step"),timestamp:J.now()}),t.writeMsg("incoming",{msg:n.data,id:n.from})}),e.on.data(this.chatEvent+"_QUIT",function(n){var r,i,s;if(!t.handleMsg(n))return;t.writeMsg("quit",{id:n.from}),i=t.recipientsIds.length;for(r=0;r<i;r++)if(t.recipientsIds[r]===t.senderToRecipientMap[n.from]){s=t.recipientsIds.splice(r,1),t.recipientsIdsQuitted.push(s),t.recipientsIds.length===0&&(t.writeMsg("noMoreParticipants"),t.disable());break}e.warn("Chat: participant quitted not found: "+n.from)}),e.on.data(this.chatEvent+"_COLLAPSE",function(e){if(!t.handleMsg(e))return;t.writeMsg("collapse",{id:e.from,collapsed:e.data})})},n.prototype.handleMsg=function(t){var n,r;return n=t.from,n===e.player.id||n===e.player.sid?(e.warn("Chat: your own message came back: "+t.id),!1):(this.isCollapsed()&&(this.uncollapseOnMsg?(this.uncollapse(),this.stats.unread=0):(this.setTitle("<strong>"+this.title+"</strong>"),this.stats.unread++)),!0)},n.prototype.disable=function(){this.submitButton&&(this.submitButton.disabled=!0),this.textarea.disabled=!0,this.disabled=!0},n.prototype.enable=function(){this.submitButton&&(this.submitButton.disabled=!1),this.textarea.disabled=!1,this.disabled=!1},n.prototype.getValues=function(){var e;return e={participants:this.participants,totSent:this.stats.sent,totReceived:this.stats.received,totUnread:this.stats.unread,initialMsg:this.initialMsg},this.db&&(e.msgs=db.fetch()),e}}(node),function(e){"use strict";function n(e){var t=this;this.options=null,this.table=null,this.sc=null,this.fp=null,this.canvas=null,this.changes=[],this.onChange=null,this.onChangeCb=function(e,n){"undefined"==typeof n&&(n=!1),e||(t.sc?e=t.sc.getValues():e=i.random()),t.draw(e,n)},this.timeFrom="step",this.features=null}function r(e,t){this.canvas=new W.Canvas(e),this.scaleX=e.width/n.width,this.scaleY=e.height/n.heigth,this.face=null}function i(e,t){var n;if("undefined"==typeof e)for(n in i.defaults)i.defaults.hasOwnProperty(n)&&(n==="color"?this.color="red":n==="lineWidth"?this.lineWidth=1:n==="scaleX"?this.scaleX=1:n==="scaleY"?this.scaleY=1:this[n]=i.defaults[n].min+Math.random()*i.defaults[n].range);else{if("object"!=typeof e)throw new TypeError("FaceVector constructor: faceVector must be object or undefined.");this.scaleX=e.scaleX||1,this.scaleY=e.scaleY||1,this.color=e.color||"green",this.lineWidth=e.lineWidth||1,t=t||i.defaults;for(n in t)t.hasOwnProperty(n)&&(e.hasOwnProperty(n)?this[n]=e[n]:this[n]=t?t[n]:i.defaults[n].value)}}var t=W.Table;e.widgets.register("ChernoffFaces",n),n.version="0.6.2",n.description="Display parametric data in the form of a Chernoff Face.",n.title="ChernoffFaces",n.className="chernofffaces",n.dependencies={JSUS:{},Table:{},Canvas:{},SliderControls:{}},n.FaceVector=i,n.FacePainter=r,n.width=100,n.height=100,n.onChange="CF_CHANGE",n.prototype.init=function(t){this.options=t,t.features?this.features=new i(t.features):this.features||(this.features=i.random()),this.fp&&this.fp.draw(this.features),t.onChange===!1||t.onChange===null?this.onChange&&(e.off(this.onChange,this.onChangeCb),this.onChange=null):(this.onChange="undefined"==typeof t.onChange?n.onChange:t.onChange,e.on(this.onChange,this.onChangeCb))},n.prototype.getCanvas=function(){return this.canvas},n.prototype.buildHTML=function(){var n,r,s,o;if(this.table)return;o=this.options,s={},this.id&&(s.id=this.id),"string"==typeof o.className?s.className=o.className:o.className!==!1&&(s.className="cf_table"),this.table=new t(s),this.canvas||this.buildCanvas();if("undefined"==typeof o.controls||o.controls)r=J.mergeOnKey(i.defaults,this.features,"value"),n={id:"cf_controls",features:r,onChange:this.onChange,submit:"Send"},"object"==typeof o.controls?this.sc=o.controls:this.sc=e.widgets.get("SliderControls",n);this.sc?this.table.addRow([{content:this.sc,id:this.id+"_td_controls"},{content:this.canvas,id:this.id+"_td_cf"}]):this.table.add({content:this.canvas,id:this.id+"_td_cf"}),this.table.parse()},n.prototype.buildCanvas=function(){var e;this.canvas||(e=this.options,e.canvas||(e.canvas={},"undefined"!=typeof e.height&&(e.canvas.height=e.height),"undefined"!=typeof e.width&&(e.canvas.width=e.width)),this.canvas=W.getCanvas("ChernoffFaces_canvas",e.canvas),this.fp=new r(this.canvas),this.fp.draw(this.features))},n.prototype.append=function(){this.table||this.buildHTML(),this.bodyDiv.appendChild(this.table.table)},n.prototype.draw=function(t,n){var r;if("object"!=typeof t)throw new TypeError("ChernoffFaces.draw: features must be object.");this.options.trackChanges&&("string"==typeof this.timeFrom?r=e.timer.getTimeSince(this.timeFrom):r=Date.now?Date.now():(new Date).getTime(),this.changes.push({time:r,change:t})),this.features=t instanceof i?t:new i(t,this.features),this.fp.redraw(this.features),this.sc&&n!==!1&&(this.sc.init({features:J.mergeOnKey(i.defaults,t,"value")}),this.sc.refresh())},n.prototype.getValues=function(e){return e&&e.changes?{changes:this.changes,cf:this.features}:this.fp.face},n.prototype.randomize=function(){var e;return e=i.random(),this.fp.redraw(e),this.sc&&(this.sc.init({features:J.mergeOnValue(i.defaults,e),onChange:this.onChange}),this.sc.refresh()),!0},r.prototype.draw=function(e,t,n){if(!e)return;this.face=e,this.fit2Canvas(e),this.canvas.scale(e.scaleX,e.scaleY),t=t||this.canvas.centerX,n=n||this.canvas.centerY,this.drawHead(e,t,n),this.drawEyes(e,t,n),this.drawPupils(e,t,n),this.drawEyebrow(e,t,n),this.drawNose(e,t,n),this.drawMouth(e,t,n)},r.prototype.redraw=function(e,t,n){this.canvas.clear(),this.draw(e,t,n)},r.prototype.scale=function(e,t){this.canvas.scale(this.scaleX,this.scaleY)},r.prototype.fit2Canvas=function(e){var t;if(!this.canvas){console.log("No canvas found");return}this.canvas.width>this.canvas.height?t=this.canvas.width/e.head_radius*e.head_scale_x:t=this.canvas.height/e.head_radius*e.head_scale_y,e.scaleX=t/2,e.scaleY=t/2},r.prototype.drawHead=function(e,t,n){var r=e.head_radius;this.canvas.drawOval({x:t,y:n,radius:r,scale_x:e.head_scale_x,scale_y:e.head_scale_y,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawEyes=function(e,t,n){var i=r.computeFaceOffset(e,e.eye_height,n),s=e.eye_spacing,o=e.eye_radius;this.canvas.drawOval({x:t-s,y:i,radius:o,scale_x:e.eye_scale_x,scale_y:e.eye_scale_y,color:e.color,lineWidth:e.lineWidth}),this.canvas.drawOval({x:t+s,y:i,radius:o,scale_x:e.eye_scale_x,scale_y:e.eye_scale_y,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawPupils=function(e,t,n){var i=e.pupil_radius,s=e.eye_spacing,o=r.computeFaceOffset(e,e.eye_height,n);this.canvas.drawOval({x:t-s,y:o,radius:i,scale_x:e.pupil_scale_x,scale_y:e.pupil_scale_y,color:e.color,lineWidth:e.lineWidth}),this.canvas.drawOval({x:t+s,y:o,radius:i,scale_x:e.pupil_scale_x,scale_y:e.pupil_scale_y,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawEyebrow=function(e,t,n){var i=r.computeEyebrowOffset(e,n),s=e.eyebrow_spacing,o=e.eyebrow_length,u=e.eyebrow_angle;this.canvas.drawLine({x:t-s,y:i,length:o,angle:u,color:e.color,lineWidth:e.lineWidth}),this.canvas.drawLine({x:t+s,y:i,length:0-o,angle:-u,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawNose=function(e,t,n){var i=r.computeFaceOffset(e,e.nose_height,n),s=t+e.nose_width/2,o=i+e.nose_length,u=s-e.nose_width,a=o;this.canvas.ctx.lineWidth=e.lineWidth,this.canvas.ctx.strokeStyle=e.color,this.canvas.ctx.save(),this.canvas.ctx.beginPath(),this.canvas.ctx.moveTo(t,i),this.canvas.ctx.lineTo(s,o),this.canvas.ctx.lineTo(u,a),this.canvas.ctx.stroke(),this.canvas.ctx.restore()},r.prototype.drawMouth=function(e,t,n){var i=r.computeFaceOffset(e,e.mouth_height,n),s=t-e.mouth_width/2,o=t+e.mouth_width/2,u=i-e.mouth_top_y,a=i+e.mouth_bottom_y;this.canvas.ctx.moveTo(s,i),this.canvas.ctx.quadraticCurveTo(t,u,o,i),this.canvas.ctx.stroke(),this.canvas.ctx.moveTo(s,i),this.canvas.ctx.quadraticCurveTo(t,a,o,i),this.canvas.ctx.stroke()},r.computeFaceOffset=function(e,t,n){n=n||0;var r=n-e.head_radius+e.head_radius*2*t;return r},r.computeEyebrowOffset=function(e,t){t=t||0;var n=2;return r.computeFaceOffset(e,e.eye_height,t)-n-e.eyebrow_eyedistance},i.defaults={head_radius:{min:10,max:100,step:.01,value:30,label:"Face radius"},head_scale_x:{min:.2,max:2,step:.01,value:.5,label:"Scale head horizontally"},head_scale_y:{min:.2,max:2,step:.01,value:1,label:"Scale head vertically"},eye_height:{min:.1,max:.9,step:.01,value:.4,label:"Eye height"},eye_radius:{min:2,max:30,step:.01,value:5,label:"Eye radius"},eye_spacing:{min:0,max:50,step:.01,value:10,label:"Eye spacing"},eye_scale_x:{min:.2,max:2,step:.01,value:1,label:"Scale eyes horizontally"},eye_scale_y:{min:.2,max:2,step:.01,value:1,label:"Scale eyes vertically"},pupil_radius:{min:1,max:9,step:.01,value:1,label:"Pupil radius"},pupil_scale_x:{min:.2,max:2,step:.01,value:1,label:"Scale pupils horizontally"},pupil_scale_y:{min:.2,max:2,step:.01,value:1,label:"Scale pupils vertically"},eyebrow_length:{min:1,max:30,step:.01,value:10,label:"Eyebrow length"},eyebrow_eyedistance:{min:.3,max:10,step:.01,value:3,label:"Eyebrow from eye"},eyebrow_angle:{min:-2,max:2,step:.01,value:-0.5,label:"Eyebrow angle"},eyebrow_spacing:{min:0,max:20,step:.01,value:5,label:"Eyebrow spacing"},nose_height:{min:.4,max:1,step:.01,value:.4,label:"Nose height"},nose_length:{min:.2,max:30,step:.01,value:15,label:"Nose length"},nose_width:{min:0,max:30,step:.01,value:10,label:"Nose width"},mouth_height:{min:.2,max:2,step:.01,value:.75,label:"Mouth height"},mouth_width:{min:2,max:100,step:.01,value:20,label:"Mouth width"},mouth_top_y:{min:-10,max:30,step:.01,value:-2,label:"Upper lip"},mouth_bottom_y:{min:-10,max:30,step:.01,value:20,label:"Lower lip"},scaleX:{min:0,max:20,step:.01,value:.2,label:"Scale X"},scaleY:{min:0,max:20,step:.01,value:.2,label:"Scale Y"},color:{min:0,max:20,step:.01,value:.2,label:"color"},lineWidth:{min:0,max:20,step:.01,value:.2,label:"lineWidth"}},function(e){var t;for(t in e)e.hasOwnProperty(t)&&(e[t].range=e[t].max-e[t].min)}(i.defaults),i.random=function(){return console.log("*** FaceVector.random is deprecated. Use new FaceVector() instead."),new i}}(node),function(e){"use strict";function n(n){this.options=n,this.id=n.id,this.table=new t({id:"cf_table"}),this.root=n.root||document.createElement("div"),this.root.id=this.id,this.sc=e.widgets.get("Controls.Slider"),this.fp=null,this.canvas=null,this.dims=null,this.change="CF_CHANGE";var r=this;this.changeFunc=function(){r.draw(r.sc.getAllValues())},this.features=null,this.controls=null}function r(e,t){this.canvas=new W.Canvas(e),this.scaleX=e.width/n.defaults.canvas.width,this.scaleY=e.height/n.defaults.canvas.heigth}function i(e){e=e||{},this.scaleX=e.scaleX||1,this.scaleY=e.scaleY||1,this.color=e.color||"green",this.lineWidth=e.lineWidth||1;for(var t in i.defaults)i.defaults.hasOwnProperty(t)&&(e.hasOwnProperty(t)?this[t]=e[t]:this[t]=i.defaults[t].value)}var t=W.Table;e.widgets.register("ChernoffFacesSimple",n),n.defaults={},n.defaults.id="ChernoffFaces",n.defaults.canvas={},n.defaults.canvas.width=100,n.defaults.canvas.heigth=100,n.version="0.4",n.description="Display parametric data in the form of a Chernoff Face.",n.dependencies={JSUS:{},Table:{},Canvas:{},"Controls.Slider":{}},n.FaceVector=i,n.FacePainter=r,n.prototype.init=function(t){this.id=t.id||this.id;var s=this.id+"_";this.features=t.features||this.features||i.random(),this.controls="undefined"!=typeof t.controls?t.controls:!0;var o=t.idCanvas?t.idCanvas:s+"canvas";this.dims={width:t.width?t.width:n.defaults.canvas.width,height:t.height?t.height:n.defaults.canvas.heigth},this.canvas=W.getCanvas(o,this.dims),this.fp=new r(this.canvas),this.fp.draw(new i(this.features));var u={id:"cf_controls",features:J.mergeOnKey(i.defaults,this.features,"value"),change:this.change,fieldset:{id:this.id+"_controls_fieldest",legend:this.controls.legend||"Controls"},submit:"Send"};this.sc=e.widgets.get("Controls.Slider",u),this.controls&&this.table.add(this.sc),"undefined"==typeof t.change?e.on(this.change,this.changeFunc):(t.change?e.on(t.change,this.changeFunc):e.removeListener(this.change,this.changeFunc),this.change=t.change),this.table.add(this.canvas),this.table.parse(),this.root.appendChild(this.table.table)},n.prototype.getRoot=function(){return this.root},n.prototype.getCanvas=function(){return this.canvas},n.prototype.append=function(e){return e.appendChild(this.root),this.table.parse(),this.root},n.prototype.listeners=function(){},n.prototype.draw=function(e){if(!e)return;var t=new i(e);this.fp.redraw(t),this.sc.init({features:J.mergeOnKey(i.defaults,e,"value")}),this.sc.refresh()},n.prototype.getAllValues=function(){return this.fp.face},n.prototype.randomize=function(){var e=i.random();this.fp.redraw(e);var t={features:J.mergeOnKey(i.defaults,e,"value"),change:this.change};return this.sc.init(t),this.sc.refresh(),!0},r.prototype.draw=function(e,t,n){if(!e)return;this.face=e,this.fit2Canvas(e),this.canvas.scale(e.scaleX,e.scaleY),t=t||this.canvas.centerX,n=n||this.canvas.centerY,this.drawHead(e,t,n),this.drawEyes(e,t,n),this.drawPupils(e,t,n),this.drawEyebrow(e,t,n),this.drawNose(e,t,n),this.drawMouth(e,t,n)},r.prototype.redraw=function(e,t,n){this.canvas.clear(),this.draw(e,t,n)},r.prototype.scale=function(e,t){this.canvas.scale(this.scaleX,this.scaleY)},r.prototype.fit2Canvas=function(e){var t;if(!this.canvas){console.log("No canvas found");return}this.canvas.width>this.canvas.height?t=this.canvas.width/e.head_radius*e.head_scale_x:t=this.canvas.height/e.head_radius*e.head_scale_y,e.scaleX=t/2,e.scaleY=t/2},r.prototype.drawHead=function(e,t,n){var r=e.head_radius;this.canvas.drawOval({x:t,y:n,radius:r,scale_x:e.head_scale_x,scale_y:e.head_scale_y,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawEyes=function(e,t,n){var i=r.computeFaceOffset(e,e.eye_height,n),s=e.eye_spacing,o=e.eye_radius;this.canvas.drawOval({x:t-s,y:i,radius:o,scale_x:e.eye_scale_x,scale_y:e.eye_scale_y,color:e.color,lineWidth:e.lineWidth}),this.canvas.drawOval({x:t+s,y:i,radius:o,scale_x:e.eye_scale_x,scale_y:e.eye_scale_y,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawPupils=function(e,t,n){var i=e.pupil_radius,s=e.eye_spacing,o=r.computeFaceOffset(e,e.eye_height,n);this.canvas.drawOval({x:t-s,y:o,radius:i,scale_x:e.pupil_scale_x,scale_y:e.pupil_scale_y,color:e.color,lineWidth:e.lineWidth}),this.canvas.drawOval({x:t+s,y:o,radius:i,scale_x:e.pupil_scale_x,scale_y:e.pupil_scale_y,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawEyebrow=function(e,t,n){var i=r.computeEyebrowOffset(e,n),s=e.eyebrow_spacing,o=e.eyebrow_length,u=e.eyebrow_angle;this.canvas.drawLine({x:t-s,y:i,length:o,angle:u,color:e.color,lineWidth:e.lineWidth}),this.canvas.drawLine({x:t+s,y:i,length:0-o,angle:-u,color:e.color,lineWidth:e.lineWidth})},r.prototype.drawNose=function(e,t,n){var i=r.computeFaceOffset(e,e.nose_height,n),s=t+e.nose_width/2,o=i+e.nose_length,u=s-e.nose_width,a=o;this.canvas.ctx.lineWidth=e.lineWidth,this.canvas.ctx.strokeStyle=e.color,this.canvas.ctx.save(),this.canvas.ctx.beginPath(),this.canvas.ctx.moveTo(t,i),this.canvas.ctx.lineTo(s,o),this.canvas.ctx.lineTo(u,a),this.canvas.ctx.stroke(),this.canvas.ctx.restore()},r.prototype.drawMouth=function(e,t,n){var i=r.computeFaceOffset(e,e.mouth_height,n),s=t-e.mouth_width/2,o=t+e.mouth_width/2,u=i-e.mouth_top_y,a=i+e.mouth_bottom_y;this.canvas.ctx.moveTo(s,i),this.canvas.ctx.quadraticCurveTo(t,u,o,i),this.canvas.ctx.stroke(),this.canvas.ctx.moveTo(s,i),this.canvas.ctx.quadraticCurveTo(t,a,o,i),this.canvas.ctx.stroke()},r.computeFaceOffset=function(e,t,n){n=n||0;var r=n-e.head_radius+e.head_radius*2*t;return r},r.computeEyebrowOffset=function(e,t){t=t||0;var n=2;return r.computeFaceOffset(e,e.eye_height,t)-n-e.eyebrow_eyedistance},i.defaults={head_radius:{min:10,max:100,step:.01,value:30,label:"Face radius"},head_scale_x:{min:.2,max:2,step:.01,value:.5,label:"Scale head horizontally"},head_scale_y:{min:.2,max:2,step:.01,value:1,label:"Scale head vertically"},eye_height:{min:.1,max:.9,step:.01,value:.4,label:"Eye height"},eye_radius:{min:2,max:30,step:.01,value:5,label:"Eye radius"},eye_spacing:{min:0,max:50,step:.01,value:10,label:"Eye spacing"},eye_scale_x:{min:.2,max:2,step:.01,value:1,label:"Scale eyes horizontally"},eye_scale_y:{min:.2,max:2,step:.01,value:1,label:"Scale eyes vertically"},pupil_radius:{min:1,max:9,step:.01,value:1,label:"Pupil radius"},pupil_scale_x:{min:.2,max:2,step:.01,value:1,label:"Scale pupils horizontally"},pupil_scale_y:{min:.2,max:2,step:.01,value:1,label:"Scale pupils vertically"},eyebrow_length:{min:1,max:30,step:.01,value:10,label:"Eyebrow length"},eyebrow_eyedistance:{min:.3,max:10,step:.01,value:3,label:"Eyebrow from eye"},eyebrow_angle:{min:-2,max:2,step:.01,value:-0.5,label:"Eyebrow angle"},eyebrow_spacing:{min:0,max:20,step:.01,value:5,label:"Eyebrow spacing"},nose_height:{min:.4,max:1,step:.01,value:.4,label:"Nose height"},nose_length:{min:.2,max:30,step:.01,value:15,label:"Nose length"},nose_width:{min:0,max:30,step:.01,value:10,label:"Nose width"},mouth_height:{min:.2,max:2,step:.01,value:.75,label:"Mouth height"},mouth_width:{min:2,max:100,step:.01,value:20,label:"Mouth width"},mouth_top_y:{min:-10,max:30,step:.01,value:-2,label:"Upper lip"},mouth_bottom_y:{min:-10,max:30,step:.01,value:20,label:"Lower lip"}},i.random=function(){var e={};for(var t in i.defaults)i.defaults.hasOwnProperty(t)&&(J.inArray(t,["color","lineWidth","scaleX","scaleY"])||(e[t]=i.defaults[t].min+Math.random()*i.defaults[t].max));return e.scaleX=1,e.scaleY=1,e.color="green",e.lineWidth=1,new i(e)},i.prototype.shuffle=function(){for(var e in this)this.hasOwnProperty(e)&&i.defaults.hasOwnProperty(e)&&e!=="color"&&(this[e]=i.defaults[e].min+Math.random()*i.defaults[e].max)},i.prototype.distance=function(e){return i.distance(this,e)},i.distance=function(e,t){var n=0,r;for(var i in e)e.hasOwnProperty(i)&&(r=e[i]-t[i],n+=r*r);return Math.sqrt(n)},i.prototype.toString=function(){var e="Face: ";for(var t in this)this.hasOwnProperty(t)&&(e+=t+" "+this[t]);return e}}(node),function(e){"use strict";function t(){var e;e=this,this.dl=null,this.mainText=null,this.spanMainText=null,this.forms=null,this.formsById=null,this.order=null,this.shuffleForms=null,this.group=null,this.groupOrder=null,this.formsOptions={title:!1,frame:!1,storeRef:!1},this.freeText=null,this.textarea=null}e.widgets.register("ChoiceManager",t),t.version="1.2.0",t.description="Groups together and manages a set of selectable choices forms (e.g. ChoiceTable).",t.title=!1,t.className="choicemanager",t.dependencies={JSUS:{}},t.prototype.init=function(e){var t,n;n=this,"undefined"==typeof e.shuffleForms?t=!1:t=!!e.shuffleForms,this.shuffleForms=t;if("string"==typeof e.group||"number"==typeof e.group)this.group=e.group;else if("undefined"!=typeof e.group)throw new TypeError("ChoiceManager.init: options.group must be string, number or undefined. Found: "+e.group);if("number"==typeof e.groupOrder)this.groupOrder=e.groupOrder;else if("undefined"!=typeof e.group)throw new TypeError("ChoiceManager.init: options.groupOrder must be number or undefined. Found: "+e.groupOrder);if("string"==typeof e.mainText)this.mainText=e.mainText;else if("undefined"!=typeof e.mainText)throw new TypeError("ChoiceManager.init: options.mainText must be string or undefined. Found: "+e.mainText);if("undefined"!=typeof e.formsOptions){if("object"!=typeof e.formsOptions)throw new TypeError("ChoiceManager.init: options.formsOptions must be object or undefined. Found: "+e.formsOptions);if(e.formsOptions.hasOwnProperty("name"))throw new Error("ChoiceManager.init: options.formsOptions cannot contain property name. Found: "+e.formsOptions);this.formsOptions=J.mixin(this.formsOptions,e.formsOptions)}this.freeText="string"==typeof e.freeText?e.freeText:!!e.freeText,"undefined"!=typeof e.forms&&this.setForms(e.forms)},t.prototype.setForms=function(t){var n,r,i,s,o;if("function"==typeof t){o=t.call(e.game);if(!J.isArray(o))throw new TypeError("ChoiceManager.setForms: forms is a callback, but did not returned an array. Found: "+o)}else{if(!J.isArray(t))throw new TypeError("ChoiceManager.setForms: forms must be array or function. Found: "+t);o=t}s=o.length;if(!s)throw new Error("ChoiceManager.setForms: forms is an empty array.");r={},t=new Array(s),i=-1;for(;++i<s;){n=o[i];if(!e.widgets.isWidget(n)){"string"==typeof n.name&&(J.mixout(n,this.formsOptions),n=e.widgets.get(n.name,n));if(!e.widgets.isWidget(n))throw new Error("ChoiceManager.setForms: one of the forms is not a widget-like element: "+n)}t[i]=n;if(n.id){if(r[n.id])throw new Error("ChoiceManager.setForms: duplicated form id: "+n.id);r[n.id]=t[i]}}this.forms=t,this.formsById=r,this.order=J.seq(0,s-1),this.shuffleForms&&(this.order=J.shuffle(this.order))},t.prototype.buildDl=function(){var t,n,r,i,s;t=-1,n=this.forms.length;for(;++t<n;)i=document.createElement("dt"),i.className="question",s=this.forms[this.order[t]],e.widgets.append(s,i),this.dl.appendChild(i)},t.prototype.append=function(){var e;if(W.getElementById(this.id))throw new Error("ChoiceManager.append: id is not unique: "+this.id);this.mainText&&(this.spanMainText=document.createElement("span"),this.spanMainText.className=t.className+"-maintext",this.spanMainText.innerHTML=this.mainText,this.bodyDiv.appendChild(this.spanMainText)),this.dl=document.createElement("dl"),this.buildDl(),this.bodyDiv.appendChild(this.dl),this.freeText&&(this.textarea=document.createElement("textarea"),this.textarea.id=this.id+"_text","string"==typeof this.freeText&&(this.textarea.placeholder=this.freeText),e=this.className?this.className+"-freetext":"freetext",this.textarea.className=e,this.bodyDiv.appendChild(this.textarea))},t.prototype.listeners=function(){var t=this;e.on("INPUT_DISABLE",function(){t.disable()}),e.on("INPUT_ENABLE",function(){t.enable()})},t.prototype.disable=function(){var e,t;if(this.disabled)return;e=-1,t=this.forms.length;for(;++e<t;)this.forms[e].disable();this.disabled=!0,this.emit("disabled")},t.prototype.enable=function(){var e,t;if(!this.disabled)return;e=-1,t=this.forms.length;for(;++e<t;)this.forms[e].enable();this.disabled=!1,this.emit("enabled")},t.prototype.verifyChoice=function(e){var t,n,r,i;r={id:this.id,order:this.order,forms:{}},e="undefined"==typeof e?!0:e,t=-1,n=this.forms.length;for(;++t<n;)i=this.forms[t],r.forms[i.id]=i.verifyChoice(e),r.form[i.id]||(r.fail=!0);return r},t.prototype.setCurrentChoice=function(e){var t,n;t=-1,n=this.forms[t].length;for(;++t<n;)this.forms[t].setCurrentChoice(e)},t.prototype.unsetCurrentChoice=function(e){var t,n;t=-1,n=this.forms[t].length;for(;++t<n;)this.forms[t].unsetCurrentChoice(e)},t.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError("ChoiceManager.highlight: border must be string or undefined. Found: "+e);if(!this.dl||this.highlighted===!0)return;this.dl.style.border=e||"3px solid red",this.highlighted=!0,this.emit("highlighted")},t.prototype.unhighlight=function(){if(!this.dl||this.highlighted!==!0)return;this.dl.style.border="",this.highlighted=!1,this.emit("unhighlighted")},t.prototype.reset=function(e){var t,n;t=-1,n=this.forms.length;for(;++t<n;)this.forms[t].reset(e)},t.prototype.getValues=function(e){var t,n,r,i;t={id:this.id,order:this.order,forms:{},missValues:[]},e=e||{},"undefined"==typeof e.markAttempt&&(e.markAttempt=!0),"undefined"==typeof e.highlight&&(e.highlight=!0),e.markAttempt&&(t.isCorrect=!0),n=-1,r=this.forms.length;for(;++n<r;)i=this.forms[n],i.isHidden()||i.isDisabled()?t.forms[i.id]=i.getValues({markAttempt:!1,highlight:!1}):(t.forms[i.id]=i.getValues(e),i.requiredChoice&&(t.forms[i.id].choice===null||i.selectMultiple&&!t.forms[i.id].choice.length)&&t.missValues.push(i.id),e.markAttempt&&t.forms[i.id].isCorrect===!1&&(t.isCorrect=!1));return t.missValues.length&&(t.isCorrect=!1),this.textarea&&(t.freetext=this.textarea.value),t},t.prototype.setValues=function(e){var t,n;if(!this.forms||!this.forms.length)throw new Error("ChoiceManager.setValues: no forms found.");e=e||{},t=-1,n=this.forms.length;for(;++t<n;)this.forms[t].setValues(e);this.textarea&&(this.textarea.value=J.randomString(100,"!Aa0"))}}(node),function(e){"use strict";function t(n){var r;r=this,this.table=null,this.choicesSetSize=null,this.trs=[],this.listener=function(t){var n,i,s,o,u,a;t=t||window.event,s=t.target||t.srcElement;if("undefined"==typeof r.choicesIds[s.id])return;"string"==typeof r.timeFrom?r.timeCurrentChoice=e.timer.getTimeSince(r.timeFrom):r.timeCurrentChoice=Date.now?Date.now():(new Date).getTime(),i=s.id.split(r.separator);if(i.length===1)return;n=i[0],i=i[1],r.numberOfClicks++;if(r.isChoiceCurrent(i)){r.unsetCurrentChoice(i),J.removeClass(s,"selected");if(r.selectMultiple){o=-1,u=r.selected.length;for(;++o<u;)if(r.selected[o].id===s.id){r.selected.splice(o,1);break}}else r.selected=null;a=!0}else{if("number"==typeof r.selectMultiple&&r.selected.length===r.selectMultiple)return;r.setCurrentChoice(i),J.addClass(s,"selected"),r.selectMultiple?r.selected.push(s):(r.selected&&J.removeClass(r.selected,"selected"),r.selected=s)}r.isHighlighted()&&r.unhighlight(),r.onclick&&(i=parseInt(i,10),r.onclick.call(r,i,a,s))},this.mainText=null,this.hint=null,this.spanMainText=null,this.choices=null,this.choicesValues={},this.choicesIds={},this.choicesCells=null,this.left=null,this.leftCell=null,this.right=null,this.rightCell=null,this.timeCurrentChoice=null,this.timeFrom="step",this.order=null,this.correctChoice=null,this.requiredChoice=null,this.attempts=[],this.numberOfClicks=0,this.selected=null,this.currentChoice=null,this.selectMultiple=null,this.shuffleChoices=null,this.renderer=null,this.orientation="H",this.group=null,this.groupOrder=null,this.freeText=null,this.textarea=null,this.separator=t.separator}function n(e,t){"number"==typeof t&&(t=""+t);if("string"!=typeof t)throw new TypeError("ChoiceTable.setCorrectChoice: each choice must be number or string. Found: "+t);if("undefined"==typeof e.choicesValues[t])throw new TypeError("ChoiceTable.setCorrectChoice: choice not found: "+t);return t}function r(e,t){var n;return n=document.createElement("tr"),n.id="tr"+e.separator+e.id,e.table.appendChild(n),e.trs.push(n),n}e.widgets.register("ChoiceTable",t),t.version="1.6.0",t.description="Creates a configurable table where each cell is a selectable choice.",t.title="Make your choice",t.className="choicetable",t.texts.autoHint=function(e){var t;return!e.requiredChoice&&!e.selectMultiple?!1:e.selectMultiple?(t="(",e.requiredChoice?"number"==typeof e.selectMultiple?t+="select between "+e.requiredChoice+" and "+e.selectMultiple:t+="select at least "+e.requiredChoice:"number"==typeof e.selectMultiple?t+="select up to "+e.selectMultiple:t+="multiple selection allowed",t+=")",e.requiredChoice&&(t+=" *"),t):"*"},t.separator="::",t.dependencies={JSUS:{}},t.prototype.init=function(e){var n,r;r=this;if(!this.id)throw new TypeError("ChoiceTable.init: options.id is missing");if("undefined"==typeof e.orientation)n="H";else{if("string"!=typeof e.orientation)throw new TypeError("ChoiceTable.init: options.orientation must be string, or undefined. Found: "+e.orientation);n=e.orientation.toLowerCase().trim();if(n==="horizontal"||n==="h")n="H";else{if(n!=="vertical"&&n!=="v")throw new Error("ChoiceTable.init: options.orientation is invalid: "+n);n="V"}}this.orientation=n,"undefined"==typeof e.shuffleChoices?n=!1:n=!!e.shuffleChoices,this.shuffleChoices=n,n=e.selectMultiple;if("undefined"==typeof n)n=!1;else if("boolean"!=typeof n){n=J.isInt(n,1);if(!n)throw new Error("ChoiceTable.init: selectMultiple must be undefined or an integer > 1. Found: "+n)}this.selectMultiple=n,n&&(this.selected=[],this.currentChoice=[]);if("number"==typeof e.requiredChoice){if(!J.isInt(e.requiredChoice,0))throw new Error("ChoiceTable.init: if number, requiredChoice must a positive integer. Found: "+e.requiredChoice);if("number"==typeof this.selectMultiple&&e.requiredChoice>this.selectMultiple)throw new Error("ChoiceTable.init: requiredChoice cannot be larger than selectMultiple. Found: "+e.requiredChoice+" > "+this.selectMultiple);this.requiredChoice=e.requiredChoice}else if("boolean"==typeof e.requiredChoice)this.requiredChoice=e.requiredChoice?1:null;else if("undefined"!=typeof e.requiredChoice)throw new TypeError("ChoiceTable.init: options.requiredChoice be number, boolean or undefined. Found: "+e.requiredChoice);if("string"==typeof e.group||"number"==typeof e.group)this.group=e.group;else if("undefined"!=typeof e.group)throw new TypeError("ChoiceTable.init: options.group must be string, number or undefined. Found: "+e.group);if("number"==typeof e.groupOrder)this.groupOrder=e.groupOrder;else if("undefined"!=typeof e.groupOrder)throw new TypeError("ChoiceTable.init: options.groupOrder must be number or undefined. Found: "+e.groupOrder);if("function"==typeof e.listener)this.listener=function(t){e.listener.call(this,t)};else if("undefined"!=typeof e.listener)throw new TypeError("ChoiceTable.init: options.listener must be function or undefined. Found: "+e.listener);if("function"==typeof e.onclick)this.onclick=e.onclick;else if("undefined"!=typeof e.onclick)throw new TypeError("ChoiceTable.init: options.onclick must be function or undefined. Found: "+e.onclick);if("string"==typeof e.mainText)this.mainText=e.mainText;else if("undefined"!=typeof e.mainText)throw new TypeError("ChoiceTable.init: options.mainText must be string or undefined. Found: "+e.mainText);if("string"==typeof e.hint||!1===e.hint)this.hint=e.hint,this.requiredChoice&&(this.hint+=" *");else{if("undefined"!=typeof e.hint)throw new TypeError("ChoiceTable.init: options.hint must be a string, false, or undefined. Found: "+e.hint);this.hint=this.getText("autoHint")}if(e.timeFrom===!1||"string"==typeof e.timeFrom)this.timeFrom=e.timeFrom;else if("undefined"!=typeof e.timeFrom)throw new TypeError("ChoiceTable.init: options.timeFrom must be string, false, or undefined. Found: "+e.timeFrom);if("string"==typeof e.separator)this.separator=e.separator;else if("undefined"!=typeof e.separator)throw new TypeError("ChoiceTable.init: options.separator must be string, or undefined. Found: "+e.separator);if(this.id.indexOf(e.separator)!==-1)throw new Error("ChoiceTable.init: options.separator cannot be a sequence of characters included in the table id. Found: "+e.separator);if("string"==typeof e.left||"number"==typeof e.left)this.left=""+e.left;else if(J.isNode(e.left)||J.isElement(e.left))this.left=e.left;else if("undefined"!=typeof e.left)throw new TypeError("ChoiceTable.init: options.left must be string, number, an HTML Element or undefined. Found: "+e.left);if("string"==typeof e.right||"number"==typeof e.right)this.right=""+e.right;else if(J.isNode(e.right)||J.isElement(e.right))this.right=e.right;else if("undefined"!=typeof e.right)throw new TypeError("ChoiceTable.init: options.right must be string, number, an HTML Element or undefined. Found: "+e.right);if("undefined"==typeof e.className)this.className=t.className;else{if(e.className!==!1&&"string"!=typeof e.className&&!J.isArray(e.className))throw new TypeError("ChoiceTable.init: options.className must be string, array, or undefined. Found: "+e.className);this.className=e.className}if("function"==typeof e.renderer)this.renderer=e.renderer;else if("undefined"!=typeof e.renderer)throw new TypeError("ChoiceTable.init: options.renderer must be function or undefined. Found: "+e.renderer);if("object"==typeof e.table)this.table=e.table;else if("undefined"!=typeof e.table&&!1!==e.table)throw new TypeError("ChoiceTable.init: options.table must be object, false or undefined. Found: "+e.table);this.table=e.table,this.freeText="string"==typeof e.freeText?e.freeText:!!e.freeText,"undefined"!=typeof e.choices&&this.setChoices(e.choices);if("undefined"!=typeof e.correctChoice){if(this.requiredChoice)throw new Error("ChoiceTable.init: cannot specify both options requiredChoice and correctChoice");this.setCorrectChoice(e.correctChoice)}if("undefined"!=typeof e.choicesSetSize){if(!J.isInt(e.choicesSetSize,0))throw new Error("ChoiceTable.init: choicesSetSize must be undefined or an integer > 0. Found: "+e.choicesSetSize);this.choicesSetSize=e.choicesSetSize}},t.prototype.setChoices=function(e){var t;if(!J.isArray(e))throw new TypeError("ChoiceTable.setChoices: choices must be array.");if(!e.length)throw new Error("ChoiceTable.setChoices: choices is empty array.");this.choices=e,t=e.length,this.order=J.seq(0,t-1),this.shuffleChoices&&(this.order=J.shuffle(this.order)),this.table?this.buildTableAndChoices():this.buildChoices()},t.prototype.buildChoices=function(){var e,t;e=-1,t=this.choices.length,this.choicesCells=new Array(t);for(;++e<t;)this.renderChoice(this.choices[this.order[e]],e);this.left&&this.renderSpecial("left",this.left),this.right&&this.renderSpecial("right",this.right)},t.prototype.buildTable=function(){function e(t,n,i,s){var o,u;u=0,i&&(o=r(this,"main"),this.leftCell&&o.appendChild(this.leftCell));for(;++t<n;){i||(o=r(this,"left"),t===0&&this.leftCell&&(o.appendChild(this.leftCell),o=r(this,t))),o.appendChild(this.choicesCells[t]);if(s&&++u>=this.choicesSetSize)break}this.rightCell&&(i||(o=r(this,"right")),o.appendChild(this.rightCell)),t!==n&&e.call(this,t,n,i,s)}return function(){var t,n,r,i;if(!this.choicesCells)throw new Error("ChoiceTable.buildTable: choices not set, cannot build table. Id: "+this.id);r=this.orientation==="H",n=this.choicesCells.length,i="number"==typeof this.choicesSetSize,e.call(this,-1,n,r,i),this.enable()}}(),t.prototype.buildTableAndChoices=function(){var e,t,n,i,s;t=this.choices.length,this.choicesCells=new Array(t),e=-1,s=this.orientation==="H",s&&(n=r(this,"main"),this.left&&(i=this.renderSpecial("left",this.left),n.appendChild(i)));for(;++e<t;)s||(n=r(this,"left"),e===0&&this.left&&(i=this.renderSpecial("left",this.left),n.appendChild(i),n=r(this,e))),i=this.renderChoice(this.choices[this.order[e]],e),n.appendChild(i);this.right&&(s||(n=r(this,"right")),i=this.renderSpecial("right",this.right),n.appendChild(i)),this.enable()},t.prototype.renderSpecial=function(e,t){var n,r;n=document.createElement("td"),"string"==typeof t?n.innerHTML=t:n.appendChild(t);if(e==="left")r=this.className?this.className+"-left":"left",this.leftCell=n;else{if(e!=="right")throw new Error("ChoiceTable.renderSpecial: unknown type: "+e);r=this.className?this.className+"-right":"right",this.rightCell=n}return n.className=r,n.id=this.id+this.separator+"special-cell-"+e,n},t.prototype.renderChoice=function(e,t){var n,r;n=document.createElement("td");if(this.renderer)r=this.renderer(n,e,t),"undefined"==typeof r&&(r=t);else{J.isArray(e)?(r=e[0],e=e[1]):r=this.shuffleChoices?this.order[t]:t;if("string"==typeof e||"number"==typeof e)n.innerHTML=e;else{if(!J.isElement(e)&&!J.isNode(e))throw new Error("ChoiceTable.renderChoice: invalid choice: "+e);n.appendChild(e)}}if("undefined"!=typeof this.choicesValues[r])throw new Error("ChoiceTable.renderChoice: value already in use: "+r);if(!n.id||n.id==="")n.id=this.id+this.separator+r;return this.choicesValues[r]=t,this.choicesCells[t]=n,this.choicesIds[n.id]=n,n},t.prototype.setCorrectChoice=function(e){var t,r;if(!this.selectMultiple)e=n(this,e);else{if(!J.isArray(e)||!e.length)throw new TypeError("ChoiceTable.setCorrectChoice: choice must be non-empty array. Found: "+e);t=-1,r=e.length;for(;++t<r;)e[t]=n(this,e[t])}this.correctChoice=e},t.prototype.append=function(){var e;if(W.getElementById(this.id))throw new Error("ChoiceTable.append: id is not unique: "+this.id);this.mainText&&(this.spanMainText=W.append("span",this.bodyDiv,{className:"choicetable-maintext",innerHTML:this.mainText})),this.hint&&W.append("span",this.spanMainText||this.bodyDiv,{className:"choicetable-hint",innerHTML:this.hint}),this.table!==!1&&("undefined"==typeof this.table&&(this.table=document.createElement("table"),this.buildTable()),this.table.id=this.id,this.className?J.addClass(this.table,this.className):this.table.className="",this.bodyDiv.appendChild(this.table)),this.freeText&&(this.textarea=document.createElement("textarea"),this.textarea.id=this.id+"_text","string"==typeof this.freeText&&(this.textarea.placeholder=this.freeText),e=this.className?this.className+"-freetext":"freetext",this.textarea.className=e,this.bodyDiv.appendChild(this.textarea))},t.prototype.listeners=function(){var t=this;e.on("INPUT_DISABLE",function(){t.disable()}),e.on("INPUT_ENABLE",function(){t.enable()})},t.prototype.disable=function(){if(this.disabled===!0)return;this.disabled=!0,this.table&&(J.removeClass(this.table,"clickable"),this.table.removeEventListener("click",this.listener)),this.emit("disabled")},t.prototype.enable=function(){if(this.disabled===!1)return;if(!this.table)throw new Error("ChoiceTable.enable: table not defined");this.disabled=!1,J.addClass(this.table,"clickable"),this.table.addEventListener("click",this.listener),this.emit("enabled")},t.prototype.verifyChoice=function(e){var t,n,r,i,s,o,u,a;if(this.requiredChoice!==null)return this.selectMultiple?this.currentChoice.length>=this.requiredChoice:this.currentChoice!==null;if(!this.correctChoice)return null;e="undefined"==typeof e?!0:e,e&&this.attempts.push(this.currentChoice);if(!this.selectMultiple)return this.currentChoice===this.correctChoice;a=J.isArray(this.correctChoice)?this.correctChoice:[this.correctChoice],n=a.length,i=this.currentChoice.length;if(n!==i)return!1;t=-1,o=this.currentChoice.slice(0);for(;++t<n;){u=!1,s=correctChoices[t],r=-1;for(;++r<i;)if(o[r]===s){u=!0;break}if(!u)return!1}return!0},t.prototype.setCurrentChoice=function(e){this.selectMultiple?this.currentChoice.push(e):this.currentChoice=e},t.prototype.unsetCurrentChoice=function(e){var t,n;if(!this.selectMultiple||"undefined"==typeof e)this.currentChoice=null;else{if("string"!=typeof e&&"number"!=typeof e)throw new TypeError("ChoiceTable.unsetCurrentChoice: choice must be string, number or undefined. Found: "+e);t=-1,n=this.currentChoice.length;for(;++t<n;)if(this.currentChoice[t]===e){this.currentChoice.splice(t,1);break}}},t.prototype.isChoiceCurrent=function(e){var t,n;if("number"==typeof e)e=""+e;else if("string"!=typeof e)throw new TypeError("ChoiceTable.isChoiceCurrent: choice must be string or number. Found: "+e);if(!this.selectMultiple)return this.currentChoice===e;t=-1,n=this.currentChoice.length;for(;++t<n;)if(this.currentChoice[t]===e)return!0;return!1},t.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError("ChoiceTable.highlight: border must be string or undefined. Found: "+e);if(!this.table||this.highlighted)return;this.table.style.border=e||"3px solid red",this.highlighted=!0,this.emit("highlighted",e)},t.prototype.unhighlight=function(){if(!this.table||this.highlighted!==!0)return;this.table.style.border="",this.highlighted=!1,this.emit("unhighlighted")},t.prototype.getChoiceAtPosition=function(e){if(!this.choices||!this.order)return;return this.choices[this.order[parseInt(e,10)]]},t.prototype.getValues=function(e){var t,n,r,i;e=e||{},t={id:this.id,choice:e.reset?this.currentChoice:J.clone(this.currentChoice),time:this.timeCurrentChoice,nClicks:this.numberOfClicks},"undefined"==typeof e.highlight&&(e.highlight=!0),e.processChoice&&(t.choice=e.processChoice.call(this,t.choice)),this.shuffleChoices&&(t.order=this.order);if(e.getValue!==!1)if(!this.selectMultiple)t.value=this.choices[t.choice];else{i=t.choice.length,t.value=new Array(i);if(i===1)t.value[0]=this.choices[t.choice[0]];else{r=-1;for(;++r<i;)t.value[r]=this.choices[t.choice[r]]}}if(this.group===0||this.group)t.group=this.group;if(this.groupOrder===0||this.groupOrder)t.groupOrder=this.groupOrder;if(null!==this.correctChoice||null!==this.requiredChoice)t.isCorrect=this.verifyChoice(e.markAttempt),t.attempts=this.attempts,!t.isCorrect&&e.highlight&&this.highlight();return this.textarea&&(t.freetext=this.textarea.value),t.isCorrect!==!1&&e.reset&&(n="object"!=typeof e.reset?{}:e.reset,this.reset(n)),t},t.prototype.setValues=function(e){var t,n,r,i,s,o,u,a;if(!this.choices||!this.choices.length)throw new Error("ChoiceTable.setValues: no choices found.");e=e||{};if(!this.choicesCells||!this.choicesCells.length)throw new Error("Choicetable.setValues: table was not built yet.");if(e.correct){if(!this.correctChoice||!this.correctChoice.length)throw new Error('Choicetable.setValues: "correct" is set, but no correct choice is found.');n=J.isArray(this.correctChoice)?this.correctChoice:[this.correctChoice],s=-1,o=n.length;for(;++s<o;){t=parseInt(n[s],10);if(this.shuffleChoices){u=-1,a=this.order.length;for(;++u<a;)if(this.order[u]===t){t=u;break}}this.choicesCells[t].click()}return}s=-1;if("undefined"!=typeof e.values){if(this.selectMultiple){if(!J.isArray(e.values))throw new Error("ChoiceTable.setValues: values must be array or undefined if selectMultiple is truthy. Found: "+e.values);o=e.values.length;if(o>this.selectMultiple)throw new Error("ChoiceTable.setValues: values array cannot be larger than selectMultiple: "+o+" > "+this.selectMultiple);i=e.values}else i=[e.values];for(;++s<o;){t=J.isInt(i[s],0,this.choices.length,1,1);if(!1===t)throw new Error("ChoiceTable.setValues: invalid choice value. Found: "+i[s]);this.choicesCells[t].click()}}else{this.selectMultiple?o=J.randomInt(0,this.choicesCells.length):o=1;for(;++s<o;)t=J.randomInt(0,this.choicesCells.length)-1,this.isChoiceCurrent(t)||this.choicesCells[t].click()}this.textarea&&(this.textarea.value=J.randomString(100,"!Aa0"))},t.prototype.reset=function(e){var t,n;e=e||{},this.attempts=[],this.numberOfClicks=0,this.timeCurrentChoice=null;if(this.selectMultiple){t=-1,n=this.selected.length;for(;++t<n;)J.removeClass(this.selected[t],"selected");this.selected=[],this.currentChoice=[]}else this.selected&&(J.removeClass(this.selected,"selected"),this.selected=null,this.currentChoice=null);this.textArea&&(this.textArea.value=""),this.isHighlighted()&&this.unhighlight(),e.shuffleChoices&&this.shuffle()},t.prototype.shuffle=function(){var e,t,n,r,i,s,o,u,a;t=this.orientation==="H",e=J.shuffle(this.order),n=-1,r=e.length,o={},u=new Array(r);for(;++n<r;)s=e[n],i=this.choicesCells[this.choicesValues[s]],u[n]=i,o[s]=n,t?this.trs[0].appendChild(i):(a=i.parentElement||i.parentNode,this.table.appendChild(a));this.rightCell&&(t?this.trs[0].appendChild(this.rightCell):(a=this.rightCell.parentElement||this.rightCell.parentNode,this.table.appendChild(a))),this.order=e,this.choicesCells=u,this.choicesValues=o}}(node),function(e){"use strict";function t(n){var r;r=this,this.table=null,this.trs=[],this.listener=function(t){var n,i,s,o,u,a;"string"==typeof r.timeFrom?a=e.timer.getTimeSince(r.timeFrom):a=Date.now?Date.now():(new Date).getTime(),t=t||window.event,o=t.target||t.srcElement;if(!o.id||o.id==="")return;if(!r.choicesById[o.id])return;i=o.id.split(r.separator);if(i.length===1)return;n=i[0],i=i[1],s=r.itemsById[n];if(!s)return;s.timeCurrentChoice=a,s.numberOfClicks++,s.selectMultiple||(u=s.selected,u&&J.removeClass(u,"selected"),s.isChoiceCurrent(i)?s.unsetCurrentChoice(i):(s.currentChoice=i,J.addClass(o,"selected"),s.selected=o)),r.isHighlighted()&&r.unhighlight()},this.mainText=null,this.spanMainText=null,this.hint=null,this.items=null,this.itemsById={},this.itemsMap={},this.choices=null,this.choicesById={},this.itemsSettings=null,this.order=null,this.originalOrder=null,this.shuffleItems=null,this.requiredChoice=null,this.orientation="H",this.group=null,this.groupOrder=null,this.freeText=null,this.textarea=null,this.timeFrom="step",this.selectMultiple=null,this.renderer=null,this.separator=t.separator,this.shuffleChoices=null}function n(e,t,n){if("string"==typeof t)t={id:t};else if("object"!=typeof t)throw new TypeError("ChoiceTableGroup.buildTable: item must be string or object. Found: "+t);return t.group=e.id,t.groupOrder=n+1,t.orientation=e.orientation,t.title=!1,t.listeners=!1,t.separator=e.separator,"undefined"==typeof t.choices&&e.choices&&(t.choices=e.choices),!t.renderer&&e.renderer&&(t.renderer=e.renderer),"undefined"==typeof t.requiredChoice&&e.requiredChoice&&(t.requiredChoice=e.requiredChoice),"undefined"==typeof t.selectMultiple&&null!==e.selectMultiple&&(t.selectMultiple=e.selectMultiple),"undefined"==typeof t.shuffleChoices&&e.shuffleChoices&&(t.shuffleChoices=e.shuffleChoices),"undefined"==typeof t.timeFrom&&(t.timeFrom=e.timeFrom),"undefined"==typeof t.left&&(t.left=t.id),t.storeRef=!1,t}function r(t,r){var i,s,o;o=t.order[r],s=n(t,t.itemsSettings[o],r),i=e.widgets.get("ChoiceTable",s);if(t.itemsById[i.id])throw new Error("ChoiceTableGroup.buildTable: an item with the same id already exists: "+i.id);if(!i.leftCell)throw new Error("ChoiceTableGroup.buildTable: item is missing a left cell: "+s.id);return t.itemsById[i.id]=i,t.items[o]=i,t.itemsMap[i.id]=o,i}function i(e,t){var n,r;return n=document.createElement("tr"),e.table.appendChild(n),r=e.separator,n.id=e.id+r+"tr"+r+t,e.trs.push(n),n}e.widgets.register("ChoiceTableGroup",t),t.version="1.6.0",t.description="Groups together and manages sets of ChoiceTable widgets.",t.title="Make your choice",t.className="choicetable",t.separator="::",t.texts.autoHint=function(e){return e.requiredChoice?"*":!1},t.dependencies={JSUS:{}},t.prototype.init=function(e){var n,r;r=this;if(!this.id)throw new TypeError("ChoiceTableGroup.init: options.id is missing.");if("undefined"==typeof e.orientation)n="H";else{if("string"!=typeof e.orientation)throw new TypeError("ChoiceTableGroup.init: options.orientation must be string, or undefined. Found: "+e.orientation);n=e.orientation.toLowerCase().trim();if(n==="horizontal"||n==="h")n="H";else{if(n!=="vertical"&&n!=="v")throw new Error("ChoiceTableGroup.init: options.orientation is invalid: "+n);n="V"}}this.orientation=n,"undefined"==typeof e.shuffleItems?n=!1:n=!!e.shuffleItems,this.shuffleItems=n;if("number"==typeof e.requiredChoice)this.requiredChoice=e.requiredChoice;else if("boolean"==typeof e.requiredChoice)this.requiredChoice=e.requiredChoice?1:0;else if("undefined"!=typeof e.requiredChoice)throw new TypeError("ChoiceTableGroup.init: options.requiredChoice be number or boolean or undefined. Found: "+e.requiredChoice);if("string"==typeof e.group||"number"==typeof e.group)this.group=e.group;else if("undefined"!=typeof e.group)throw new TypeError("ChoiceTableGroup.init: options.group must be string, number or undefined. Found: "+e.group);if("number"==typeof e.groupOrder)this.groupOrder=e.groupOrder;else if("undefined"!=typeof e.group)throw new TypeError("ChoiceTableGroup.init: options.groupOrder must be number or undefined. Found: "+e.groupOrder);if("function"==typeof e.onclick)this.listener=function(t){e.onclick.call(this,t)};else if("undefined"!=typeof e.onclick)throw new TypeError("ChoiceTableGroup.init: options.onclick must be function or undefined. Found: "+e.onclick);if("string"==typeof e.mainText)this.mainText=e.mainText;else if("undefined"!=typeof e.mainText)throw new TypeError("ChoiceTableGroup.init: options.mainText must be string or undefined. Found: "+e.mainText);if("string"==typeof e.hint||!1===e.hint)this.hint=e.hint;else{if("undefined"!=typeof e.hint)throw new TypeError("ChoiceTableGroup.init: options.hint must be a string, false, or undefined. Found: "+e.hint);this.hint=this.getText("autoHint")}if(e.timeFrom===!1||"string"==typeof e.timeFrom)this.timeFrom=e.timeFrom;else if("undefined"!=typeof e.timeFrom)throw new TypeError("ChoiceTableGroup.init: options.timeFrom must be string, false, or undefined. Found: "+e.timeFrom);"undefined"!=typeof e.shuffleChoices&&(this.shuffleChoices=!!e.shuffleChoices);if("function"==typeof e.renderer)this.renderer=e.renderer;else if("undefined"!=typeof e.renderer)throw new TypeError("ChoiceTableGroup.init: options.renderer must be function or undefined. Found: "+e.renderer);"undefined"!=typeof e.choices&&(this.choices=e.choices);if("undefined"==typeof e.className)this.className=t.className;else{if(e.className!==!1&&"string"!=typeof e.className&&!J.isArray(e.className))throw new TypeError("ChoiceTableGroup.init: options.className must be string, array, or undefined. Found: "+e.className);this.className=e.className}if("object"==typeof e.table)this.table=e.table;else if("undefined"!=typeof e.table&&!1!==e.table)throw new TypeError("ChoiceTableGroup.init: options.table must be object, false or undefined. Found: "+e.table);this.table=e.table,this.freeText="string"==typeof e.freeText?e.freeText:!!e.freeText,"undefined"!=typeof e.items&&this.setItems(e.items)},t.prototype.setItems=function(e){var t;if(!J.isArray(e))throw new TypeError("ChoiceTableGroup.setItems: items must be array. Found: "+e);if(!e.length)throw new Error("ChoiceTableGroup.setItems: items is an empty array.");t=e.length,this.itemsSettings=e,this.items=new Array(t),this.order=J.seq(0,t-1),this.shuffleItems&&(this.order=J.shuffle(this.order)),this.originalOrder=this.order,this.table&&this.buildTable()},t.prototype.buildTable=function(){var e,t,n,s,o,u,a,f,l,c;s=this.orientation==="H",e=-1,t=this.itemsSettings.length;if(s)for(;++e<t;){o=r(this,e),n=i(this,o.id),n.appendChild(o.leftCell),u=-1,a=o.choicesCells.length;if(e===0)f=a;else if(a!==f)throw new Error("ChoiceTableGroup.buildTable: item do not have same number of choices: "+o.id);for(;++u<a;)c=o.choicesCells[u],n.appendChild(c),this.choicesById[c.id]=c;o.rightCell&&n.appendChild(o.rightCell)}else{n=i(this,"header");for(;++e<t;){o=r(this,e),a=o.choicesCells.length;if(e===0)f=a;else if(a!==f)throw new Error("ChoiceTableGroup.buildTable: item do not have same number of choices: "+o.id);if("undefined"==typeof l)l=!!o.rightCell;else if(!o.rightCell&&l||o.rightCell&&!l)throw new Error("ChoiceTableGroup.buildTable: either all items or no item must have the right cell: "+o.id);n.appendChild(o.leftCell)}l&&a++,u=-1;for(;++u<a;){n=i(this,"row"+(u+1)),e=-1;for(;++e<t;)l&&u===a-1?n.appendChild(this.items[e].rightCell):(c=this.items[e].choicesCells[u],n.appendChild(c),this.choicesById[c.id]=c)}}this.enable(!0)},t.prototype.append=function(){if(W.getElementById(this.id))throw new Error("ChoiceTableGroup.append: id is not unique: "+this.id);this.mainText&&(this.spanMainText=W.append("span",this.bodyDiv,{className:"custominput-maintext",innerHTML:this.mainText})),this.hint&&W.append("span",this.spanMainText||this.bodyDiv,{className:"choicetable-hint",innerHTML:this.hint}),this.table!==!1&&("undefined"==typeof this.table&&(this.table=document.createElement("table"),this.items&&this.buildTable()),this.table.id=this.id,this.className?J.addClass(this.table,this.className):this.table.className="",this.bodyDiv.appendChild(this.table)),this.freeText&&(this.textarea=document.createElement("textarea"),this.textarea.id=this.id+"_text",this.textarea.className=t.className+"-freetext","string"==typeof this.freeText&&(this.textarea.placeholder=this.freeText),this.bodyDiv.appendChild(this.textarea))},t.prototype.listeners=function(){var t=this;e.on("INPUT_DISABLE",function(){t.disable()}),e.on("INPUT_ENABLE",function(){t.enable()})},t.prototype.disable=function(){if(this.disabled===!0||!this.table)return;this.disabled=!0,J.removeClass(this.table,"clickable"),this.table.removeEventListener("click",this.listener),this.emit("disabled")},t.prototype.enable=function(e){if(!this.table||!e&&!this.disabled)return;this.disabled=!1,J.addClass(this.table,"clickable"),this.table.addEventListener("click",this.listener),this.emit("enabled")},t.prototype.verifyChoice=function(e){var t,n,r;r={},e="undefined"==typeof e?!0:e,t=-1,n=this.items.length;for(;++t<n;)r[this.items[t].id]=this.items[t].verifyChoice(e);return r},t.prototype.setCurrentChoice=function(e){var t,n;t=-1,n=this.items[t].length;for(;++t<n;)this.items[t].setCurrentChoice(e)},t.prototype.unsetCurrentChoice=function(e){var t,n;t=-1,n=this.items.length;for(;++t<n;)this.items[t].unsetCurrentChoice(e)},t.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError("ChoiceTableGroup.highlight: border must be string or undefined. Found: "+e);if(!this.table||this.highlighted===!0)return;this.table.style.border=e||"3px solid red",this.highlighted=!0,this.emit("highlighted",e)},t.prototype.unhighlight=function(){if(!this.table||this.highlighted!==!0)return;this.table.style.border="",this.highlighted=!1,this.emit("unhighlighted")},t.prototype.getValues=function(e){var t,n,r,i,s,o;t={id:this.id,order:this.order,items:{},isCorrect:!0},e=e||{},"undefined"==typeof e.highlight&&(e.highlight=!0),o=e.reset,e.reset=!1,n=-1,r=this.items.length;for(;++n<r;)i=this.items[n],t.items[i.id]=i.getValues(e),t.items[i.id].choice===null&&(t.missValues=!0,i.requiredChoice&&(s=!0,t.isCorrect=!1)),t.items[i.id].isCorrect===!1&&e.highlight&&(s=!0);return e.highlight&&s?this.highlight():o&&this.reset(o),e.reset=o,this.textarea&&(t.freetext=this.textarea.value),t},t.prototype.setValues=function(e){var t,n;if(!this.items||!this.items.length)throw new Error("ChoiceTableGroup.setValues: no items found.");e=e||{},t=-1,n=this.items.length;for(;++t<n;)this.items[t].setValues(e);this.textarea&&(this.textarea.value=J.randomString(100,"!Aa0"))},t.prototype.reset=function(e){var t,n;e=e||{},t=-1,n=this.items.length;for(;++t<n;)this.items[t].reset(e);this.textarea&&(this.textarea.value=""),e.shuffleItems&&this.shuffle(),this.isHighlighted()&&this.unhighlight()},t.prototype.shuffle=function(e){var t,n,r,i,s,o,u,a;if(!this.items)return;r=this.items.length;if(!r)return;o=this,a=new Array(r),u=function(e,t,n){var r;r=e.id.split(o.separator),r=o.orientation==="H"?r[2]:r[0],r=o.itemsMap[r],o.items[r].groupOrder=t+1,a[t]=r},t=J.shuffle(this.order);if(this.orientation==="H")J.shuffleElements(this.table,t,u);else{r=this.trs.length;for(n=-1;++n<r;)J.shuffleElements(this.trs[n],t,u),u=undefined}this.order=a}}(node),function(e){"use strict";function t(e){this.options=e,this.listRoot=null,this.submit=null,this.changeEvent="Controls_change",this.hasChanged=!1}function n(e){t.call(this,e)}function r(e){t.call(this,e)}function i(e){t.call(this,e),this.groupName="undefined"!=typeof e.name?e.name:W.generateUniqueId(),this.radioElem=null}e.widgets.register("Controls",t),t.version="0.5.1",t.description="Wraps a collection of user-inputs controls.",t.title="Controls",t.className="controls",t.prototype.add=function(e,t,n){},t.prototype.getItem=function(e,t){},t.prototype.init=function(e){this.hasChanged=!1,"undefined"!=typeof e.change&&(e.change?this.changeEvent=e.change:this.changeEvent=!1),this.list=new W.List(e),this.listRoot=this.list.getRoot(),e.features&&(this.features=e.features,this.populate())},t.prototype.append=function(){var t=this,n="submit_Controls";this.list.parse(),this.bodyDiv.appendChild(this.listRoot),this.options.submit&&(this.options.submit.id&&(n=this.options.submit.id,this.option.submit=this.option.submit.name),this.submit=W.add("button",this.bodyDiv,J.merge(this.options.attributes,{id:n,innerHTML:this.options.submit})),this.submit.onclick=function(){t.options.change&&e.emit(t.options.change)})},t.prototype.parse=function(){return this.list.parse()},t.prototype.populate=function(){var t,n,r,i,s,o=this;for(t in this.features)this.features.hasOwnProperty(t)&&(r=this.features[t],n=t,r.id&&(n=r.id,delete r.id),i=document.createElement("div"),s=this.add(i,n,r),this.changeEvent&&(s.onchange=function(){e.emit(o.changeEvent)}),r.label&&W.add("label",i,{"for":s.id,innerHTML:r.label}),this.list.addDT(i))},t.prototype.listeners=function(){var t=this;e.on(this.changeEvent,function(){t.hasChanged=!0})},t.prototype.refresh=function(){var e,t;for(e in this.features)this.features.hasOwnProperty(e)&&(t=W.getElementById(e),t&&(t.value=this.features[e].value));return!0},t.prototype.getValues=function(){var e,t,n;e={};for(n in this.features)this.features.hasOwnProperty(n)&&(t=W.getElementById(n),t&&(e[n]=Number(t.value)));return e},t.prototype.highlight=function(e){return W.highlight(this.listRoot,e)},n.prototype.__proto__=t.prototype,n.prototype.constructor=n,n.version="0.2.2",n.description="Collection of Sliders.",n.title="Slider Controls",n.className="slidercontrols",n.dependencies={Controls:{}},e.widgets.register("SliderControls",n),n.prototype.add=function(e,t,n){return n=n||{},n.id=t,n.type="range",W.add("input",e,n)},n.prototype.getItem=function(e,t){return t=t||{},t.id=e,W.get("input",t)},r.prototype.__proto__=t.prototype,r.prototype.constructor=r,r.version="0.14",r.description="Collection of jQuery Sliders.",r.title="jQuery Slider Controls",r.className="jqueryslidercontrols",r.dependencies={jQuery:{},Controls:{}},e.widgets.register("jQuerySliderControls",r),r.prototype.add=function(e,t,n){var r=jQuery("<div/>",{id:t}).slider(),i=r.appendTo(e);return i[0]},r.prototype.getItem=function(e,t){var n=jQuery("<div/>",{id:e}).slider();return n},i.prototype.__proto__=t.prototype,i.prototype.constructor=i,i.version="0.1.2",i.description="Collection of Radio Controls.",i.title="Radio Controls",i.className="radiocontrols",i.dependencies={Controls:{}},e.widgets.register("RadioControls",i),i.prototype.populate=function(){var t,n,r,i,s;s=this,this.radioElem||(this.radioElem=document.createElement("radio"),this.radioElem.group=this.name||"radioGroup",this.radioElem.group=this.className||"radioGroup",this.bodyDiv.appendChild(this.radioElem));for(t in this.features)this.features.hasOwnProperty(t)&&(r=this.features[t],n=t,r.id&&(n=r.id,delete r.id),i=this.add(this.radioElem,n,r),this.changeEvent&&(i.onchange=function(){e.emit(s.changeEvent)}),this.list.addDT(i))},i.prototype.add=function(e,t,n){var r;return"undefined"==typeof n.name&&(n.name=this.groupName),n.id=t,n.type="radio",r=W.add("input",e,n),r.appendChild(document.createTextNode(n.label)),r},i.prototype.getItem=function(e,t){return t=t||{},"undefined"==typeof t.name&&(t.name=this.groupName),t.id=e,t.type="radio",W.get("input",t)},i.prototype.getValues=function(){var e,t;for(e in this.features)if(this.features.hasOwnProperty(e)){t=W.getElementById(e);if(t.checked)return t.value}return!1}}(node),function(e){"use strict";function d(){this.input=null,this.placeholder=null,this.inputWidth=null,this.type=null,this.preprocess=null,this.validation=null,this.validationSpeed=500,this.postprocess=null,this.params={},this.errorBox=null,this.mainText=null,this.hint=null,this.requiredChoice=null,this.timeBegin=null,this.timeEnd=null,this.checkbox=null,this.checkboxText=null,this.checkboxCb=null}function v(e,t){var n,r;if("string"==typeof e){e=e==="today"?new Date:new Date(e),r=e.getDate();if(!r)return!1}try{n={day:r||e.getDate(),month:e.getMonth()+1,year:e.getFullYear(),obj:e}}catch(i){return!1}return n.str=(t.dayPos?n.day+t.sep+n.month:n.month+t.sep+n.day)+t.sep,n.str+=t.yearDigits===2?n.year.substring(3,4):n.year,n}function m(e){var t;switch(e){case"usStatesTerrByAbbrLow":return p||(m("usStatesTerrLow"),p=J.reverseObj(o,g)),p;case"usStatesTerrByAbbr":return u||(m("usStatesTerr"),u=J.reverseObj(o)),u;case"usTerrByAbbrLow":return c||(c=J.reverseObj(r,g)),c;case"usTerrByAbbr":return i||(i=J.reverseObj(r)),i;case"usStatesByAbbrLow":return h||(h=J.reverseObj(n,g)),h;case"usStatesByAbbr":return s||(s=J.reverseObj(n)),s;case"usStatesTerrLow":return l||(a||(a=y(n)),f||(f=y(r)),l=J.merge(a,f)),l;case"usStatesTerr":return o||(o=J.merge(n,r)),o;case"usStatesLow":return a||(a=objToLow(n,g)),a;case"usStates":return n;case"usTerrLow":return f||(f=objToLow(r,g)),f;case"usTerr":return r;default:throw new Error("getUsStatesList: unknown request: "+e)}}function g(e,t){return[e.toLowerCase(),t]}function y(e){var t,n;n={};for(t in e)e.hasOwnProperty(t)&&(n[t.toLowerCase()]=e[t]);return n}function b(e){return e.length===5&&J.isInt(e,0)}e.widgets.register("CustomInput",d),d.version="0.9.0",d.description="Creates a configurable input form",d.title=!1,d.panel=!1,d.className="custominput",d.types={text:!0,number:!0,"float":!0,"int":!0,date:!0,list:!0,us_city_state_zip:!0,us_state:!0,us_zip:!0};var t={",":"comma"," ":"space",".":"dot"},n={Alabama:"AL",Alaska:"AK",Arizona:"AZ",Arkansas:"AR",California:"CA",Colorado:"CO",Connecticut:"CT",Delaware:"DE",Florida:"FL",Georgia:"GA",Hawaii:"HI",Idaho:"ID",Illinois:"IL",Indiana:"IN",Iowa:"IA",Kansas:"KS",Kentucky:"KY",Louisiana:"LA",Maine:"ME",Maryland:"MD",Massachusetts:"MA",Michigan:"MI",Minnesota:"MN",Mississippi:"MS",Missouri:"MO",Montana:"MT",Nebraska:"NE",Nevada:"NV","New Hampshire":"NH","New Jersey":"NJ","New Mexico":"NM","New York":"NY","North Carolina":"NC","North Dakota":"ND",Ohio:"OH",Oklahoma:"OK",Oregon:"OR",Pennsylvania:"PA","Rhode Island":"RI","South Carolina":"SC","South Dakota":"SD",Tennessee:"TN",Texas:"TX",Utah:"UT",Vermont:"VT",Virginia:"VA",Washington:"WA","West Virginia":"WV",Wisconsin:"WI",Wyoming:"WY"},r={"American Samoa":"AS","District of Columbia":"DC","Federated States of Micronesia":"FM",Guam:"GU","Marshall Islands":"MH","Northern Mariana Islands":"MP",Palau:"PW","Puerto Rico":"PR","Virgin Islands":"VI"},i,s,o,u,a,f,l,c,h,l,p;d.texts={listErr:"Check that there are no empty items; do not end with the separator",listSizeErr:function(e,t){return e.params.fixedSize?e.params.minItems+" items required":t==="min"?"Too few items. Min: "+e.params.minItems:"Too many items. Max: "+e.params.maxItems},usStateAbbrErr:"Not a valid state abbreviation (must be 2 characters)",usStateErr:"Not a valid state (full name required)",usZipErr:"Not a valid ZIP code (must be 5 digits)",autoHint:function(e){var n,r;if(e.type==="list")r=t[e.params.listSep]||e.params.listSep,n="(if more than one, separate with "+r+")";else if(e.type==="us_state")n=e.params.abbr?"(Use 2-letter abbreviation)":"(Type the full name of the state)";else if(e.type==="us_zip")n="(Use 5-digit ZIP code)";else if(e.type==="us_city_state_zip")r=e.params.listSep,n="(Format: Town"+r+" State"+r+" ZIP code)";else if(e.type==="date")e.params.minDate&&e.params.maxDate?n="(Must be between "+e.params.minDate.str+" and "+e.params.maxDate.str+")":e.params.minDate?n="(Must be after "+e.params.minDate.str+")":e.params.maxDate?n="(Must be before "+e.params.maxDate.str+")":n="(Format: "+e.params.format+")";else if(e.type==="number"||e.type==="int"||e.type==="float")e.params.min&&e.params.max?n="(Must be between "+e.params.min+" and "+e.params.max+")":e.params.min?n="(Must be after "+e.params.min+")":e.params.max&&(n="(Must be before "+e.params.max+")");return e.requiredChoice?(n||"")+" *":n||!1},numericErr:function(e){var t,n;return n=e.params,n.exactly?"Must enter "+n.lower:(t="Must be ",e.type==="float"?t+="a floating point number ":e.type==="int"&&(t+="an integer "),n.between?(t+=(n.leq?"&ge; ":"<")+n.lower,t+=" and ",t+=(n.ueq?"&le; ":"> ")+n.upper):"undefined"!=typeof n.lower?t+=(n.leq?"&ge; ":"< ")+n.lower:t+=(n.ueq?"&le; ":"> ")+n.upper,t)},textErr:function(e,t){var n,r;return r=e.params,n="Must be ",r.exactly?n+="exactly "+(r.lower+1):r.between?n+="between "+r.lower+" and "+r.upper:"undefined"!=typeof r.lower?n+=" more than "+(r.lower-1):"undefined"!=typeof r.upper&&(n+=" less than "+(r.upper+1)),n+=" characters long",r.between&&(n+=" (extremes included)"),n+=". Current length: "+t,n},dateErr:function(e,t){return t==="invalid"?"Date is invalid":t==="min"?"Date must be after "+e.params.minDate.str:t==="max"?"Date must be before "+e.params.maxDate.str:"Must follow format "+e.params.format},emptyErr:function(e){return"Cannot be empty"}},d.dependencies={JSUS:{}},d.prototype.init=function(e){var t,n,r,i,s;n=this,r="CustomInput.init: ",this.requiredChoice=!!e.requiredChoice;if(e.type){if(!d.types[e.type])throw new Error(r+"type not supported: "+e.type);this.type=e.type}else this.type="text";if(e.validation){if("function"!=typeof e.validation)throw new TypeError(r+"validation must be function "+"or undefined. Found: "+e.validation);t=e.validation}else if(this.type==="number"||this.type==="float"||this.type==="int"||this.type==="text"){i=this.type==="text";if("undefined"!=typeof e.min){t=J.isNumber(e.min);if(!1===t)throw new TypeError(r+"min must be number or "+"undefined. Found: "+e.min);this.params.lower=e.min,this.params.leq=!0}if("undefined"!=typeof e.max){t=J.isNumber(e.max);if(!1===t)throw new TypeError(r+"max must be number or "+"undefined. Found: "+e.max);this.params.upper=e.max,this.params.ueq=!0}e.strictlyGreater&&(this.params.leq=!1),e.strictlyLess&&(this.params.ueq=!1);if("undefined"!=typeof this.params.lower&&"undefined"!=typeof this.params.upper){if(this.params.lower>this.params.upper)throw new TypeError(r+"min cannot be greater "+"than max. Found: "+e.min+"> "+e.max);if(this.params.lower===this.params.upper){if(!this.params.leq||!this.params.ueq)throw new TypeError(r+"min cannot be equal to "+"max when strictlyGreater or "+"strictlyLess are set. "+"Found: "+e.min);if(this.type==="int"||this.type==="text")if(J.isFloat(this.params.lower))throw new TypeError(r+"min cannot be a "+"floating point number "+"and equal to "+"max, when type "+'is not "float". Found: '+e.min);this.params.exactly=!0}else this.params.between=!0}if(i){if("undefined"!=typeof this.params.lower){if(this.params.lower<0)throw new TypeError(r+"min cannot be negative "+'when type is "text". Found: '+this.params.lower);this.params.leq||this.params.lower++}if("undefined"!=typeof this.params.upper){if(this.params.upper<0)throw new TypeError(r+"max cannot be negative "+'when type is "text". Found: '+this.params.upper);this.params.ueq||this.params.upper--}t=function(e){var t,r,i,s;r=n.params,t=e.length,i={value:e};if(r.exactly)s=t!==r.lower;else if("undefined"!=typeof r.lower&&t<r.lower||"undefined"!=typeof r.upper&&t>r.upper)s=!0;return s&&(i.err=n.getText("textErr",t)),i},s=function(e){var t,r;return t="undefined"!=typeof n.params.lower?n.params.lower+1:5,r="undefined"!=typeof n.params.upper?n.params.upper:t+5,J.randomString(J.randomInt(t,r))}}else t=function(){var e;return n.type==="float"?e=J.isFloat:n.type==="int"?e=J.isInt:e=J.isNumber,function(t){var r,i;return i=n.params,r=e(t,i.lower,i.upper,i.leq,i.ueq),r!==!1?{value:r}:{value:t,err:n.getText("numericErr")}}}(),s=function(e){var t,r,i;return t=n.params,n.type==="float"?J.random():(r=0,i=10,"undefined"!=typeof t.lower&&(r=t.leq?t.lower-1:t.lower),"undefined"!=typeof t.upper&&(i=t.ueq?t.upper:t.upper-1),J.randomInt(r,i))};this.params.upper&&(this.params.upper<10?this.inputWidth="100px":this.params.upper<20&&(this.inputWidth="200px"))}else if(this.type==="date"){if("undefined"!=typeof e.format){if(e.format!=="mm-dd-yy"&&e.format!=="dd-mm-yy"&&e.format!=="mm-dd-yyyy"&&e.format!=="dd-mm-yyyy"&&e.format!=="mm.dd.yy"&&e.format!=="dd.mm.yy"&&e.format!=="mm.dd.yyyy"&&e.format!=="dd.mm.yyyy"&&e.format!=="mm/dd/yy"&&e.format!=="dd/mm/yy"&&e.format!=="mm/dd/yyyy"&&e.format!=="dd/mm/yyyy")throw new Error(r+"date format is invalid. Found: "+e.format);this.params.format=e.format}else this.params.format="mm/dd/yyyy";this.params.sep=this.params.format.charAt(2),t=this.params.format.split(this.params.sep),this.params.yearDigits=t[2].length,this.params.dayPos=t[0].charAt(0)==="d"?0:1,this.params.monthPos=this.params.dayPos?0:1,this.params.dateLen=t[2].length+6;if(e.minDate){t=v(e.minDate,this.params);if(!t)throw new Error(r+"minDate must be a Date object. "+"Found: "+e.minDate);this.params.minDate=t}if(e.maxDate){t=v(e.maxDate,this.params);if(!t)throw new Error(r+"maxDate must be a Date object. "+"Found: "+e.maxDate);if(this.params.minDate&&this.params.minDate.obj>t.obj)throw new Error(r+"maxDate cannot be prior to "+"minDate. Found: "+t.str+" < "+this.params.minDate.str);this.params.maxDate=t}this.params.yearDigits===2?this.inputWidth="100px":this.inputWidth="150px",this.placeholder=this.params.format,t=function(e){var t,r,i,s,o,u,a;t=n.params,r=e.split(t.sep);if(r.length!==3)return{err:n.getText("dateErr")};if(r[2].length!==t.yearDigits)return{err:n.getText("dateErr")};s={},t.yearDigits===2?(u=-1,a=100):(u=-1,a=1e4),i=J.isInt(r[2],u,a),i!==!1?s.year=i:s.err=!0,i=J.isInt(r[t.monthPos],1,12,1,1),i?s.month=i:s.err=!0,i===1||i===3||i===5||i===7||i===8||i===10||i===12?o=31:i!==2?o=30:o=s.year%4===0&&s.year%100!==0||s.year%400===0?29:28,s.month=i,i=J.isInt(r[t.dayPos],1,o,1,1),i?s.day=i:s.err=!0;if(s.err)s.err=n.getText("dateErr","invalid");else if(t.minDate||t.maxDate)i=new Date(e),t.minDate.obj&&t.minDate.obj>i?s.err=n.getText("dateErr","min"):t.maxDate.obj&&t.maxDate.obj<i&&(s.err=n.getText("dateErr","max"));return s.err||(s.value=e,s={value:s}),s},s=function(e){var t,r,i,s,o,u,a;return t=n.params,r=t.minDate?t.minDate.obj:new Date("01/01/1900"),i=t.maxDate?t.maxDate.obj:undefined,s=J.randomDate(r,i),o=s.getDate(),u=s.getMonth()+1,a=s.getFullYear(),t.yearDigits===2&&(a=(""+a).substr(2)),t.monthPos===0?s=u+t.sep+o:s=o+t.sep+u,s+=t.sep+a,s}}else if(this.type==="us_state")e.abbreviation?(this.params.abbr=!0,this.inputWidth="100px"):this.inputWidth="200px",e.territories!==!1?(this.terr=!0,this.params.abbr?t=m("usStatesTerrByAbbrLow"):t=m("usStatesTerrLow")):this.params.abbr?t=m("usStatesByAbbrLow"):t=m("usStatesLow"),this.params.usStateVal=t,t=function(e){var t;return t={value:e},n.params.usStateVal[e.toLowerCase()]||(t.err=n.getText("usStateErr")),t},s=function(e){return J.randomKey(n.params.usStateVal)};else if(this.type==="us_zip")t=function(e){var t;return t={value:e},b(e)||(t.err=n.getText("usZipErr")),t},s=function(e){return Math.floor(Math.random()*9e4)+1e4};else if(this.type==="list"||this.type==="us_city_state_zip"){if(e.listSeparator){if("string"!=typeof e.listSeparator)throw new TypeError(r+"listSeparator must be "+"string or undefined. Found: "+e.listSeperator);this.params.listSep=e.listSeparator}else this.params.listSep=",";if(this.type==="us_city_state_zip")m("usStatesTerrByAbbr"),this.params.minItems=this.params.maxItems=3,this.params.fixedSize=!0,this.params.itemValidation=function(e,t){if(t===2){if(!u[e.toUpperCase()])return{err:n.getText("usStateAbbrErr")}}else if(t===3&&!b(e))return{err:n.getText("usZipErr")}},this.placeholder="Town"+this.params.listSep+" State"+this.params.listSep+" ZIP";else{if("undefined"!=typeof e.minItems){t=J.isInt(e.minItems,0);if(t===!1)throw new TypeError(r+"minItems must be "+"a positive integer. Found: "+e.minItems);this.params.minItems=t}if("undefined"!=typeof e.maxItems){t=J.isInt(e.maxItems,0);if(t===!1)throw new TypeError(r+"maxItems must be "+"a positive integer. Found: "+e.maxItems);if(this.params.minItems&&this.params.minItems>t)throw new TypeError(r+"maxItems must be larger "+"than minItems. Found: "+t+" < "+this.params.minItems);this.params.maxItems=t}}t=function(e){var t,r,i,s,o;e=e.split(n.params.listSep),r=e.length;if(!r)return e;s=n.params.itemValidation,t=0,i=e[0].trim();if(!i)return{err:n.getText("listErr")};if(s){o=s(i,1);if(o)return o}e[t++]=i;if(r>1){i=e[1].trim();if(!i)return{err:n.getText("listErr")};if(s){o=s(i,t+1);if(o)return o}e[t++]=i}if(r>2){i=e[2].trim();if(!i)return{err:n.getText("listErr")};if(s){o=s(i,t+1);if(o)return o}e[t++]=i}if(r>3)for(;t<r;){i=e[t].trim();if(!i)return{err:n.getText("listErr")};if(s){o=s(i,t+1);if(o)return o}e[t++]=i}return n.params.minItems&&t<n.params.minItems?{err:n.getText("listSizeErr","min")}:n.params.maxItems&&t>n.params.maxItems?{err:n.getText("listSizeErr","max")}:{value:e}},this.type==="us_city_state_zip"?s=function(e){var t;return t=n.params,J.randomString(8)+t.listSep+J.randomKey(t.usStateVal)+t.listSep+Math.floor(Math.random()*9e4)+1e4}:s=function(e){var t,r,i,s;t=n.params,r=J.randomInt(t.minItems,t.maxItems)+1,s="";for(i=0;i<r;i++)i!==0&&(s+=t.listSep+" "),s+=J.randomString(J.randomInt(3,10));return s}}this.validation=function(e){var r;return r={value:e},e.trim()===""?n.requiredChoice&&(r.err=n.getText("emptyErr")):t&&(r=t(e)),r},this._setValues=s;if(e.preprocess){if("function"!=typeof e.preprocess)throw new TypeError(r+"preprocess must be function or "+"undefined. Found: "+e.preprocess);this.preprocess=e.preprocess}else e.preprocess!==!1&&(this.type==="date"?this.preprocess=function(e){var t,r;r=e.value.length,t=n.params.sep,r===2?e.selectionStart===2&&e.value.charAt(1)!==t&&(e.value+=t):r===5?e.selectionStart===5&&e.value.charAt(4)!==t&&e.value.split(t).length-1===1&&(e.value+=t):r>this.params.dateLen&&(e.value=e.value.substring(0,this.params.dateLen))}:(this.type==="list"||this.type==="us_city_state_zip")&&this.params.listSep.trim()!==""&&(this.preprocess=function(e){var t,r;r=e.value.length,t=n.params.listSep,r>1&&r===e.selectionStart&&e.value.charAt(r-1)===t&&e.value.charAt(r-2)!==t&&(e.value+=" ")}));if(e.postprocess){if("function"!=typeof e.postprocess)throw new TypeError(r+"postprocess must be function or "+"undefined. Found: "+e.postprocess);this.postprocess=e.postprocess}if("undefined"!=typeof e.validationSpeed){t=J.isInt(e.valiadtionSpeed,0,undefined,!0);if(t===!1)throw new TypeError(r+"validationSpeed must a non-negative "+"number or undefined. Found: "+e.validationSpeed);this.validationSpeed=t}if(e.mainText){if("string"!=typeof e.mainText)throw new TypeError(r+"mainText must be string or "+"undefined. Found: "+e.mainText);this.mainText=e.mainText}if("undefined"!=typeof e.hint){if(!1!==e.hint&&"string"!=typeof e.hint)throw new TypeError(r+"hint must be a string, false, or "+"undefined. Found: "+e.hint);this.hint=e.hint,this.requiredChoice&&(this.hint+=" *")}else this.hint=this.getText("autoHint");if(e.placeholder){if("string"!=typeof e.placeholder)throw new TypeError(r+"placeholder must be string or "+"undefined. Found: "+e.placeholder);this.placeholder=e.placeholder}if(e.width){if("string"!=typeof e.width)throw new TypeError(r+"width must be string or "+"undefined. Found: "+e.width);this.inputWidth=e.width}if(e.checkboxText){if("string"!=typeof e.checkboxText)throw new TypeError(r+"checkboxText must be string or "+"undefined. Found: "+e.checkboxText);this.checkboxText=e.checkboxText}if(e.checkboxCb){if(!this.checkboxText)throw new TypeError(r+"checkboxCb cannot be defined "+"if checkboxText is not defined");if("function"!=typeof e.checkboxCb)throw new TypeError(r+"checkboxCb must be function or "+"undefined. Found: "+e.checkboxCb);this.checkboxCb=e.checkboxCb}},d.prototype.append=function(){var t,n;t=this,this.mainText&&(this.spanMainText=W.append("span",this.bodyDiv,{className:"custominput-maintext",innerHTML:this.mainText})),this.hint&&W.append("span",this.spanMainText||this.bodyDiv,{className:"custominput-hint",innerHTML:this.hint}),this.input=W.append("input",this.bodyDiv),this.placeholder&&(this.input.placeholder=this.placeholder),this.inputWidth&&(this.input.style.width=this.inputWidth),this.errorBox=W.append("div",this.bodyDiv,{className:"errbox"}),this.input.oninput=function(){t.timeBegin?t.timeEnd=e.timer.getTimeSince("step"):t.timeEnd=t.timeBegin=e.timer.getTimeSince("step"),n&&clearTimeout(n),t.isHighlighted()&&t.unhighlight(),t.preprocess&&t.preprocess(t.input),n=setTimeout(function(){var e;t.validation&&(e=t.validation(t.input.value),e.err&&t.setError(e.err))},t.validationSpeed)},this.input.onclick=function(){t.isHighlighted()&&t.unhighlight()},this.checkboxText&&(this.checkbox=W.append("input",this.bodyDiv,{type:"checkbox",className:"custominput-checkbox"}),W.append("span",this.bodyDiv,{className:"custominput-checkbox-text",innerHTML:this.checkboxText}),this.checkboxCb&&J.addEvent(this.checkbox,"change",function(){t.checkboxCb(t.checkbox.checked,t)}))},d.prototype.setError=function(e){this.errorBox.innerHTML=e,this.highlight()},d.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError("CustomInput.highlight: border must be string or undefined. Found: "+e);if(!this.input||this.highlighted)return;this.input.style.border=e||"3px solid red",this.highlighted=!0,this.emit("highlighted",e)},d.prototype.unhighlight=function(){if(!this.input||this.highlighted!==!0)return;this.input.style.border="",this.highlighted=!1,this.errorBox.innerHTML="",this.emit("unhighlighted")},d.prototype.disable=function(e){if(this.disabled)return;if(!this.isAppended())return;this.disabled=!0,this.input.disabled=!0,this.checkbox&&(!e||e.checkbox!==!1)&&(this.checkbox.disable=!0),this.emit("disabled")},d.prototype.enable=function(e){if(this.disabled!==!0)return;if(!this.isAppended())return;this.disabled=!1,this.input.disabled=!1,this.checkbox&&(!e||e.checkbox!==!1)&&(this.checkbox.disable=!1),this.emit("enabled")},d.prototype.reset=function(){this.input&&(this.input.value=""),this.isHighlighted()&&this.unhighlight(),this.timeBegin=this.timeEnd=null},d.prototype.getValues=function(e){var t,n;return e=e||{},"undefined"==typeof e.markAttempt&&(e.markAttempt=!0),"undefined"==typeof e.highlight&&(e.highlight=!0),t=this.input.value,t=this.validation?this.validation(t):{value:t},n=!t.err,t.timeBegin=this.timeBegin,t.timeEnd=this.timeEnd,this.postprocess&&(t.value=this.postprocess(t.value,n)),n?(e.markAttempt&&(t.isCorrect=!0),e.reset&&this.reset()):(e.highlight&&this.setError(t.err),e.markAttempt&&(t.isCorrect=!1)),this.checkbox&&(t.checked=this.checkbox.checked),t.id=this.id,t},d.prototype.setValues=function(e){var t,n;e&&"undefined"!=typeof e.value?t=e.value:t=this._setValues(e),this.input.value=t,this.preprocess&&this.preprocess(this.input)}}(node),function(e){"use strict";function t(n){this.id=n.id||t.id,this.event=n.event||"D3",this.svg=null;var r=this;e.on(this.event,function(e){r.tick.call(r,e)})}function n(e){var r,i,s;t.call(this,e),this.options=r=J.merge(n.defaults,e),this.n=r.n,this.data=[0],this.margin=r.margin,this.width=r.width-this.margin.left-this.margin.right,this.height=r.height-this.margin.top-this.margin.bottom,this.x=i=d3.scale.linear().domain(r.domain.x).range(r.range.x),this.y=s=d3.scale.linear().domain(r.domain.y).range(r.range.y),this.line=d3.svg.line().x(function(e,t){return i(t)}).y(function(e,t){return s(e)})}e.widgets.register("D3",t),e.widgets.register("D3ts",n),t.prototype.__proto__=e.Widget.prototype,t.prototype.constructor=t,t.defaults={},t.defaults.id="D3",t.defaults.fieldset={legend:"D3 plot"},t.version="0.1",t.description="Real time plots for nodeGame with d3.js",t.dependencies={d3:{},JSUS:{}},t.prototype.append=function(e){return this.root=e,this.svg=d3.select(e).append("svg"),e},t.prototype.tick=function(){},n.id="D3ts",n.version="0.1",n.description="Time series plot for nodeGame with d3.js",n.dependencies={D3:{},JSUS:{}},n.prototype.__proto__=t.prototype,n.prototype.constructor=n,n.defaults={},n.defaults.width=400,n.defaults.height=200,n.defaults.margin={top:10,right:10,bottom:20,left:40},n.defaults.domain={x:[0,10],y:[0,1]},n.defaults.range={x:[0,n.defaults.width],y:[n.defaults.height,0]},n.prototype.init=function(e){console.log("init!");var t=this.x,n=this.y,r=this.height,i=this.width,s=this.margin;this.svg.attr("width",i+s.left+s.right).attr("height",r+s.top+s.bottom).append("g").attr("transform","translate("+s.left+","+s.top+")"),this.svg.append("defs").append("clipPath").attr("id","clip").append("rect").attr("width",i).attr("height",r),this.svg.append("g").attr("class","x axis").attr("transform","translate(0,"+r+")").call(d3.svg.axis().scale(t).orient("bottom")),this.svg.append("g").attr("class","y axis").call(d3.svg.axis().scale(n).orient("left")),this.path=this.svg.append("g").attr("clip-path","url(#clip)").append("path").data([this.data]).attr("class","line").attr("d",this.line)},n.prototype.tick=function(e){this.alreadyInit=this.alreadyInit||!1,this.alreadyInit||(this.init(),this.alreadyInit=!0);var t=this.x;console.log("tick!"),this.data.push(e),this.path.attr("d",this.line).attr("transform",null),this.data.length>this.n&&(this.path.transition().duration(500).ease("linear").attr("transform","translate("+t(-1)+")"),this.data.shift())}}(node),function(e){"use strict";function n(){this.table=null,this.interval=null,this.intervalTime=1e3}var t=W.Table;e.widgets.register("DebugInfo",n),n.version="0.6.2",n.description="Display basic info a client's status.",n.title="Debug Info",n.className="debuginfo",n.dependencies={Table:{}},n.prototype.init=function(t){var n;"number"==typeof t.intervalTime&&(this.intervalTime=t.intervalTime),n=this,this.on("destroyed",function(){clearInterval(n.interval),n.interval=null,e.silly("DebugInfo destroyed.")})},n.prototype.append=function(){var e;this.table=new t,this.bodyDiv.appendChild(this.table.table),this.updateAll(),e=this,this.interval=setInterval(function(){e.updateAll()},this.intervalTime)},n.prototype.updateAll=function(){var t,n,r,i,s,o,u,a,f,l,c,h;if(!this.bodyDiv){e.err("DebugInfo.updateAll: bodyDiv not found.");return}h="-",r=h,n=h,t=e.game.getCurrentGameStage(),t&&(c=e.game.plot.getStep(t),r=c?c.id:"-",n=t.toString()),s=J.getKeyByValue(e.constants.stageLevels,e.game.getStageLevel()),o=J.getKeyByValue(e.constants.stateLevels,e.game.getStateLevel()),u=J.getKeyByValue(e.constants.windowLevels,W.getStateLevel()),i=e.player?e.player.id:h,a=e.errorManager.lastErr||h,l=e.game.settings&&e.game.settings.treatmentName?e.game.settings.treatmentName:h,f=e.socket.connected?"yes":"no",this.table.clear(!0),this.table.addRow(["Treatment: ",l]),this.table.addRow(["Connected: ",f]),this.table.addRow(["Player Id: ",i]),this.table.addRow(["Stage  No: ",n]),this.table.addRow(["Stage  Id: ",r]),this.table.addRow(["Stage Lvl: ",s]),this.table.addRow(["State Lvl: ",o]),this.table.addRow(["Players  : ",e.game.pl.size()]),this.table.addRow(["Win   Lvl: ",u]),this.table.addRow(["Win Loads: ",W.areLoading]),this.table.addRow(["Last  Err: ",a]),this.table.parse()}}(node),function(e){"use strict";function t(){this.buttonsDiv=null,this.hiddenTypes={},this.counterIn=0,this.counterOut=0,this.counterLog=0,this.wall=null,this.wallDiv=null,this.origMsgInCb=null,this.origMsgOutCb=null,this.origLogCb=null}e.widgets.register("DebugWall",t),t.version="1.0.0",t.description="Intercepts incoming and outgoing messages, and logs and prints them numbered and timestamped. Warning! Modifies core functions, therefore its usage in production is not recommended.",t.title="Debug Wall",t.className="debugwall",t.dependencies={JSUS:{}},t.prototype.init=function(t){var n;n=this,t.msgIn!==!1&&(this.origMsgInCb=e.socket.onMessage,e.socket.onMessage=function(t){n.write("in",n.makeTextIn(t)),n.origMsgInCb.call(e.socket,t)}),t.msgOut!==!1&&(this.origMsgOutCb=e.socket.send,e.socket.send=function(t){n.write("out",n.makeTextOut(t)),n.origMsgOutCb.call(e.socket,t)}),t.log!==!1&&(this.origLogCb=e.log,e.log=function(t,r,i){n.write(r||"info",n.makeTextLog(t,r,i)),n.origLogCb.call(e,t,r,i)});if(t.hiddenTypes){if("object"!=typeof hiddenTypes)throw new TypeError("DebugWall.init: hiddenTypes must be object. Found: "+hiddenTypes);this.hiddenTypes=hiddenTypes}this.on("destroyed",function(){n.origLogCb&&(e.log=n.origLogCb),n.origMsgOutCb&&(e.socket.send=n.origMsgOutCb),n.origMsgInCb&&(e.socket.onMessage=n.origMsgInCb)})},t.prototype.append=function(){var e,t,n,r,i,s,o;this.buttonsDiv=W.add("div",this.bodyDiv,{className:"wallbuttonsdiv"}),i=document.createElement("div"),i.role="group",i["aria-label"]="Toggle visibility",i.className="btn-group",e=W.add("button",i,{innerHTML:"Incoming",className:"btn btn-secondary"}),t=W.add("button",i,{innerHTML:"Outgoing",className:"btn btn-secondary"}),n=W.add("button",i,{innerHTML:"Log",className:"btn btn-secondary"}),this.buttonsDiv.appendChild(i),r=this,s=function(e){var t,n,i,s;s="wall_"+e,t=r.wall.getElementsByClassName(s),i=t[0].style.display===""?"none":"";for(n=0;n<t.length;n++)t[n].style.display=i;r.hiddenTypes[e]=!!i},e.onclick=function(){s("in")},t.onclick=function(){s("out")},n.onclick=function(){s("log")},this.wallDiv=W.add("div",this.bodyDiv,{className:"walldiv"}),this.wall=W.add("table",this.wallDiv)},t.prototype.shouldHide=function(e,t){return this.hiddenTypes[e]},t.prototype.write=function(t,n){var r,i,s,o,u,a,f,l;this.isAppended()?(o=t==="in"?++this.counterIn:t==="out"?++this.counterOut:++this.counterLog,a=200,u="wall_"+t,f=W.add("tr",this.wall,{className:u}),t!=="in"&&t!=="out"&&(f.className+=" wall_log"),this.shouldHide(t,n)&&(f.style.display="none"),W.add("td",f,{innerHTML:o}),W.add("td",f,{innerHTML:t}),W.add("td",f,{innerHTML:J.getTimeM()}),l=W.add("td",f),n.length>a?(r=W.add("span",l,{className:u+"_click",innerHTML:n.substr(0,a)}),s=W.add("span",r,{className:u+"_extra",innerHTML:n.substr(a,n.length),id:"wall_"+t+"_"+o,style:{display:"none"}}),i=W.add("span",r,{className:u+"_dots",innerHTML:" ...",id:"wall_"+t+"_"+o}),r.onclick=function(){i.style.display==="none"?(i.style.display="",s.style.display="none"):(i.style.display="none",s.style.display="")}):r=W.add("span",l,{innerHTML:n}),this.wallDiv.scrollTop=this.wallDiv.scrollHeight):e.warn("Wall not appended, cannot write.")},t.prototype.makeTextIn=function(e){var t,n;return n=new Date(e.created),t=n.getHours()+":"+n.getMinutes()+":"+n.getSeconds()+":"+n.getMilliseconds(),t+=" | "+e.to+" | "+e.target+" | "+e.action+" | "+e.text+" | "+e.data,t},t.prototype.makeTextOut=function(e){var t;return t=e.from+" | "+e.target+" | "+e.action+" | "+e.text+" | "+e.data,t},t.prototype.makeTextLog=function(e,t,n){return e}}(node),function(e){"use strict";function t(){this.disconnectButton=null,this.ee=null}e.widgets.register("DisconnectBox",t),t.version="0.2.3",t.description="Visually display current, previous and next stage of the game.",t.title=!1,t.panel=!1,t.className="disconnectbox",t.texts={leave:"Leave Experiment",left:"You Left"},t.dependencies={},t.prototype.append=function(){var t=this;this.disconnectButton=W.add("button",this.bodyDiv,{innerHTML:this.getText("leave"),className:"btn btn-lg"}),this.disconnectButton.onclick=function(){t.disconnectButton.disabled=!0,e.socket.disconnect(),t.disconnectButton.innerHTML=t.getText("left")}},t.prototype.listeners=function(){var t=this;this.ee=e.getCurrentEventEmitter(),this.ee.on("SOCKET_DISCONNECT",function(){}),this.ee.on("SOCKET_CONNECT",function(){t.disconnectButton.disabled&&(t.disconnectButton.disabled=!1,t.disconnectButton.innerHTML=t.getText("leave"))}),this.on("destroyed",function(){t.ee.off("SOCKET_DISCONNECT","DBdiscon"),t.ee.off("SOCKET_CONNECT","DBcon")})}}(node),function(e){"use strict";function t(t){var n;n=this;if("object"==typeof t.button)this.button=t.button;else{if("undefined"!=typeof t.button)throw new TypeError("DoneButton constructor: options.button must be object or undefined. Found: "+t.button);this.button=document.createElement("input"),this.button.type="button"}this.button.onclick=function(){var t;t=e.done(),t&&n.disable()}}e.widgets.register("DoneButton",t),t.version="1.0.0",t.description="Creates a button that if pressed emits node.done().",t.title=!1,t.className="donebutton",t.texts.done="Done",t.dependencies={JSUS:{}},t.prototype.init=function(e){var n;e=e||{};if("undefined"==typeof e.id)n=t.className;else if("string"==typeof e.id)n=e.id;else{if(!1!==e.id)throw new TypeError("DoneButton.init: options.id must be string, false, or undefined. Found: "+e.id);n=""}this.button.id=n;if("undefined"==typeof e.className)n="btn btn-lg btn-primary";else if(e.className===!1)n="";else if("string"==typeof e.className)n=e.className;else{if(!J.isArray(e.className))throw new TypeError("DoneButton.init: options.className must be string, array, or undefined. Found: "+e.className);n=e.className.join(" ")}this.button.className=n,this.button.value="string"==typeof e.text?e.text:this.getText("done")},t.prototype.append=function(){this.bodyDiv.appendChild(this.button)},t.prototype.listeners=function(){var t=this;e.on("PLAYING",function(){var n,r;r=e.game.getCurrentGameStage(),n=e.game.plot.getProperty(r,"donebutton"),n===!1||n&&n.enableOnPlaying===!1?t.disable():t.enable(),"string"==typeof n?t.button.value=n:n&&n.text&&(t.button.value=n.text)})},t.prototype.disable=function(){this.button.disabled="disabled"},t.prototype.enable=function(){this.button.disabled=!1}}(node),function(e){"use strict";function t(e){if(!e.onsubmit)this.onsubmit={emailOnly:!0,send:!0,updateUI:!0};else{if("object"!=typeof e.onsubmit)throw new TypeError("EmailForm constructor: options.onsubmit must be string or object. Found: "+e.onsubmit);this.onsubmit=e.onsubmit}this._email=e.email||null,this.attempts=[],this.timeInput=null,this.formElement=null,this.inputElement=null,this.buttonElement=null,this.setMsg=!!e.setMsg||!1}function n(){return this.inputElement?this.inputElement.value:this._email}e.widgets.register("EmailForm",t),t.version="0.12.0",t.description="Displays a configurable email form.",t.title="Email",t.className="emailform",t.texts.label="Enter your email:",t.texts.errString="Not a valid email address, please correct it and submit it again.",t.dependencies={JSUS:{}},t.prototype.createForm=function(){var e,t,n,r,i;return e=this,t=document.createElement("form"),t.className="emailform-form",n=document.createElement("label"),n.innerHTML=this.getText("label"),r=document.createElement("input"),r.setAttribute("type","text"),r.setAttribute("placeholder","Email"),r.className="emailform-input form-control",i=document.createElement("input"),i.setAttribute("type","submit"),i.setAttribute("value","Submit email"),i.className="btn btn-lg btn-primary emailform-submit",t.appendChild(n),t.appendChild(r),t.appendChild(i),J.addEvent(t,"submit",function(t){t.preventDefault(),e.getValues(e.onsubmit)},!0),J.addEvent(t,"input",function(t){e.timeInput||(e.timeInput=J.now()),e.isHighlighted()&&e.unhighlight()},!0),this.formElement=t,this.inputElement=r,this.buttonElement=i,this._email&&(this.formElement.value=this._email),this._email=null,t},t.prototype.verifyInput=function(e,t){var r,i;return r=n.call(this),i=J.isEmail(r),i&&t?(this.inputElement&&(this.inputElement.disabled=!0),this.buttonElement&&(this.buttonElement.disabled=!0,this.buttonElement.value="Sent!")):(t&&this.buttonElement&&(this.buttonElement.value=this.getText("errString")),("undefined"==typeof e||e)&&this.attempts.push(r)),i},t.prototype.append=function(){this.createForm(),this.bodyDiv.appendChild(this.formElement)},t.prototype.setValues=function(e){var t;e=e||{},e.email?t=e.email:t=J.randomEmail(),this.inputElement?this.inputElement.value=t:this._email=t,this.timeInput=J.now()},t.prototype.getValues=function(e){var t,r;return e=e||{},"undefined"!=typeof e.say&&(console.log("***EmailForm.getValues: option say is deprecated,  use send.***"),e.send=e.say),"undefined"!=typeof e.sayAnyway&&(console.log("***EmailForm.getValues: option sayAnyway is deprecated, use sendAnyway.***"),e.sendAnyway=e.sayAnyway),"undefined"==typeof e.markAttempt&&(e.markAttempt=!0),"undefined"==typeof e.highlight&&(e.highlight=!0),t=n.call(this),e.verify!==!1&&(r=this.verifyInput(e.markAttempt,e.updateUI)),e.emailOnly||(t={time:this.timeInput,email:t,attempts:this.attempts},e.markAttempt&&(t.isCorrect=r)),r===!1&&((e.updateUI||e.highlight)&&this.highlight(),this.timeInput=null),(e.send&&r||e.sendAnyway)&&this.sendValues({values:t}),e.reset&&this.reset(),t},t.prototype.sendValues=function(t){var n;return t=t||{emailOnly:!0},n=t.values||this.getValues(t),this.setMsg?("string"==typeof n&&(n={email:n}),e.set(n,t.to||"SERVER")):e.say("email",t.to||"SERVER",n),n},t.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError("EmailForm.highlight: border must be string or undefined. Found: "+e);if(!this.inputElement||this.highlighted===!0)return;this.inputElement.style.border=e||"3px solid red",this.highlighted=!0,this.emit("highlighted",e)},t.prototype.unhighlight=function(){if(!this.inputElement||this.highlighted!==!0)return;this.inputElement.style.border="",this.highlighted=!1,this.emit("unhighlighted")},t.prototype.reset=function(){this.attempts=[],this.timeInput=null,this._email=null,this.inputElement&&(this.inputElement.value=""),this.isHighlighted()&&this.unhighlight()}}(node),function(e){"use strict";function t(e){if(e.email===!1)e.showEmailForm=!1;else if("undefined"==typeof e.showEmailForm)this.showEmailForm=!0;else{if("boolean"!=typeof e.showEmailForm)throw new TypeError("EndScreen constructor: options.showEmailForm must be boolean or undefined. Found: "+e.showEmailForm);this.showEmailForm=e.showEmailForm}if(e.feedback===!1)e.showFeedbackForm=!1;else if("undefined"==typeof e.showFeedbackForm)this.showFeedbackForm=!0;else{if("boolean"!=typeof e.showFeedbackForm)throw new TypeError("EndScreen constructor: options.showFeedbackForm must be boolean or undefined. Found: "+e.showFeedbackForm);this.showFeedbackForm=e.showFeedbackForm}if(e.totalWin===!1)e.showTotalWin=!1;else if("undefined"==typeof e.showTotalWin)this.showTotalWin=!0;else{if("boolean"!=typeof e.showTotalWin)throw new TypeError("EndScreen constructor: options.showTotalWin must be boolean or undefined. Found: "+e.showTotalWin);this.showTotalWin=e.showTotalWin}if(e.exitCode===!1)e.showExitCode!==!1;else if("undefined"==typeof e.showExitCode)this.showExitCode=!0;else{if("boolean"!=typeof e.showExitCode)throw new TypeError("EndScreen constructor: options.showExitCode must be boolean or undefined. Found: "+e.showExitCode);this.showExitCode=e.showExitCode}if("undefined"==typeof e.totalWinCurrency)this.totalWinCurrency="USD";else{if("string"!=typeof e.totalWinCurrency||e.totalWinCurrency.trim()==="")throw new TypeError("EndScreen constructor: options.totalWinCurrency must be undefined or a non-empty string. Found: "+e.totalWinCurrency);this.totalWinCurrency=e.totalWinCurrency}if(e.totalWinCb){if("function"!=typeof e.totalWinCb)throw new TypeError("EndScreen constructor: options.totalWinCb must be function or undefined. Found: "+e.totalWinCb);this.totalWinCb=e.totalWinCb}this.emailForm=null,this.feedback=null,this.endScreenHTML=null,this.askServer=e.askServer||!1}e.widgets.register("EndScreen",t),t.version="0.6.0",t.description="Game end screen. With end game message, email form, and exit code.",t.title="End Screen",t.className="endscreen",t.texts.headerMessage="Thank you for participating!",t.texts.message="You have now completed this task and your data has been saved. Please go back to the Amazon Mechanical Turk web site and submit the HIT.",t.texts.contactQuestion="Would you like to be contacted againfor future experiments? If so, leaveyour email here and press submit: ",t.texts.totalWin="Your total win:",t.texts.exitCode="Your exit code:",t.texts.errTotalWin="Error: invalid total win.",t.texts.errExitCode="Error: invalid exit code.",t.texts.copyButton="Copy",t.texts.exitCopyMsg="Exit code copied to clipboard.",t.texts.exitCopyError="Failed to copy exit code. Please copy it manually.",t.dependencies={JSUS:{},Feedback:{},EmailForm:{}},t.prototype.init=function(t){this.showEmailForm&&!this.emailForm&&(this.emailForm=e.widgets.get("EmailForm",J.mixin({label:this.getText("contactQuestion"),onsubmit:{say:!0,emailOnly:!0,updateUI:!0},storeRef:!1},t.email))),this.showFeedbackForm&&(this.feedback=e.widgets.get("Feedback",J.mixin({storeRef:!1},t.feedback)))},t.prototype.append=function(){this.endScreenHTML=this.makeEndScreen(),this.bodyDiv.appendChild(this.endScreenHTML),this.askServer&&setTimeout(function(){e.say("WIN")})},t.prototype.makeEndScreen=function(){var t,n,r,i,s,o,u,a,f,l,c,h=this;return t=document.createElement("div"),t.className="endscreen",n=document.createElement("h1"),n.innerHTML=this.getText("headerMessage"),t.appendChild(n),r=document.createElement("p"),r.innerHTML=this.getText("message"),t.appendChild(r),this.showTotalWin&&(i=document.createElement("div"),s=document.createElement("p"),s.innerHTML="<strong>"+this.getText("totalWin")+"</strong>",o=document.createElement("input"),o.className="endscreen-total form-control",o.setAttribute("disabled","true"),s.appendChild(o),i.appendChild(s),t.appendChild(i),this.totalWinInputElement=o),this.showExitCode&&(u=document.createElement("div"),u.className="input-group",a=document.createElement("span"),a.innerHTML="<strong>"+this.getText("exitCode")+"</strong>",f=document.createElement("input"),f.id="exit_code",f.className="endscreen-exit-code form-control",f.setAttribute("disabled","true"),c=document.createElement("span"),c.className="input-group-btn",l=document.createElement("button"),l.className="btn btn-default endscreen-copy-btn",l.innerHTML=this.getText("copyButton"),l.type="button",l.onclick=function(){h.copy(f.value)},c.appendChild(l),t.appendChild(a),u.appendChild(c),u.appendChild(f),t.appendChild(u),this.exitCodeInputElement=f),this.showEmailForm&&e.widgets.append(this.emailForm,t,{title:!1,panel:!1}),this.showFeedbackForm&&e.widgets.append(this.feedback,t,{title:!1,panel:!1}),t},t.prototype.listeners=function(){var t;t=this,e.on.data("WIN",function(e){t.updateDisplay(e.data)})},t.prototype.copy=function(e){var t=document.createElement("input");try{document.body.appendChild(t),t.value=e,t.select(),document.execCommand("copy",!1),t.remove(),alert(this.getText("exitCopyMsg"))}catch(n){alert(this.getText("exitCopyError"))}},t.prototype.updateDisplay=function(t){var n,r,i,s,o,u,a,f;if(this.totalWinCb)r=this.totalWinCb(t,this);else{if("undefined"==typeof t.total&&"undefined"==typeof t.totalRaw)throw new Error("EndScreen.updateDisplay: data.total and data.totalRaw cannot be both undefined.");"undefined"!=typeof t.total&&(r=J.isNumber(t.total,0),r===!1&&(e.err("EndScreen.updateDisplay: invalid data.total: "+t.total),r=this.getText("errTotalWin"),f=!0)),t.partials&&(J.isArray(t.partials)?n=t.partials.join(" + "):e.err("EndScreen error, invalid partials win: "+t.partials)),"undefined"!=typeof t.totalRaw&&(n?n+=" = ":n="",n+=t.totalRaw,a="undefined"!=typeof t.exchangeRate?t.exchangeRate:e.game.settings.EXCHANGE_RATE,"undefined"!=typeof a&&(n+="*"+a),"undefined"==typeof r&&(i=J.isNumber(t.totalRaw,0),r=parseFloat(a*t.totalRaw).toFixed(2),r=J.isNumber(r,0),r===!1&&(e.err("EndScreen.updateDisplay: invalid : totalWin calculation from totalRaw."),r=this.getText("errTotalWin"),f=!0)),f||(r=n+" = "+r)),f||(r+=" "+this.totalWinCurrency)}s=t.exit,"string"!=typeof s&&(e.err("EndScreen error, invalid exit code: "+s),s=this.getText("errExitCode")),o=this.totalWinInputElement,u=this.exitCodeInputElement,o&&this.showTotalWin&&(o.value=r),u&&this.showExitCode&&(u.value=s)}}(node),function(e){"use strict";function i(e){var t;"undefined"!=typeof e.maxLength&&(console.log("***Feedback constructor: maxLength is deprecated, use maxChars instead***"),e.maxChars=e.maxLength),"undefined"!=typeof e.minLength&&(console.log("***Feedback constructor: minLength is deprecated, use minChars instead***"),e.minChars=e.minLength),this.mainText=null,this.hint=null,this.spanMainText=null;if("undefined"==typeof e.maxChars)this.maxChars=0;else{t=J.isInt(e.maxChars,0);if(t===!1)throw new TypeError("Feedback constructor: maxChars must be an integer >= 0 or undefined. Found: "+e.maxChars);this.maxChars=t}if("undefined"==typeof e.minChars)this.minChars=0;else{t=J.isInt(e.minChars,0,undefined,!0);if(t===!1)throw new TypeError("Feedback constructor: minChars must be an integer >= 0 or undefined. Found: "+e.minChars);if(this.maxChars&&t>this.maxChars)throw new TypeError("Feedback constructor: minChars cannot be greater than maxChars. Found: "+t+" > "+this.maxChars);this.minChars=t}if("undefined"==typeof e.maxWords)this.maxWords=0;else{t=J.isInt(e.maxWords,0,undefined,!0);if(t===!1)throw new TypeError("Feedback constructor: maxWords must be an integer >= 0 or undefined. Found: "+e.maxWords);this.maxWords=e.maxWords}if("undefined"==typeof e.minWords)this.minWords=0;else{t=J.isInt(e.minWords,0,undefined,!0);if(t===!1)throw new TypeError("Feedback constructor: minWords must be an integer >= 0 or undefined. Found: "+e.minWords);this.minWords=e.minWords;if(this.maxChars){t=(this.maxChars+1)/2;if(this.minWords>t)throw new TypeError("Feedback constructor: minWords cannot be larger than (maxChars+1)/2. Found: "+this.minWords+" > "+t)}}if(this.maxWords){if(this.maxChars&&this.maxChars<this.maxWords)throw new TypeError("Feedback constructor: maxChars cannot be smaller than maxWords. Found: "+this.maxChars+" > "+this.maxWords);if(this.minChars>this.maxWords)throw new TypeError("Feedback constructor: minChars cannot be greater than maxWords. Found: "+this.minChars+" > "+this.maxWords)}if("undefined"==typeof e.rows)this.rows=3;else{if(J.isInt(e.rows,0)===!1)throw new TypeError("Feedback constructor: rows must be an integer > 0 or undefined. Found: "+e.rows);this.rows=e.rows}if("undefined"==typeof e.maxAttemptLength)this.maxAttemptLength=0;else{t=J.isNumber(e.maxAttemptLength,0);if(t===!1)throw new TypeError("Feedback constructor: options.maxAttemptLength must be a number > 0 or undefined. Found: "+e.maxAttemptLength);this.maxAttemptLength=t}this.showSubmit="undefined"==typeof e.showSubmit?!0:!!e.showSubmit;if(!e.onsubmit)this.onsubmit={feedbackOnly:!0,say:!0,updateUI:!0};else{if("object"!=typeof e.onsubmit)throw new TypeError("Feedback constructor: onsubmit must be string or object. Found: "+e.onsubmit);this.onsubmit=e.onsubmit}this._feedback=e.feedback||null,this.attempts=[],this.timeInputBegin=null,this.feedbackForm=null,this.textareaElement=null,this.charCounter=null,this.wordCounter=null,this.submitButton=null,this.setMsg=!!e.setMsg||!1}function s(){var e;return e=this.textareaElement?this.textareaElement.value:this._feedback,e?e.trim():e}e.widgets.register("Feedback",i),i.version="1.6.0",i.description="Displays a configurable feedback form",i.title="Feedback",i.className="feedback",i.texts={autoHint:function(e){var t,n;return e.minChars&&e.maxChars?t="between "+e.minChars+" and "+e.maxChars+" characters":e.minChars?(t="at least "+e.minChars+" character",e.minChars>1&&(t+="s")):e.maxChars&&(t="at most "+e.maxChars+" character",e.maxChars>1&&(t+="s")),e.minWords&&e.maxWords?n="beetween "+e.minWords+" and "+e.maxWords+" words":e.minWords?(n="at least "+e.minWords+" word",e.minWords>1&&(t+="s")):e.maxWords&&(n="at most "+e.maxWords+" word",e.maxWords>1&&(t+="s")),t?(t="("+t,n&&(t+=", and "+n),t+")"):n?"("+n+")":!1},submit:"Submit feedback",label:"Any feedback? Let us know here:",sent:"Sent!",counter:function(e,t){var n;return n=t.chars?" character":" word",t.len!==1&&(n+="s"),t.needed?n+=" needed":t.over?n+=" over":t.justcount||(n+=" remaining"),n}};var t,n,r;t="#a32020",n="#a32020",r="#78b360",i.dependencies={JSUS:{}},i.prototype.init=function(e){if("string"==typeof e.mainText)this.mainText=e.mainText;else{if("undefined"!=typeof e.mainText)throw new TypeError("Feedback.init: options.mainText must be string or undefined. Found: "+e.mainText);this.mainText=this.getText("label")}if("string"==typeof e.hint||!1===e.hint)this.hint=e.hint;else{if("undefined"!=typeof e.hint)throw new TypeError("Feedback.init: options.hint must be a string, false, or undefined. Found: "+e.hint);this.hint=this.getText("autoHint")}},i.prototype.verifyFeedback=function(e,i){var o,u,a,f,l,c,h,p,d,v,m;return o=s.call(this),u=o?o.length:0,f=this.submitButton,l=this.charCounter,c=this.wordCounter,a=!0,u<this.minChars?(a=!1,h=this.minChars-u,p=h+this.getText("counter",{chars:!0,needed:!0,len:h}),d=t):this.maxChars&&u>this.maxChars?(a=!1,h=u-this.maxChars,p=h+this.getText("counter",{chars:!0,over:!0,len:h}),d=n):(h=this.maxChars?this.maxChars-u:u,p=h+this.getText("counter",{chars:!0,len:h,justcount:!this.maxChars}),d=r),c&&(h=o?o.match(/\b[-?(\w+)?]+\b/gi):0,u=h?h.length:0,u<this.minWords?(a=!1,h=h=this.minWords-u,v=h+this.getText("counter",{needed:!0,len:h}),m=t):this.maxWords&&u>this.maxWords?(a=!1,h=u-this.maxWords,v=h+this.getText("counter",{over:!0,len:h}),m=n):(h=this.maxWords?this.maxWords-u:u,v=h+this.getText("counter",{len:h,justcount:!this.maxWords}),m=r)),i&&(f&&(f.disabled=!a),l&&(l.style.backgroundColor=d,l.innerHTML=p),c&&(c.style.backgroundColor=m,c.innerHTML=v)),!a&&("undefined"==typeof e||e)&&(this.maxAttemptLength&&u>this.maxAttemptLength&&(o=o.substr(0,this.maxAttemptLength)),this.attempts.push(o)),a},i.prototype.append=function(){var e,t;e=this,this.feedbackForm=W.append("form",this.bodyDiv,{className:"feedback-form"}),this.mainText&&(this.spanMainText=W.append("span",this.feedbackForm,{className:"feedback-maintext",innerHTML:this.mainText})),this.hint&&W.append("span",this.spanMainText||this.feedbackForm,{className:"feedback-hint",innerHTML:this.hint}),this.textareaElement=W.append("textarea",this.feedbackForm,{className:"form-control feedback-textarea",type:"text",rows:this.rows}),this.showSubmit&&(this.submitButton=W.append("input",this.feedbackForm,{className:"btn btn-lg btn-primary",type:"submit",value:this.getText("submit")}),J.addEvent(this.feedbackForm,"submit",function(t){t.preventDefault(),e.getValues(e.onsubmit)})),this.showCounters(),J.addEvent(this.feedbackForm,"input",function(t){e.isHighlighted()&&e.unhighlight(),e.verifyFeedback(!1,!0)}),J.addEvent(this.feedbackForm,"click",function(t){e.isHighlighted()&&e.unhighlight()}),this.verifyFeedback(!1,!0)},i.prototype.setValues=function(e){var t,n;e=e||{},e.feedback?t=e.feedback:(this.maxChars?n=this.maxChars:this.maxWords&&(n=this.maxWords*4),t=J.randomString(J.randomInt(0,n),"aA_1")),this.textareaElement?this.textareaElement.value=t:this._feedback=t,this.timeInputBegin=J.now()},i.prototype.getValues=function(e){var t,n,r;return e=e||{},"undefined"!=typeof e.say&&(console.log("***EmailForm.getValues: option say is deprecated,  use send.***"),e.send=e.say),"undefined"!=typeof e.sayAnyway&&(console.log("***EmailForm.getValues: option sayAnyway is deprecated, use sendAnyway.***"),e.sendAnyway=e.sayAnyway),"undefined"==typeof e.markAttempt&&(e.markAttempt=!0),"undefined"==typeof e.highlight&&(e.highlight=!0),t=s.call(this),e.keepBreaks&&(t=t.replace(/\n\r?/g,"<br />")),e.verify!==!1&&(r=this.verifyFeedback(e.markAttempt,e.updateUI)),r===!1&&(e.updateUI||e.highlight)&&this.highlight(),e.feedbackOnly||(t={timeBegin:this.timeInputBegin,feedback:t,attempts:this.attempts,valid:r},e.markAttempt&&(t.isCorrect=r)),t!==""&&(e.send&&r||e.sendAnyway)&&(this.sendValues({values:t}),e.updateUI&&(this.submitButton.setAttribute("value",this.getText("sent")),this.submitButton.disabled=!0,this.textareaElement.disabled=!0)),e.reset&&this.reset(),t},i.prototype.sendValues=function(t){var n;return t=t||{feedbackOnly:!0},n=t.values||this.getValues(t),this.setMsg?("string"==typeof n&&(n={feedback:n}),e.set(n,t.to||"SERVER")):e.say("feedback",t.to||"SERVER",n),n},i.prototype.highlight=function(e){if(e&&"string"!=typeof e)throw new TypeError("Feedback.highlight: border must be string or undefined. Found: "+e);if(!this.isAppended()||this.highlighted===!0)return;this.textareaElement.style.border=e||"3px solid red",this.highlighted=!0,this.emit("highlighted",e)},i.prototype.unhighlight=function(){if(!this.isAppended()||this.highlighted!==!0)return;this.textareaElement.style.border="",this.highlighted=!1,this.emit("unhighlighted")},i.prototype.reset=function(){this.attempts=[],this.timeInputBegin=null,this._feedback=null,this.textareaElement&&(this.textareaElement.value=""),this.isHighlighted()&&this.unhighlight()},i.prototype.disable=function(){if(!this.textareaElement||this.textareaElement.disabled)return;this.disabled=!0,this.submitElement&&(this.submitElement.disabled=!0),this.textareaElement.disabled=!0,this.emit("disabled")},i.prototype.enable=function(){if(!this.textareaElement||!this.textareaElement.disabled)return;this.disabled=!1,this.submitElement&&(this.submitElement.disabled=!1),this.textareaElement.disabled=!1,this.emit("enabled")},i.prototype.showCounters=function(){if(!this.charCounter){if(this.minChars||this.maxChars)this.charCounter=W.append("span",this.feedbackForm,{className:"feedback-char-count badge",innerHTML:this.maxChars})}else this.charCounter.style.display="";if(!this.wordCounter){if(this.minWords||this.maxWords)this.wordCounter=W.append("span",this.feedbackForm,{className:"feedback-char-count badge",innerHTML:this.maxWords}),this.charCounter&&(this.wordCounter.style["margin-left"]="10px")}else this.wordCounter.style.display=""},i.prototype.hideCounters=function(){this.charCounter&&(this.charCounter.style.display="none"),this.wordCounter&&(this.wordCounter.style.display="none")}}(node),function(e){"use strict";function t(t){var n=this;this.options=t,this.availableLanguages={en:{name:"English",nativeName:"English",shortName:"en"}},this.currentLanguage=null,this.buttonListLength=null,this.displayForm=null,this.optionsLabel={},this.optionsDisplay={},this.loadingDiv=null,this.languagesLoaded=!1,this.usingButtons=!0,this.updatePlayer="ondone",this.setUriPrefix=!0,this.notifyServer=!0,this.onLangCallback=function(t){function i(e){return function(){n.setLanguage(e,n.updatePlayer==="onselect")}}var r;while(n.displayForm.firstChild)n.displayForm.removeChild(n.displayForm.firstChild);n.availableLanguages=t.data;if(n.usingButtons)for(r in t.data)t.data.hasOwnProperty(r)&&(n.optionsLabel[r]=W.get("label",{id:r+"Label","for":r+"RadioButton"}),n.optionsDisplay[r]=W.get("input",{id:r+"RadioButton",type:"radio",name:"languageButton",value:t.data[r].name}),n.optionsDisplay[r].onclick=i(r),n.optionsLabel[r].appendChild(n.optionsDisplay[r]),n.optionsLabel[r].appendChild(document.createTextNode(t.data[r].nativeName)),W.add("br",n.displayForm),n.optionsLabel[r].className="unselectedButtonLabel",n.displayForm.appendChild(n.optionsLabel[r]));else{n.displaySelection=W.get("select","selectLanguage");for(r in t.data)n.optionsLabel[r]=document.createTextNode(t.data[r].nativeName),n.optionsDisplay[r]=W.get("option",{id:r+"Option",value:r}),n.optionsDisplay[r].appendChild(n.optionsLabel[r]),n.displaySelection.appendChild(n.optionsDisplay[r]);n.displayForm.appendChild(n.displaySelection),n.displayForm.onchange=function(){n.setLanguage(n.displaySelection.value,n.updatePlayer==="onselect")}}n.loadingDiv.style.display="none",n.languagesLoaded=!0,n.setLanguage(e.player.lang.shortName||"en",!1),n.onLangCallbackExtension&&(n.onLangCallbackExtension(t),n.onLangCallbackExtension=null)},this.onLangCallbackExtension=null}e.widgets.register("LanguageSelector",t),t.version="0.6.2",t.description="Display information about the current language and allows to change language.",t.title="Language",t.className="languageselector",t.texts.loading="Loading language information...",t.dependencies={JSUS:{}},t.prototype.init=function(t){J.mixout(t,this.options),this.options=t,"undefined"!=typeof this.options.usingButtons&&(this.usingButtons=!!this.options.usingButtons);if("undefined"!=typeof this.options.notifyServer)if(!1===this.options.notifyServer)this.options.notifyServer="never";else{if("string"!=typeof this.options.notifyServer)throw new Error("LanguageSelector.init: options.notifyServer must be "+this.options.notifyServer);if("never"!==this.options.notifyServer&&"onselect"!==this.options.notifyServer&&"ondone"!==this.options.notifyServer)throw new Error('LanguageSelector.init: invalid value for notifyServer: "'+this.options.notifyServer+'". Valid '+'values: "never","onselect", "ondone".');this.notifyServer=this.options.notifyServer}"undefined"!=typeof this.options.setUriPrefix&&(this.setUriPrefix=!!this.options.setUriPrefix),e.on.lang(this.onLangCallback),this.displayForm=W.get("form","radioButtonForm"),this.loadingDiv=W.add("div",this.displayForm),this.loadingDiv.innerHTML=this.getText("loading"),this.loadLanguages()},t.prototype.append=function(){this.bodyDiv.appendChild(this.displayForm)},t.prototype.setLanguage=function(t,n){this.usingButtons&&this.currentLanguage!==null&&this.currentLanguage!==this.availableLanguages[t]&&(this.optionsDisplay[this.currentLanguage].checked="unchecked",this.optionsLabel[this.currentLanguage].className="unselectedButtonLabel"),this.currentLanguage=t,this.usingButtons?(this.optionsDisplay[this.currentLanguage].checked="checked",this.optionsLabel[this.currentLanguage].className="selectedButtonLabel"):this.displaySelection.value=this.currentLanguage,n!==!1&&e.setLanguage(this.availableLanguages[this.currentLanguage],this.setUriPrefix,this.notifyServer)},t.prototype.updateAvalaibleLanguages=function(t){t&&t.callback&&(this.onLangCallbackExtension=t.callback),e.socket.send(e.msg.create({target:"LANG",to:"SERVER",action:"get"}))},t.prototype.loadLanguages=function(e){this.languagesLoaded?e&&e.callback&&e.callback():this.updateAvalaibleLanguages(e)},t.prototype.listeners=function(){var t;t=this,e.events.step.on("REALLY_DONE",function(){t.updatePlayer==="ondone"&&e.setLanguage(t.availableLanguages[t.currentLanguage],t.setUriPrefix,t.notifyServer)})}}(node),function(e){"use strict";function t(e){this.spanCurrency=null,this.spanMoney=null,this.currency="ECU",this.money=0,this.precision=2,this.showCurrency=!0,this.classnameCurrency="moneytalkscurrency",this.classnameMoney="moneytalksmoney"}e.widgets.register("MoneyTalks",t),t.version="0.4.0",t.description="Displays the earnings of a player.",t.title="Earnings",t.className="moneytalks",t.dependencies={JSUS:{}},t.prototype.init=function(e){"string"==typeof e.currency&&(this.currency=e.currency),"undefined"!=typeof e.showCurrency&&(this.showCurrency=!!e.showCurrency),"number"==typeof e.money&&(this.money=e.money),"number"==typeof e.precision&&(this.precision=e.precision),"string"==typeof e.MoneyClassName&&(this.classnameMoney=e.MoneyClassName),"string"==typeof e.currencyClassName&&(this.classnameCurrency=e.currencyClassName)},t.prototype.append=function(){this.spanMoney||(this.spanMoney=document.createElement("span")),this.spanCurrency||(this.spanCurrency=document.createElement("span")),this.showCurrency||(this.spanCurrency.style.display="none"),this.spanMoney.className=this.classnameMoney,this.spanCurrency.className=this.classnameCurrency,this.spanCurrency.innerHTML=this.currency,this.spanMoney.innerHTML=this.money,this.bodyDiv.appendChild(this.spanMoney),this.bodyDiv.appendChild(this.spanCurrency)},t.prototype.listeners=function(){var t=this;e.on("MONEYTALKS",function(e,n){t.update(e,n)})},t.prototype.update=function(t,n){var r;r=J.isNumber(t);if(r===!1){e.err("MoneyTalks.update: invalid amount: "+t);return}n&&(this.money=0),this.money+=r,this.spanMoney.innerHTML=this.money.toFixed(this.precision)},t.prototype.getValues=function(){return this.money}}(node),function(e){"use strict";function t(e){this.methods={},this.method="I-PANAS-SF",this.gauge=null,this.addMethod("I-PANAS-SF",r)}function n(e,t){if(!t)throw new Error("MoodGauge.init: method "+e+"did not create element gauge.");if("function"!=typeof t.getValues)throw new Error("MoodGauge.init: method "+e+": gauge missing function getValues.");if("function"!=typeof t.enable)throw new Error("MoodGauge.init: method "+e+": gauge missing function enable.");if("function"!=typeof t.disable)throw new Error("MoodGauge.init: method "+e+": gauge missing function disable.");if("function"!=typeof t.append)throw new Error("MoodGauge.init: method "+e+": gauge missing function append.")}function r(t){var n,r,i,s,o,u,a,f;i=t.choices||["1","2","3","4","5"],r=t.emotions||["Upset","Hostile","Alert","Ashamed","Inspired","Nervous","Determined","Attentive","Afraid","Active"],s=t.left||"never",o=t.right||"always",f=r.length,n=new Array(f),a=-1;for(;++a<f;)n[a]={id:r[a],left:'<span class="emotion">'+r[a]+":</span> never",right:o,choices:i};return u=e.widgets.get("ChoiceTableGroup",{id:"ipnassf",items:n,mainText:this.getText("mainText"),title:!1,requiredChoice:!0,storeRef:!1}),u}e.widgets.register("MoodGauge",t),t.version="0.3.0",t.description="Displays an interface to measure mood and emotions.",t.title="Mood Gauge",t.className="moodgauge",t.texts.mainText="Thinking about yourself and how you normally feel, to what extent do you generally feel: ",t.dependencies={JSUS:{}},t.prototype.init=function(e){var t;if("undefined"!=typeof e.method){if("string"!=typeof e.method)throw new TypeError("MoodGauge.init: options.method must be string or undefined: "+e.method);if(!this.methods[e.method])throw new Error("MoodGauge.init: options.method is not a valid method: "+e.method);this.method=e.method}t=this.methods[this.method].call(this,e),n(this.method,t),this.gauge=t,this.on("enabled",function(){t.enable()}),this.on("disabled",function(){t.disable()}),this.on("highlighted",function(){t.highlight()}),this.on("unhighlighted",function(){t.unhighlight()})},t.prototype.append=function(){e.widgets.append(this.gauge,this.bodyDiv,{panel:!1})},t.prototype.addMethod=function(e,t){if("string"!=typeof e)throw new Error("MoodGauge.addMethod: name must be string: "+e);if("function"!=typeof t)throw new Error("MoodGauge.addMethod: cb must be function: "+t);if(this.methods[e])throw new Error("MoodGauge.addMethod: name already existing: "+e);this.methods[e]=t},t.prototype.getValues=function(e){return this.gauge.getValues(e)},t.prototype.setValues=function(e){return this.gauge.setValues(e)}}(node),function(e){"use strict";function t(e){function t(e){var t,n,i,s;return t="/images/"+(e.content.success?"success-icon.png":"delete-icon.png"),n=document.createElement("img"),n.src=t,"object"==typeof e.content.text&&(e.content.text=r(e.content.text)),s=document.createTextNode(e.content.text),i=document.createElement("span"),i.className="requirement",i.appendChild(n),i.appendChild(s),i}this.requirements=[],this.stillChecking=0,this.withTimeout=e.withTimeout||!0,this.timeoutTime=e.timeoutTime||1e4,this.timeoutId=null,this.summary=null,this.summaryUpdate=null,this.summaryResults=null,this.dots=null,this.hasFailed=!1,this.results=[],this.completed={},this.sayResults=e.sayResults||!1,this.sayResultsLabel=e.sayResultLabel||"requirements",this.addToResults=e.addToResults||null,this.onComplete=null,this.onSuccess=null,this.onFailure=null,this.callbacksExecuted=!1,this.list=new W.List({render:{pipeline:t,returnAt:"first"}})}function n(e,t,n){var r,i,s;i=function(n,r,i){if(e.completed[t])throw new Error("Requirements.checkRequirements: test already completed: "+t);e.completed[t]=!0,e.updateStillChecking(-1),n||(e.hasFailed=!0),"string"==typeof r&&(r=[r]);if(r){if(!J.isArray(r))throw new Error("Requirements.checkRequirements: errors must be array or undefined. Found: "+r);e.displayResults(r)}e.results.push({name:t,success:n,errors:r,data:i}),e.isCheckingFinished()&&e.checkingFinished()},r=e.requirements[n];if("function"==typeof r)s=r(i);else{if("object"!=typeof r)throw new TypeError("Requirements.checkRequirements: invalid requirement: "+t+".");s=r.cb(i,r.params||{})}s&&i(s.success,s.errors,s.data)}function r(e){var t;return e.msg?t=e.msg:e.message?t=e.message:e.description?t=t.description:t=e.toString(),t}e.widgets.register("Requirements",t),t.version="0.7.1",t.description="Checks a set of requirements and display the results",t.title="Requirements",t.className="requirements",t.texts.errStr="One or more function is taking too long. This is likely to be due to a compatibility issue with your browser or to bad network connectivity.",t.texts.testPassed="All tests passed.",t.dependencies={JSUS:{},List:{}},t.prototype.init=function(e){if("object"!=typeof e)throw new TypeError("Requirements.init: conf must be object. Found: "+e);if(e.requirements){if(!J.isArray(e.requirements))throw new TypeError("Requirements.init: conf.requirements must be array or undefined. Found: "+e.requirements);this.requirements=e.requirements}if("undefined"!=typeof e.onComplete){if(null!==e.onComplete&&"function"!=typeof e.onComplete)throw new TypeError("Requirements.init: conf.onComplete must be function, null or undefined. Found: "+e.onComplete);this.onComplete=e.onComplete}if("undefined"!=typeof e.onSuccess){if(null!==e.onSuccess&&"function"!=typeof e.onSuccess)throw new TypeError("Requirements.init: conf.onSuccess must be function, null or undefined. Found: "+e.onSuccess);this.onSuccess=e.onSuccess}if("undefined"!=typeof e.onFailure){if(null!==e.onFailure&&"function"!=typeof e.onFailure)throw new TypeError("Requirements.init: conf.onFailure must be function, null or undefined. Found: "+e.onFailure);this.onFailure=e.onFailure}if(e.maxExecTime){if(null!==e.maxExecTime&&"number"!=typeof e.maxExecTime)throw new TypeError("Requirements.init: conf.onMaxExecTime must be number, null or undefined. Found: "+e.maxExecTime);this.withTimeout=!!e.maxExecTime,this.timeoutTime=e.maxExecTime}},t.prototype.addRequirements=function(){var e,t;e=-1,t=arguments.length;for(;++e<t;){if("function"!=typeof arguments[e]&&"object"!=typeof arguments[e])throw new TypeError("Requirements.addRequirements: requirements must be function or object. Found: "+arguments[e]);this.requirements.push(arguments[e])}},t.prototype.checkRequirements=function(e){var t,i,s,o,u;if(!this.requirements.length)throw new Error("Requirements.checkRequirements: no requirements to check.");this.updateStillChecking(this.requirements.length,!0),s=[],t=-1,i=this.requirements.length;for(;++t<i;){this.requirements[t]&&this.requirements[t].name?o=this.requirements[t].name:o=t+1;try{n(this,o,t)}catch(a){this.hasFailed=!0,u=r(a),this.updateStillChecking(-1),s.push("An error occurred in requirement n."+o+": "+u)}}return this.withTimeout&&this.addTimeout(),("undefined"==typeof e?!0:!1)&&this.displayResults(s),this.isCheckingFinished()&&this.checkingFinished(),s},t.prototype.addTimeout=function(){var e=this;this.timeoutId=setTimeout(function(){e.stillChecking>0&&e.displayResults([this.getText("errStr")]),e.timeoutId=null,e.hasFailed=!0,e.checkingFinished()},this.timeoutTime)},t.prototype.clearTimeout=function(){this.timeoutId&&(clearTimeout(this.timeoutId),this.timeoutId=null)},t.prototype.updateStillChecking=function(e,t){var n,r;this.stillChecking=t?e:this.stillChecking+e,n=this.requirements.length,r=n-this.stillChecking,this.summaryUpdate.innerHTML=" ("+r+" / "+n+")"},t.prototype.isCheckingFinished=function(){return this.stillChecking<=0},t.prototype.checkingFinished=function(t){var n;if(this.callbacksExecuted&&!t)return;this.callbacksExecuted=!0,this.timeoutId&&clearTimeout(this.timeoutId),this.dots.stop(),this.sayResults&&(n={success:!this.hasFailed,results:this.results},this.addToResults&&J.mixin(n,this.addToResults()),e.say(this.sayResultsLabel,"SERVER",n)),this.onComplete&&this.onComplete(),this.hasFailed?this.onFailure&&this.onFailure():this.onSuccess&&this.onSuccess()},t.prototype.displayResults=function(e){var t,n;if(!this.list)throw new Error("Requirements.displayResults: list not found. Have you called .append() first?");if(!J.isArray(e))throw new TypeError("Requirements.displayResults: results must be array. Found: "+e);if(!this.hasFailed&&this.stillChecking<=0)this.list.addDT({success:!0,text:this.getText("testPassed")});else{t=-1,n=e.length;for(;++t<n;)this.list.addDT({success:!1,text:e[t]})}this.list.parse()},t.prototype.append=function(){this.summary=document.createElement("span"),this.summary.appendChild(document.createTextNode("Evaluating requirements")),this.summaryUpdate=document.createElement("span"),this.summary.appendChild(this.summaryUpdate),this.dots=W.getLoadingDots(),this.summary.appendChild(this.dots.span),this.summaryResults=document.createElement("div"),this.summary.appendChild(document.createElement("br")),this.summary.appendChild(this.summaryResults),this.bodyDiv.appendChild(this.summary),this.bodyDiv.appendChild(this.list.getRoot())},t.prototype.listeners=function(){var t;t=this,e.registerSetup("requirements",function(n){if(!n)return;if("object"!=typeof n){e.warn("requirements widget: invalid setup object: "+n);return}return t.init(n),n.doChecking!==!1&&t.checkRequirements(),n}),this.on("destroyed",function(){e.deregisterSetup("requirements")})}}(node),function(e){"use strict";function t(e){this.methods={},this.method="Slider",this.gauge=null,this.addMethod("Slider",r)}function n(e,t){if(!t)throw new Error("SVOGauge.init: method "+e+"did not create element gauge.");if("function"!=typeof t.getValues)throw new Error("SVOGauge.init: method "+e+": gauge missing function getValues.");if("function"!=typeof t.enable)throw new Error("SVOGauge.init: method "+e+": gauge missing function enable.");if("function"!=typeof t.disable)throw new Error("SVOGauge.init: method "+e+": gauge missing function disable.");if("function"!=typeof t.append)throw new Error("SVOGauge.init: method "+e+": gauge missing function append.")}function r(t){var n,r,i,s,o,u;r=t.sliders||[[[85,85],[85,76],[85,68],[85,59],[85,50],[85,41],[85,33],[85,24],[85,15]],[[85,15],[87,19],[89,24],[91,28],[93,33],[94,37],[96,41],[98,46],[100,50]],[[50,100],[54,98],[59,96],[63,94],[68,93],[72,91],[76,89],[81,87],[85,85]],[[50,100],[54,89],[59,79],[63,68],[68,58],[72,47],[76,36],[81,26],[85,15]],[[100,50],[94,56],[88,63],[81,69],[75,75],[69,81],[63,88],[56,94],[50,100]],[[100,50],[98,54],[96,59],[94,63],[93,68],[91,72],[89,76],[87,81],[85,85]]],this.sliders=r,u=t.renderer||function(e,t,n){e.innerHTML=t[0]+"<hr/>"+t[1]},o=r.length,n=new Array(o),s=-1;for(;++s<o;)n[s]={id:s+1,left:this.getText("left"),choices:r[s]};return i=e.widgets.get("ChoiceTableGroup",{id:"svo_slider",items:n,mainText:this.getText("mainText"),title:!1,renderer:u,requiredChoice:!0,storeRef:!1}),i}e.widgets.register("SVOGauge",t),t.version="0.6.0",t.description="Displays an interface to measure social value orientation (S.V.O.).",t.title="SVO Gauge",t.className="svogauge",t.texts.mainText="Select your preferred option among those available below:",t.texts.left="You:<hr/>Other:",t.dependencies={JSUS:{}},t.prototype.init=function(e){var t;if("undefined"!=typeof e.method){if("string"!=typeof e.method)throw new TypeError("SVOGauge.init: options.method must be string or undefined: "+e.method);if(!this.methods[e.method])throw new Error("SVOGauge.init: options.method is not a valid method: "+e.method);this.method=e.method}t=this.methods[this.method].call(this,e),n(this.method,t),this.gauge=t,this.on("enabled",function(){t.enable()}),this.on("disabled",function(){t.disable()}),this.on("highlighted",function(){t.highlight()}),this.on("unhighlighted",function(){t.unhighlight()})},t.prototype.append=function(){e.widgets.append(this.gauge,this.bodyDiv)},t.prototype.addMethod=function(e,t){if("string"!=typeof e)throw new Error("SVOGauge.addMethod: name must be string: "+e);if("function"!=typeof t)throw new Error("SVOGauge.addMethod: cb must be function: "+t);if(this.methods[e])throw new Error("SVOGauge.addMethod: name already existing: "+e);this.methods[e]=t},t.prototype.getValues=function(e){return e=e||{},"undefined"==typeof e.processChoice&&(e.processChoice=function(e){return e===null?null:this.choices[e]}),this.gauge.getValues(e)},t.prototype.setValues=function(e){return this.gauge.setValues(e)}}(node),function(e){"use strict";function t(){this.options=null,this.displayMode=null,this.stager=null,this.gamePlot=null,this.curStage=null,this.totStage=null,this.curRound=null,this.totRound=null,this.stageOffset=null,this.totStageOffset=null,this.oldStageId=null,this.separator=" / ",this.layout=null}function n(e,t){a(this,e,"COUNT_UP_STAGES",t),this.curStageNumber=null,this.totStageNumber=null,this.textDiv=null,this.init()}function r(e,t){a(this,e,"COUNT_DOWN_STAGES",t),this.stagesLeft=null,this.init()}function i(e,t){a(this,e,"COUNT_UP_ROUNDS",t),this.curRoundNumber=null,this.totRoundNumber=null,this.init()}function s(e,t){a(this,e,"COUNT_DOWN_ROUNDS",t),this.roundsLeft=null,this.init()}function o(e,t,n){this.visualRound=e,this.displayModes=t,this.name=t.join("&"),this.options=n||{},this.displayDiv=null,this.init(n)}function u(e,t,n){return t==="vertical"||t==="multimode_vertical"||t==="all_vertical"?(e.displayDiv.style.float="none",e.titleDiv.style.float="none",e.titleDiv.style["margin-right"]="0px",e.contentDiv.style.float="none",!0):t==="horizontal"?(e.displayDiv.style.float="none",e.titleDiv.style.float="left",e.titleDiv.style["margin-right"]="6px",e.contentDiv.style.float="right",!0):t==="multimode_horizontal"?(e.displayDiv.style.float="left",e.titleDiv.style.float="none",e.titleDiv.style["margin-right"]="0px",e.contentDiv.style.float="none",n||(e.displayDiv.style["margin-right"]="10px"),!0):t==="all_horizontal"?(e.displayDiv.style.float="left",e.titleDiv.style.float="left",e.titleDiv.style["margin-right"]="6px",e.contentDiv.style.float="right",n||(e.displayDiv.style["margin-right"]="10px"),!0):!1}function a(e,t,n,r){e.visualRound=t,e.name=n,r.toTotal&&(e.name+="_TO_TOTAL"),e.options=r||{},e.displayDiv=null,e.titleDiv=null,e.contentDiv=null,e.textDiv=null}function f(e,t,n){e.displayDiv=W.get("div",{className:t}),e.titleDiv=W.add("div",e.displayDiv,{className:"title",innerHTML:n}),e.contentDiv=W.add("div",e.displayDiv,{className:"content"})}e.widgets.register("VisualRound",t),t.version="0.8.0",t.description="Display number of current round and/or stage.Can also display countdown and total number of rounds and/or stages.",t.title=!1,t.className="visualround",t.texts.round="Round",t.texts.stage="Stage",t.texts.roundLeft="Round Left",t.texts.stageLeft="Stage left",t.dependencies={GamePlot:{},JSUS:{}},t.prototype.init=function(t){t=t||{},J.mixout(t,this.options),this.options=t,this.stageOffset=this.options.stageOffset||0,this.totStageOffset="undefined"==typeof this.options.totStageOffset?this.stageOffset:this.options.totStageOffset,this.options.flexibleMode&&(this.curStage=this.options.curStage||1,this.curStage-=this.options.stageOffset||0,this.curRound=this.options.curRound||1,this.totStage=this.options.totStage,this.totRound=this.options.totRound,this.oldStageId=this.options.oldStageId),this.gamePlot||(this.gamePlot=e.game.plot),this.stager||(this.stager=this.gamePlot.stager),this.updateInformation(),!this.options.displayMode&&this.options.displayModeNames&&(console.log("***VisualTimer.init: options.displayModeNames is deprecated. Use options.displayMode instead.***"),this.options.displayMode=this.options.displayModeNames),this.options.displayMode?this.setDisplayMode(this.options.displayMode):this.setDisplayMode(["COUNT_UP_ROUNDS_TO_TOTAL_IFNOT1","COUNT_UP_STAGES_TO_TOTAL"]),"undefined"!=typeof t.separator&&(this.separator=t.separator),"undefined"!=typeof t.layout&&(this.layout=t.layout),this.updateDisplay()},t.prototype.append=function(){this.activate(this.displayMode),this.updateDisplay()},t.prototype.updateDisplay=function(){this.displayMode&&this.displayMode.updateDisplay()},t.prototype.setDisplayMode=function(e){var t,u,a;if("string"==typeof e)e=[e];else if(!J.isArray(e))throw new TypeError("VisualRound.setDisplayMode: displayMode must be array or string. Found: "+e);u=e.length;if(u===0)throw new Error("VisualRound.setDisplayMode: displayMode is empty");if(this.displayMode){if(e.join("&")===this.displayMode.name)return;this.deactivate(this.displayMode)}a=[],t=-1;for(;++t<u;)switch(e[t]){case"COUNT_UP_STAGES_TO_TOTAL":a.push(new n(this,{toTotal:!0}));break;case"COUNT_UP_STAGES":a.push(new n(this));break;case"COUNT_DOWN_STAGES":a.push(new r(this));break;case"COUNT_UP_ROUNDS_TO_TOTAL":a.push(new i(this,{toTotal:!0}));break;case"COUNT_UP_ROUNDS":a.push(new i(this));break;case"COUNT_UP_ROUNDS_TO_TOTAL_IFNOT1":a.push(new i(this,{toTotal:!0,ifNotOne:!0}));break;case"COUNT_UP_ROUNDS_IFNOT1":a.push(new i(this,{ifNotOne:!0}));break;case"COUNT_DOWN_ROUNDS":a.push(new s(this));break;default:throw new Error("VisualRound.setDisplayMode: unknown mode: "+e[t])}this.displayMode=new o(this,a),this.activate(this.displayMode)},t.prototype.getDisplayModeName=function(){return this.displayMode.name},t.prototype.activate=function(e){this.bodyDiv&&this.bodyDiv.appendChild(e.displayDiv),e.activate&&e.activate()},t.prototype.deactivate=function(e){this.bodyDiv.removeChild(e.displayDiv),e.deactivate&&e.deactivate()},t.prototype.listeners=function(){var t;t=this,e.on("STEP_CALLBACK_EXECUTED",function(){t.updateInformation()})},t.prototype.updateInformation=function(){var t,n;t=e.player.stage,t.stage===0?(this.curStage=0,this.totStage=0,this.totRound=0):this.options.flexibleMode?(t.id===this.oldStageId?this.curRound+=1:t.id&&(this.curRound=1,this.curStage+=1),this.oldStageId=t.id):(this.curStage=t.stage,"string"==typeof this.curStage&&(this.curStage=this.gamePlot.normalizeGameStage(t).stage),this.curRound=t.round,this.totRound=this.stager.sequence[this.curStage-1].num||1,this.curStage-=this.stageOffset,n=this.stager.sequence.length,this.totStage=n-this.totStageOffset,this.stager.sequence[n-1].type==="gameover"&&this.totStage--),this.updateDisplay()},t.prototype.setLayout=function(e){if("string"!=typeof e||e.trim()==="")throw new TypeError("VisualRound.setLayout: layout must be a non-empty string. Found: "+e);this.layout=e,this.displayMode&&this.displayMode.setLayout(e)},n.prototype.init=function(){f(this,"stagediv",this.visualRound.getText("stage")),this.curStageNumber=W.append("span",this.contentDiv,{className:"number"}),this.options.toTotal&&(this.textDiv=W.append("span",this.contentDiv,{className:"text",innerHTML:this.visualRound.separator}),this.totStageNumber=W.append("span",this.contentDiv,{className:"number"})),this.updateDisplay()},n.prototype.updateDisplay=function(){this.curStageNumber.innerHTML=this.visualRound.curStage,this.options.toTotal&&(this.totStageNumber.innerHTML=this.visualRound.totStage||"?")},r.prototype.init=function(){f(this,"stagediv",this.visualRound.getText("stageLeft")),this.stagesLeft=W.add("div",this.contentDiv,{className:"number"}),this.updateDisplay()},r.prototype.updateDisplay=function(){var e;e=this.visualRound,e.totStage===e.curStage?this.stagesLeft.innerHTML=0:this.stagesLeft.innerHTML=e.totStage-e.curStage||"?"},i.prototype.init=function(){f(this,"rounddiv",this.visualRound.getText("round")),this.curRoundNumber=W.add("span",this.contentDiv,{className:"number"}),this.options.toTotal&&(this.textDiv=W.add("span",this.contentDiv,{className:"text",innerHTML:this.visualRound.separator}),this.totRoundNumber=W.add("span",this.contentDiv,{className:"number"})),this.updateDisplay()},i.prototype.updateDisplay=function(){this.options.ifNotOne&&this.visualRound.totRound===1?this.displayDiv.style.display="none":(this.curRoundNumber.innerHTML=this.visualRound.curRound,this.options.toTotal&&(this.totRoundNumber.innerHTML=this.visualRound.totRound||"?"),this.displayDiv.style.display="")},s.prototype.init=function(){f(this,"rounddiv",this.visualRound.getText("roundLeft")),this.roundsLeft=W.add("div",this.displayDiv),this.roundsLeft.className="number",this.updateDisplay()},s.prototype.updateDisplay=function(){var e;e=this.visualRound,e.totRound===e.curRound?this.roundsLeft.innerHTML=0:this.roundsLeft.innerHTML=e.totRound-e.curRound||"?"},o.prototype.init=function(e){var t,n;this.displayDiv=W.get("div"),t=-1,n=this.displayModes.length;for(;++t<n;)this.displayDiv.appendChild(this.displayModes[t].displayDiv);this.updateDisplay()},o.prototype.updateDisplay=function(){var e,t;e=-1,t=this.displayModes.length;for(;++e<t;)this.displayModes[e].updateDisplay()},o.prototype.activate=function(){var e,t,n,r;r=this.visualRound.layout,e=-1,t=this.displayModes.length;for(;++e<t;)n=this.displayModes[e],n.activate&&this.displayModes[e].activate(),r&&u(n,r,e===t-1)},o.prototype.deactivate=function(){var e,t,n;e=-1,t=this.displayModes.length;for(;++e<t;)n=this.displayModes[e],n.deactivate&&n.deactivate()},o.prototype.setLayout=function(e){var t,n,r;t=-1,n=this.displayModes.length;for(;++t<n;)r=this.displayModes[t],u(r,e,t===n-1)}}(node),function(e){"use strict";function n(){this.table=new t}var t=W.Table;e.widgets.register("VisualStage",n),n.version="0.2.3",n.description="Visually display current, previous and next stage of the game.",n.title="Stage",n.className="visualstage",n.dependencies={JSUS:{},Table:{}},n.prototype.append=function(){this.bodyDiv.appendChild(this.table.table),this.writeStage()},n.prototype.listeners=function(){var t=this;e.on("STEP_CALLBACK_EXECUTED",function(){t.writeStage()})},n.prototype.writeStage=function(){var t,n,r,i,s,o,u,a,f;t="-",n="Uninitialized",r=t,i=t,o=e.game.getCurrentGameStage(),o&&(s=e.game.plot.getStep(o),n=s?s.id:t,a=e.game.plot.previous(o),a&&(s=e.game.plot.getStep(a),r=s?s.id:t),u=e.game.plot.next(o),u&&(s=e.game.plot.getStep(u),i=s?s.id:t)),this.table.clear(!0),this.table.addRow(["Previous: ",r]),this.table.addRow(["Current: ",n]),this.table.addRow(["Next: ",i]),f=this.table.selexec("y","=",0),f.addClass("strong"),f.selexec("x","=",2).addClass("underline"),this.table.parse()}}(node),function(e){"use strict";function t(){this.gameTimer=null,this.mainBox=null,this.waitBox=null,this.activeBox=null,this.isInitialized=!1,this.options={},this.internalTimer=null}function n(e){this.boxDiv=null,this.titleDiv=null,this.bodyDiv=null,this.timeLeft=null,this.boxDiv=W.get("div"),this.titleDiv=W.add("div",this.boxDiv),this.bodyDiv=W.add("div",this.boxDiv),this.init(e)}e.widgets.register("VisualTimer",t),t.version="0.9.2",t.description="Display a configurable timer for the game. Can trigger events. Only for countdown smaller than 1h.",t.title="Time Left",t.className="visualtimer",t.dependencies={GameTimer:{},JSUS:{}},t.prototype.init=function(t){var r,i;t=t||{};if("object"!=typeof t)throw new TypeError("VisualTimer.init: options must be object or undefined. Found: "+t);i={};if("undefined"!=typeof t.gameTimer){if(this.gameTimer)throw new Error("GameTimer.init: options.gameTimer cannot be set if a gameTimer is already existing: "+this.name);if("object"!=typeof t.gameTimer)throw new TypeError("VisualTimer.init: options.gameTimer must be object or undefined. Found: "+t.gameTimer);this.gameTimer=t.gameTimer}else this.isInitialized||(this.internalTimer=!0,this.gameTimer=e.timer.createTimer({name:t.name||"VisualTimer"}));if(t.hooks){if(!this.internalTimer)throw new Error("VisualTimer.init: cannot add hooks on external gameTimer.");J.isArray(t.hooks)||(i.hooks=[t.hooks])}else i.hooks=[];this.isInitialized||i.hooks.push({name:"VisualTimer_"+this.wid,hook:this.updateDisplay,ctx:this}),"undefined"!=typeof t.milliseconds&&(i.milliseconds=e.timer.parseInput("milliseconds",t.milliseconds)),"undefined"!=typeof t.update?i.update=e.timer.parseInput("update",t.update):i.update=1e3,"undefined"!=typeof t.timeup&&(i.timeup=t.timeup),this.gameTimer.init(i),r=this.gameTimer,this.options=i,"undefined"==typeof this.options.stopOnDone&&(this.options.stopOnDone=!0),"undefined"==typeof this.options.startOnPlaying&&(this.options.startOnPlaying=!0),this.options.mainBoxOptions||(this.options.mainBoxOptions={}),this.options.waitBoxOptions||(this.options.waitBoxOptions={}),J.mixout(this.options.mainBoxOptions,{classNameBody:t.className,hideTitle:!0}),J.mixout(this.options.waitBoxOptions,{title:"Max. wait timer",classNameTitle:"waitTimerTitle",classNameBody:"waitTimerBody",hideBox:!0}),this.mainBox?this.mainBox.init(this.options.mainBoxOptions):this.mainBox=new n(this.options.mainBoxOptions),this.waitBox?this.waitBox.init(this.options.waitBoxOptions):this.waitBox=new n(this.options.waitBoxOptions),this.activeBox=this.options.activeBox||this.mainBox,this.isInitialized=!0},t.prototype.append=function(){this.bodyDiv.appendChild(this.mainBox.boxDiv),this.bodyDiv.appendChild(this.waitBox.boxDiv),this.activeBox=this.mainBox,this.updateDisplay()},t.prototype.clear=function(t){var n;return t=t||{},n=this.options,this.internalTimer?(e.timer.destroyTimer(this.gameTimer),this.internalTimer=null):this.gameTimer.removeHook(this.updateHookName),this.gameTimer=null,this.activeBox=null,this.isInitialized=!1,this.init(t),n},t.prototype.updateDisplay=function(){var e,t,n;if(!this.gameTimer.milliseconds||this.gameTimer.milliseconds===0){this.activeBox.bodyDiv.innerHTML="00:00";return}e=this.gameTimer.milliseconds-this.gameTimer.timePassed,e=J.parseMilliseconds(e),t=e[2]<10?"0"+e[2]:e[2],n=e[3]<10?"0"+e[3]:e[3],this.activeBox.bodyDiv.innerHTML=t+":"+n},t.prototype.start=function(){this.updateDisplay(),this.gameTimer.start()},t.prototype.restart=function(e){this.stop(),this.init(e),this.start()},t.prototype.stop=function(e){this.gameTimer.isStopped()||(this.activeBox.timeLeft=this.gameTimer.timeLeft,this.gameTimer.stop())},t.prototype.switchActiveBoxTo=function(e){this.activeBox.timeLeft=this.gameTimer.timeLeft||0,this.activeBox=e,this.updateDisplay()},t.prototype.startWaiting=function(e){"undefined"==typeof e&&(e={}),"undefined"==typeof e.milliseconds&&(e.milliseconds=this.gameTimer.timeLeft),"undefined"==typeof e.mainBoxOptions&&(e.mainBoxOptions={}),"undefined"==typeof e.waitBoxOptions&&(e.waitBoxOptions={}),e.mainBoxOptions.classNameBody="strike",e.mainBoxOptions.timeLeft=this.gameTimer.timeLeft||0,e.activeBox=this.waitBox,e.waitBoxOptions.hideBox=!1,this.restart(e)},t.prototype.startTiming=function(e){"undefined"==typeof e&&(e={}),"undefined"==typeof e.mainBoxOptions&&(e.mainBoxOptions={}),"undefined"==typeof e.waitBoxOptions&&(e.waitBoxOptions={}),e.activeBox=this.mainBox,e.waitBoxOptions.timeLeft=this.gameTimer.timeLeft||0,e.waitBoxOptions.hideBox=!0,e.mainBoxOptions.classNameBody="",this.restart(e)},t.prototype.resume=function(){this.gameTimer.resume()},t.prototype.setToZero=function(){this.stop(),this.activeBox.bodyDiv.innerHTML="00:00",this.activeBox.setClassNameBody("strike")},t.prototype.isTimeup=function(){return this.gameTimer.isTimeup()},t.prototype.doTimeUp=function(){this.gameTimer.doTimeUp()},t.prototype.listeners=function(){var t=this;if(!this.internalTimer)return;e.on("PLAYING",function(){var e;t.options.startOnPlaying&&(e=t.gameTimer.getStepOptions(),e?(e.update=t.update,e.timeup=undefined,t.startTiming(e)):t.gameTimer.isRunning()||t.setToZero())}),e.on("REALLY_DONE",function(){t.options.stopOnDone&&(t.gameTimer.isStopped()||t.stop())}),this.on("destroyed",function(){t.internalTimer?(e.timer.destroyTimer(t.gameTimer),t.internalTimer=null):t.gameTimer.removeHook("VisualTimer_"+t.wid),t.bodyDiv.removeChild(t.mainBox.boxDiv),t.bodyDiv.removeChild(t.waitBox.boxDiv)})},n.prototype.init=function(e){e&&(e.hideTitle?this.hideTitle():this.unhideTitle(),e.hideBody?this.hideBody():this.unhideBody(),e.hideBox?this.hideBox():this.unhideBox()),this.setTitle(e.title||""),this.setClassNameTitle(e.classNameTitle||""),this.setClassNameBody(e.classNameBody||""),e.timeLeft&&(this.timeLeft=e.timeLeft)},n.prototype.hideBox=function(){this.boxDiv.style.display="none"},n.prototype.unhideBox=function(){this.boxDiv.style.display=""},n.prototype.hideTitle=function(){this.titleDiv.style.display="none"},n.prototype.unhideTitle=function(){this.titleDiv.style.display=""},n.prototype.hideBody=function(){this.bodyDiv.style.display="none"},n.prototype.unhideBody=function(){this.bodyDiv.style.display=""},n.prototype.setTitle=function(e){this.titleDiv.innerHTML=e},n.prototype.setClassNameTitle=function(e){this.titleDiv.className=e},n.prototype.setClassNameBody=function(e){this.bodyDiv.className=e}}(node),function(e){"use strict";function t(e){this.connected=0,this.poolSize=0,this.nGames=undefined,this.groupSize=0,this.waitTime=null,this.executionMode=null,this.startDate=null,this.timeoutId=null,this.execModeDiv=null,this.playerCount=null,this.startDateDiv=null,this.msgDiv=null,this.timerDiv=null,this.timer=null,this.dots=null,this.onTimeout=null,this.disconnectIfNotSelected=null,this.playWithBotOption=null,this.playBotBtn=null,this.selectTreatmentOption=null,this.selectedTreatment=null}e.widgets.register("WaitingRoom",t),t.version="1.3.0",t.description="Displays a waiting room for clients.",t.title="Waiting Room",t.className="waitingroom",t.dependencies={JSUS:{},VisualTimer:{}},t.sounds={dispatch:"/sounds/doorbell.ogg"},t.texts={blinkTitle:"GAME STARTS!",waitingForConf:"Waiting to receive data",executionMode:function(e){var t;return e.executionMode==="WAIT_FOR_N_PLAYERS"?"Waiting for All Players to Connect: ":e.executionMode==="WAIT_FOR_DISPATCH"?"Task will start soon. Please be patient.":"Task will start at: <br>"+e.startDate},disconnect:'<span style="color: red">You have been <strong>disconnected</strong>. Please try again later.</span><br><br>',waitedTooLong:"Waiting for too long. Please look for a HIT called <strong>Trouble Ticket</strong> and file a new trouble ticket reporting your experience.",notEnoughPlayers:'<h3 align="center" style="color: red">Thank you for your patience.<br>Unfortunately, there are not enough participants in your group to start the experiment.<br>',roomClosed:'<span style="color: red"> The waiting room is <strong>CLOSED</strong>. You have been disconnected. Please try again later.</span><br><br>',tooManyPlayers:function(e,t){var n;return n="There are more players in this waiting room than playslots in the game. ",e.poolSize===1?n+="Each player will play individually.":n+="Only "+t.nGames+" players will be selected "+"to play the game.",n},notSelectedClosed:'<h3 align="center"><span style="color: red">Unfortunately, you were <strong>not selected</strong> to join the game this time. Thank you for your participation.</span></h3><br><br>',notSelectedOpen:'<h3 align="center"><span style="color: red">Unfortunately, you were <strong>not selected</strong> to join the game this time, but you may join the next one.</span><a class="hand" onclick=javascript:this.parentElement.innerHTML="">Ok, I got it.</a></h3><br><br>Thank you for your participation.</span></h3><br><br>',exitCode:function(e,t){return"<br>You have been disconnected. "+("undefined"!=typeof t.exit?"Please report this exit code: "+t.exit:"")+"<br></h3>"},playBot:function(e){return e.poolSize===e.groupSize&&e.groupSize===1?"Play":e.groupSize===2?"Play With Bot":"Play With Bots"},connectingBots:function(e){return console.log(e.poolSize,e.groupSize),e.poolSize===e.groupSize&&e.groupSize===1?"Starting, Please Wait...":e.groupSize===2?"Connecting Bot, Please Wait...":"Connecting Bot/s, Please Wait..."},selectTreatment:"Select Treatment ",gameTreatments:"Game:",defaultTreatments:"Defaults:"},t.prototype.init=function(t){var n=this;if("object"!=typeof t)throw new TypeError("WaitingRoom.init: conf must be object. Found: "+t);if(!t.executionMode)return;this.executionMode=t.executionMode;if(t.onTimeout){if("function"!=typeof t.onTimeout)throw new TypeError("WaitingRoom.init: conf.onTimeout must be function, null or undefined. Found: "+t.onTimeout);this.onTimeout=t.onTimeout}if(t.waitTime){if(null!==t.waitTime&&"number"!=typeof t.waitTime)throw new TypeError("WaitingRoom.init: conf.waitTime must be number, null or undefined. Found: "+t.waitTime);this.waitTime=t.waitTime}t.startDate&&(this.startDate=(new Date(t.startDate)).toString());if(t.poolSize){if(t.poolSize&&"number"!=typeof t.poolSize)throw new TypeError("WaitingRoom.init: conf.poolSize must be number or undefined. Found: "+t.poolSize);this.poolSize=t.poolSize}if(t.groupSize){if(t.groupSize&&"number"!=typeof t.groupSize)throw new TypeError("WaitingRoom.init: conf.groupSize must be number or undefined. Found: "+t.groupSize);this.groupSize=t.groupSize}if(t.nGames){if(t.nGames&&"number"!=typeof t.nGames)throw new TypeError("WaitingRoom.init: conf.nGames must be number or undefined. Found: "+t.nGames);this.nGames=t.nGames}if(t.connected){if(t.connected&&"number"!=typeof t.connected)throw new TypeError("WaitingRoom.init: conf.connected must be number or undefined. Found: "+t.connected);this.connected=t.connected}if(t.disconnectIfNotSelected){if("boolean"!=typeof t.disconnectIfNotSelected)throw new TypeError("WaitingRoom.init: conf.disconnectIfNotSelected must be boolean or undefined. Found: "+t.disconnectIfNotSelected);this.disconnectIfNotSelected=t.disconnectIfNotSelected}else this.disconnectIfNotSelected=!1;t.playWithBotOption?this.playWithBotOption=!0:this.playWithBotOption=!1,t.selectTreatmentOption?this.selectTreatmentOption=!0:this.selectTreatmentOption=!1,this.displayExecMode(),this.playWithBotOption&&!document.getElementById("bot_btn")&&function(n){var r=document.createElement("div");r.role="group",r["aria-label"]="Play Buttons",r.className="btn-group";var i=document.createElement("input");i.className="btn btn-primary btn-lg",i.value=n.getText("playBot"),i.id="bot_btn",i.type="button",i.onclick=function(){n.playBotBtn.value=n.getText("connectingBots"),n.playBotBtn.disabled=!0,e.say("PLAYWITHBOT","SERVER",n.selectedTreatment),setTimeout(function(){n.playBotBtn.value=n.getText("playBot"),n.playBotBtn.disabled=!1},5e3)},r.appendChild(i),n.playBotBtn=i;if(n.selectTreatmentOption){var s=document.createElement("div");s.role="group",s["aria-label"]="Select Treatment",s.className="btn-group";var o=document.createElement("button");o.className="btn btn-default btn-lg dropdown-toggle",o["data-toggle"]="dropdown",o["aria-haspopup"]="true",o["aria-expanded"]="false",o.innerHTML=n.getText("selectTreatment");var u=document.createElement("span");u.className="caret",o.appendChild(u);var a=document.createElement("ul");a.className="dropdown-menu",a.style["text-align"]="left";var f,l,c,h,p;if(t.availableTreatments){f=document.createElement("li"),f.innerHTML=n.getText("gameTreatments"),f.className="dropdown-header",a.appendChild(f);for(c in t.availableTreatments)t.availableTreatments.hasOwnProperty(c)&&(f=document.createElement("li"),f.id=c,l=document.createElement("a"),l.href="#",l.innerHTML="<strong>"+c+"</strong>: "+t.availableTreatments[c],f.appendChild(l),c==="treatment_rotate"?h=f:c==="treatment_random"?p=f:a.appendChild(f));f=document.createElement("li"),f.role="separator",f.className="divider",a.appendChild(f),f=document.createElement("li"),f.innerHTML=n.getText("defaultTreatments"),f.className="dropdown-header",a.appendChild(f),a.appendChild(h),a.appendChild(p)}s.appendChild(o),s.appendChild(a),r.appendChild(s),o.onclick=function(){a.style.display===""?a.style.display="block":a.style.display=""},a.onclick=function(e){var t;t=e.target,a.style.display="",t=t.parentNode.id,t||(t=e.target.parentNode.parentNode.id);if(!t)return;o.innerHTML=t+" ",o.appendChild(u),n.selectedTreatment=t},n.treatmentBtn=o}n.bodyDiv.appendChild(document.createElement("br")),n.bodyDiv.appendChild(r)}(this),this.on("destroyed",function(){n.dots&&n.dots.stop(),e.deregisterSetup("waitroom")})},t.prototype.startTimer=function(){var t=this;if(this.timer)return;if(!this.waitTime)return;this.timerDiv||(this.timerDiv=document.createElement("div"),this.timerDiv.id="timer-div"),this.timerDiv.appendChild(document.createTextNode("Maximum Waiting Time: ")),this.timer=e.widgets.append("VisualTimer",this.timerDiv,{milliseconds:this.waitTime,timeup:function(){t.bodyDiv.innerHTML=t.getText("waitedTooLong")},update:1e3}),this.timer.setTitle(),this.timer.panelDiv.className="ng_widget visualtimer",this.bodyDiv.appendChild(this.timerDiv),this.timer.start()},t.prototype.clearTimeout=function(){this.timeoutId&&(clearTimeout(this.timeoutId),this.timeoutId=null)},t.prototype.updateState=function(e){if(!e)return;"number"==typeof e.connected&&(this.connected=e.connected),"number"==typeof e.poolSize&&(this.poolSize=e.poolSize),"number"==typeof e.groupSize&&(this.groupSize=e.groupSize)},t.prototype.updateDisplay=function(){var e,t;this.connected>this.poolSize?(t=Math.floor(this.connected/this.groupSize),"undefined"!=typeof this.nGames&&(t=t>this.nGames?this.nGames:t),e=t*this.groupSize,this.playerCount.innerHTML='<span style="color:red">'+this.connected+"</span>"+" / "+this.poolSize,this.playerCountTooHigh.style.display="",this.playerCountTooHigh.innerHTML=this.getText("tooManyPlayers",{nGames:e})):(this.playerCount.innerHTML=this.connected+" / "+this.poolSize,this.playerCountTooHigh.style.display="none")},t.prototype.displayExecMode=function(){this.bodyDiv.innerHTML="",this.execModeDiv=document.createElement("div"),this.execModeDiv.id="exec-mode-div",this.execModeDiv.innerHTML=this.getText("executionMode"),this.playerCount=document.createElement("p"),this.playerCount.id="player-count",this.execModeDiv.appendChild(this.playerCount),this.playerCountTooHigh=document.createElement("div"),this.playerCountTooHigh.style.display="none",this.execModeDiv.appendChild(this.playerCountTooHigh),this.startDateDiv=document.createElement("div"),this.startDateDiv.style.display="none",this.execModeDiv.appendChild(this.startDateDiv),this.dots=W.getLoadingDots(),this.execModeDiv.appendChild(this.dots.span),this.bodyDiv.appendChild(this.execModeDiv),this.msgDiv=document.createElement("div"),this.bodyDiv.appendChild(this.msgDiv),this.waitTime&&this.startTimer()},t.prototype.append=function(){this.bodyDiv.innerHTML=this.getText("waitingForConf")},t.prototype.listeners=function(){var t;t=this,e.registerSetup("waitroom",function(n){if(!n)return;if("object"!=typeof n){e.warn("waiting room widget: invalid setup object: "+n);return}return n.executionMode?t.init(n):(t.setSounds(n.sounds),t.setTexts(n.texts)),n}),e.on.data("PLAYERSCONNECTED",function(e){if(!e.data)return;t.connected=e.data,t.updateDisplay()}),e.on.data("DISPATCH",function(e){var n,r;e=e||{},n=e.data||{},t.dots&&t.dots.stop(),n.action==="allPlayersConnected"?t.alertPlayer():(r=t.getText("exitCode",n),n.action==="notEnoughPlayers"?(t.bodyDiv.innerHTML=t.getText(n.action),t.onTimeout&&t.onTimeout(e.data),t.disconnect(t.bodyDiv.innerHTML+r)):n.action==="notSelected"?!1===n.shouldDispatchMoreGames||t.disconnectIfNotSelected?(t.bodyDiv.innerHTML=t.getText("notSelectedClosed"),t.disconnect(t.bodyDiv.innerHTML+r)):t.msgDiv.innerHTML=t.getText("notSelectedOpen"):n.action==="disconnect"&&t.disconnect(t.bodyDiv.innerHTML+r))}),e.on.data("TIME",function(n){n=n||{},e.info("waiting room: TIME IS UP!"),t.stopTimer()}),e.on.data("WAITTIME",function(e){t.updateState(e.data),t.updateDisplay()}),e.on("SOCKET_DISCONNECT",function(){t.stopTimer(),t.bodyDiv.innerHTML=t.getText("disconnect")}),e.on.data("ROOM_CLOSED",function(){t.disconnect(t.getText("roomClosed"))})},t.prototype.stopTimer=function(){this.timer&&(e.info("waiting room: STOPPING TIMER"),this.timer.destroy())},t.prototype.disconnect=function(t){t&&this.setText("disconnect",t),e.socket.disconnect(),this.stopTimer()},t.prototype.alertPlayer=function(){var t,n,r,i;r=this.getText("blinkTitle"),i=this.getSound("dispatch"),i&&J.playSound(i);if(!r)return;document.hasFocus&&document.hasFocus()?J.blinkTitle(r,{repeatFor:1}):(t=J.blinkTitle(r,{stopOnFocus:!0,stopOnClick:window}),n=function(){var e;t(),e=W.getFrame(),e&&e.removeEventListener("mouseover",n,!1)},e.events.ng.once("FRAME_GENERATED",function(e){e.addEventListener("mouseover",n,!1)}))}}(node)